#include "incl.h"

int CIPL_ExtractfromPPM(THEADER *, THEADER *, int);
int CIPL_InsertintoPPM(THEADER *, THEADER *, int);

int CIPL_ExtractfromPPM(THEADER *it, THEADER *ot, int colour)
{
     int i, j, max;
     if(ot->img.TYPE == PPM || ot->img.TYPE == HSV || ot->img.TYPE == YIQ || ot->img.TYPE == XYZ){
     	for(i=0;i<ot->P.psize;i++) {
       		free(ot->jarr[i]);
       		free(ot->karr[i]);
     	}
     	free(ot->jarr);
     	free(ot->karr);
     }
     
     ot->img.TYPE = PGM;
     HIPL_Refresh(ot, 1);

     do {
	  if ((max = HIPL_Getpart(it)) < 0) {
	       HIPL_Error("Error in Getpart - incomplete read");
	       return(max);
	  }

	  for (i=0; i<max; i++) {
	       for (j=0; j<it->img.COLS; j++) {
		    if (colour == RED)
			 ot->iarr[i][j] = it->iarr[i][j];
		    if (colour == GREEN)
			 ot->iarr[i][j] = it->jarr[i][j];
		    if (colour == BLUE)
			 ot->iarr[i][j] = it->karr[i][j];
	       }
	  }

	  if ((max = HIPL_Putpart(ot)) < 0) {
	       HIPL_Error("Error in Putpart - incomplete write");
	       return(max);
	  }

	  if (ot->P.nleft == 0)
	       max = -1;
     } while (max >= 0);

     HIPL_Refresh(it, 0);
     HIPL_Refresh(ot, 0);
     
     return(0);
}

int CIPL_InsertintoPPM(THEADER *it, THEADER *ot, int colour)
{
     int i, j, max;
     
     do {
	  if ((max = HIPL_Getpart(it)) < 0) {
	       HIPL_Error("Error in Getpart - incomplete read");
	       return(max);
	  }
	  for (i=0; i<max; i++) {
	       for (j=0; j<it->img.COLS; j++) {
		    if (colour == RED)
			 ot->iarr[i][j] = it->iarr[i][j];
		    if (colour == GREEN)
			 ot->jarr[i][j] = it->iarr[i][j];
		    if (colour == BLUE)
			 ot->karr[i][j] = it->iarr[i][j];
	       }
	  }

	  if ((max = HIPL_Putpart(ot)) < 0) {
	       HIPL_Error("Error in Putpart - incomplete write");
	       return(max);
	  }

	  if (it->P.nleft == 0)
	       max = -1;
     } while (max >= 0);

     HIPL_Refresh(it, 0);
     HIPL_Refresh(ot, 0);

     return(0);
}

			 
