#include "incl.h"
#define MAX(A, B)	(((A) > (B)) ? (A) : (B))

extern int  HIPL_Getpart(THEADER *T);
extern int HIPL_Putpart(THEADER *T);
extern void HIPL_Error(char *msg);
extern int HIPL_Refresh(THEADER *T,int flag);
extern int HIPL_Initialise(THEADER *,char *,short,short,DATA *);
extern int HIPL_AllocateMem(THEADER *);
extern int HIPL_Closeall(THEADER *);
extern int HIPL_FreeMem(THEADER *);
int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color);

int CIPL_SobelMove(THEADER *it,THEADER *ot,int max,int flags);
extern int CIPL_PrewittsEdge(THEADER *it,THEADER *ot,int levels);
extern int CIPL_RobertsEdge(THEADER *it,THEADER *ot, int levels);
extern int CIPL_KirschEdge(THEADER *it,THEADER *ot,int levels);


int CIPL_Sobel(THEADER *it,THEADER *ot,int flags);
int CIPL_Prewitts(THEADER *it,THEADER *ot,int flags);
int CIPL_Roberts(THEADER *it,THEADER *ot,int flags);
int CIPL_Kirsch(THEADER *it,THEADER *ot,int flags);


int CIPL_Sobel(THEADER *it,THEADER *ot,int flags)
{	
	THEADER *temp,*temp1;
	DATA *ID;
	int i,j,max,r,g,b;
		
	temp=(THEADER *)malloc(sizeof(THEADER));
	temp1=(THEADER *)malloc(sizeof(THEADER));
	
  	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->type=it->img.TYPE;
	ID->ver=it->ver;
		 	
     	HIPL_Initialise(temp,NULL,1,0,ID);
	HIPL_AllocateMem(temp);
	HIPL_Initialise(temp1,NULL,1,0,ID);
	HIPL_AllocateMem(temp1);
			  	 	
  	if(it->P.psize<it->MROWS)
	{
		HIPL_ERRNO=-17;
		HIPL_Error("Mask operation");
		return(-1);
	}
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}

		CIPL_SobelMove(it,temp,i,flags);
		i=HIPL_Putpart(temp);
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(temp->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(temp,0);
	temp->MROWS=1;
	temp->MCOLS=0;

	if(temp->img.TYPE == HSV && flags != 1)
	{	CIPL_Scale(temp,temp1,255.0/3600.0,2);
		HIPL_Refresh(temp,0);
		CIPL_Scale(temp1,temp,255.0/1000.0,4);
	}
	
	ot->img.TYPE = PGM;
	if(ot->jarr!=NULL && ot->karr != NULL){
		for(i=0;i<ot->P.psize;i++) {
			free(ot->jarr[i]);
			free(ot->karr[i]);
		}
		free(ot->jarr);
		free(ot->karr);
	}
	
	do {
		max = HIPL_Getpart(temp);
		
		if (max < 0) {
			HIPL_Error("Error in Getpart - incomplete read");
			return(max);
		}

		for (i=0; i<max; i++) {
			for (j=0; j<it->img.COLS; j++) {
				r=g=b=0;
				if((flags & 1) == 1)
					r=temp->iarr[i][j];
				if((flags & 2) == 2)
					g=temp->jarr[i][j];
				if((flags & 4) == 4)
					b=temp->karr[i][j];
				ot->iarr[i][j] = MAX(r,MAX(g,b));
			}
		}

		max = HIPL_Putpart(ot);
		if (max < 0) {
			HIPL_Error("Error in Putpart - incomplete write");
			return(max);
		}

		if (ot->P.nleft == 0)
			max = -1;
	} while (max >= 0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	i=HIPL_FreeMem(temp);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(temp1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(temp);
	free(temp1);
  	return(0);
}

int CIPL_SobelMove(THEADER *it,THEADER *ot,int max,int flags)
{
	int i,j,k,l,m,n,**temp1,max1,levels;
	long int sum11,sum12,sum21,sum22,sum31,sum32;
	double tem,t;
	int Mask1[3][3] = { {-1,-2,-1},
			    { 0, 0, 0},
			    { 1, 2 ,1}};

	int Mask2[3][3] = { {-1, 0, 1},
			    {-2, 0, 2},
			    {-1, 0 ,1}};
			    
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}

	for(i=0;i<max;i++)
	{
		for(j=0;j<it->img.COLS;j++)
		{
			
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0)
				{
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			else
			{
				sum11=sum12=sum21=sum22=sum31=sum32=0;
						
				m=-it->MORGX;
				n=-it->MORGY;
				if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
				{	m=-it->MORGX;
					n=-it->MORGY;
					max1=-1;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(max1<it->jarr[i+n][j+m])
								max1 = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					m=-it->MORGX;
					n=-it->MORGY;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(it->jarr[i+n][j+m]<(max1 - 1800))
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
							else
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
				}
				
				m=-it->MORGX;
				n=-it->MORGY;
				for(k=0;k<it->MROWS;k++)
				{
					for(l=0;l<it->MCOLS;l++)
					{
						if(it->arrtype==0)
						{	if((flags & 1) ==1)
							{
								sum11=sum11+(Mask1[k][l]*it->iarr[i+n][j+m]);
								sum12=sum12+(Mask2[k][l]*it->iarr[i+n][j+m]);
							}
							if((flags & 2) == 2)
							{	if(it->img.TYPE == HSV)
								{	sum21=sum21+(Mask1[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
									sum22=sum22+(Mask2[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
								}
								else
								{	sum21=sum21+(Mask1[k][l]*it->jarr[i+n][j+m]);
									sum22=sum22+(Mask2[k][l]*it->jarr[i+n][j+m]);
								}
							}
							if((flags & 4) == 4)
							{	sum31=sum31+(Mask1[k][l]*it->karr[i+n][j+m]);
								sum32=sum32+(Mask2[k][l]*it->karr[i+n][j+m]);
							}
						}
						m++;
					}
					m=-it->MORGY;
					n++;
				}
				
				if((flags & 1) == 1)
				{	levels=256;
					tem = sqrt((double)(sum11*sum11)+(double)(sum12*sum12));
					t=abs(tem);
					ot->iarr[i][j]=(int)t;
					if(ot->iarr[i][j]>levels)
						ot->iarr[i][j]=levels;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	if(it->img.TYPE == HSV)
						levels=3600;
					else
						levels=255;
					tem = sqrt((double)(sum21*sum21)+(double)(sum22*sum22));
					t=abs(tem);
					ot->jarr[i][j]=(int)t;
					if(ot->jarr[i][j]>levels)
					{	if(it->img.TYPE == HSV)
							ot->jarr[i][j]=ot->jarr[i][j]-levels;
						else
							ot->jarr[i][j]=levels;
					}
					if(ot->jarr[i][j]<0)
						ot->jarr[i][j]=0;
				}
				if((flags & 4) == 4)
				{	if(it->img.TYPE == HSV)
						levels=999;
					else
						levels=255;
					tem = sqrt((double)(sum31*sum31)+(double)(sum32*sum32));
					t=abs(tem);
					ot->karr[i][j]=(int)t;
					if(ot->karr[i][j]>levels)
						ot->karr[i][j]=levels;
					if(ot->karr[i][j]<0)
						ot->karr[i][j]=0;
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				
				if((flags & 2) == 0)	
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
					
			}
		}
	}
	return(0);
}

int CIPL_Prewitts(THEADER *it,THEADER *ot,int flags)
{	
	THEADER *temp,*temp1;
	DATA *ID;
	int i,j,max,r,g,b;
		
	temp=(THEADER *)malloc(sizeof(THEADER));
	temp1=(THEADER *)malloc(sizeof(THEADER));
	
  	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->type=it->img.TYPE;
	ID->ver=it->ver;
		 	
     	HIPL_Initialise(temp,NULL,1,0,ID);
	HIPL_AllocateMem(temp);
	HIPL_Initialise(temp1,NULL,1,0,ID);
	HIPL_AllocateMem(temp1);
			  	 	
  	if(it->P.psize<it->MROWS)
	{
		HIPL_ERRNO=-17;
		HIPL_Error("Mask operation");
		return(-1);
	}
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}

		CIPL_PrewittsMove(it,temp,i,flags);
		i=HIPL_Putpart(temp);
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(temp->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(temp,0);
	temp->MROWS=1;
	temp->MCOLS=0;

	if(temp->img.TYPE == HSV && flags != 1)
	{	CIPL_Scale(temp,temp1,255.0/3600.0,2);
		HIPL_Refresh(temp,0);
		CIPL_Scale(temp1,temp,255.0/1000.0,4);
	}
	
	ot->img.TYPE = PGM;
	if(ot->jarr!=NULL && ot->karr != NULL){
		for(i=0;i<ot->P.psize;i++) {
			free(ot->jarr[i]);
			free(ot->karr[i]);
		}
		free(ot->jarr);
		free(ot->karr);
	}
	
	do {
		max = HIPL_Getpart(temp);
		
		if (max < 0) {
			HIPL_Error("Error in Getpart - incomplete read");
			return(max);
		}

		for (i=0; i<max; i++) {
			for (j=0; j<it->img.COLS; j++) {
				r=g=b=0;
				if((flags & 1) == 1)
					r=temp->iarr[i][j];
				if((flags & 2) == 2)
					g=temp->jarr[i][j];
				if((flags & 4) == 4)
					b=temp->karr[i][j];
				ot->iarr[i][j] = MAX(r,MAX(g,b));
			}
		}

		max = HIPL_Putpart(ot);
		if (max < 0) {
			HIPL_Error("Error in Putpart - incomplete write");
			return(max);
		}

		if (ot->P.nleft == 0)
			max = -1;
	} while (max >= 0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	i=HIPL_FreeMem(temp);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(temp1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(temp);
	free(temp1);
  	return(0);
}
int CIPL_PrewittsMove(THEADER *it,THEADER *ot,int max,int flags)
{
	int i,j,k,l,m,n,**temp1,max1,levels;
	long int sum11,sum12,sum21,sum22,sum31,sum32;
	double tem,t;
	int Mask1[3][3] = { {-1,-1,-1},
			    { 0, 0, 0},
			    { 1, 1 ,1}};

	int Mask2[3][3] = { {-1, 0, 1},
			    {-1, 0, 1},
			    {-1, 0 ,1}};

			    
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}

	for(i=0;i<max;i++)
	{
		for(j=0;j<it->img.COLS;j++)
		{
			
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0)
				{
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			else
			{
				sum11=sum12=sum21=sum22=sum31=sum32=0;
						
				m=-it->MORGX;
				n=-it->MORGY;
				if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
				{	m=-it->MORGX;
					n=-it->MORGY;
					max1=-1;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(max1<it->jarr[i+n][j+m])
								max1 = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					m=-it->MORGX;
					n=-it->MORGY;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(it->jarr[i+n][j+m]<(max1 - 1800))
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
							else
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
				}
				
				m=-it->MORGX;
				n=-it->MORGY;
				for(k=0;k<it->MROWS;k++)
				{
					for(l=0;l<it->MCOLS;l++)
					{
						if(it->arrtype==0)
						{	if((flags & 1) ==1)
							{
								sum11=sum11+(Mask1[k][l]*it->iarr[i+n][j+m]);
								sum12=sum12+(Mask2[k][l]*it->iarr[i+n][j+m]);
							}
							if((flags & 2) == 2)
							{	if(it->img.TYPE == HSV)
								{	sum21=sum21+(Mask1[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
									sum22=sum22+(Mask2[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
								}
								else
								{	sum21=sum21+(Mask1[k][l]*it->jarr[i+n][j+m]);
									sum22=sum22+(Mask2[k][l]*it->jarr[i+n][j+m]);
								}
							}
							if((flags & 4) == 4)
							{	sum31=sum31+(Mask1[k][l]*it->karr[i+n][j+m]);
								sum32=sum32+(Mask2[k][l]*it->karr[i+n][j+m]);
							}
						}
						m++;
					}
					m=-it->MORGY;
					n++;
				}
				
				if((flags & 1) == 1)
				{	levels=256;
					tem = sqrt((double)(sum11*sum11)+(double)(sum12*sum12));
					t=abs(tem);
					ot->iarr[i][j]=(int)t;
					if(ot->iarr[i][j]>levels)
						ot->iarr[i][j]=levels;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	if(it->img.TYPE == HSV)
						levels=3600;
					else
						levels=255;
					tem = sqrt((double)(sum21*sum21)+(double)(sum22*sum22));
					t=abs(tem);
					ot->jarr[i][j]=(int)t;
					if(ot->jarr[i][j]>levels)
					{	if(it->img.TYPE == HSV)
							ot->jarr[i][j]=ot->jarr[i][j]-levels;
						else
							ot->jarr[i][j]=levels;
					}
					if(ot->jarr[i][j]<0)
						ot->jarr[i][j]=0;
				}
				if((flags & 4) == 4)
				{	if(it->img.TYPE == HSV)
						levels=999;
					else
						levels=255;
					tem = sqrt((double)(sum31*sum31)+(double)(sum32*sum32));
					t=abs(tem);
					ot->karr[i][j]=(int)t;
					if(ot->karr[i][j]>levels)
						ot->karr[i][j]=levels;
					if(ot->karr[i][j]<0)
						ot->karr[i][j]=0;
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				
				if((flags & 2) == 0)	
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
					
			}
		}
	}
	return(0);
}




int CIPL_Roberts(THEADER *it,THEADER *ot,int flags)
{	
	THEADER *temp,*temp1;
	DATA *ID;
	int i,j,max,r,g,b;
		
	temp=(THEADER *)malloc(sizeof(THEADER));
	temp1=(THEADER *)malloc(sizeof(THEADER));
	
  	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->type=it->img.TYPE;
	ID->ver=it->ver;
		 	
     	HIPL_Initialise(temp,NULL,1,0,ID);
	HIPL_AllocateMem(temp);
	HIPL_Initialise(temp1,NULL,1,0,ID);
	HIPL_AllocateMem(temp1);
			  	 	
  	if(it->P.psize<it->MROWS)
	{
		HIPL_ERRNO=-17;
		HIPL_Error("Mask operation");
		return(-1);
	}
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}

		CIPL_RobertsMove(it,temp,i,flags);
		i=HIPL_Putpart(temp);
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(temp->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(temp,0);
	temp->MROWS=1;
	temp->MCOLS=0;

	if(temp->img.TYPE == HSV && flags != 1)
	{	CIPL_Scale(temp,temp1,255.0/3600.0,2);
		HIPL_Refresh(temp,0);
		CIPL_Scale(temp1,temp,255.0/1000.0,4);
	}
	
	ot->img.TYPE = PGM;
	if(ot->jarr!=NULL && ot->karr != NULL){
		for(i=0;i<ot->P.psize;i++) {
			free(ot->jarr[i]);
			free(ot->karr[i]);
		}
		free(ot->jarr);
		free(ot->karr);
	}
	
	do {
		max = HIPL_Getpart(temp);
		
		if (max < 0) {
			HIPL_Error("Error in Getpart - incomplete read");
			return(max);
		}

		for (i=0; i<max; i++) {
			for (j=0; j<it->img.COLS; j++) {
				r=g=b=0;
				if((flags & 1) == 1)
					r=temp->iarr[i][j];
				if((flags & 2) == 2)
					g=temp->jarr[i][j];
				if((flags & 4) == 4)
					b=temp->karr[i][j];
				ot->iarr[i][j] = MAX(r,MAX(g,b));
			}
		}

		max = HIPL_Putpart(ot);
		if (max < 0) {
			HIPL_Error("Error in Putpart - incomplete write");
			return(max);
		}

		if (ot->P.nleft == 0)
			max = -1;
	} while (max >= 0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	i=HIPL_FreeMem(temp);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(temp1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(temp);
	free(temp1);
  	return(0);
}
int CIPL_RobertsMove(THEADER *it,THEADER *ot,int max,int flags)
{
	int i,j,k,l,m,n,**temp1,max1,levels;
	long int sum11,sum12,sum21,sum22,sum31,sum32;
	double tem,t;
	int Mask1[2][2] = {{1,0},{0,-1}};

	int Mask2[2][2] = {{0,1},{-1,0}};

			    
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}

	for(i=0;i<max;i++)
	{
		for(j=0;j<it->img.COLS;j++)
		{
			
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0)
				{
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			else
			{
				sum11=sum12=sum21=sum22=sum31=sum32=0;
						
				m=-it->MORGX;
				n=-it->MORGY;
				if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
				{	m=-it->MORGX;
					n=-it->MORGY;
					max1=-1;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(max1<it->jarr[i+n][j+m])
								max1 = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					m=-it->MORGX;
					n=-it->MORGY;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(it->jarr[i+n][j+m]<(max1 - 1800))
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
							else
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
				}
				
				m=-it->MORGX;
				n=-it->MORGY;
				for(k=0;k<it->MROWS;k++)
				{
					for(l=0;l<it->MCOLS;l++)
					{
						if(it->arrtype==0)
						{	if((flags & 1) ==1)
							{
								sum11=sum11+(Mask1[k][l]*it->iarr[i+n][j+m]);
								sum12=sum12+(Mask2[k][l]*it->iarr[i+n][j+m]);
							}
							if((flags & 2) == 2)
							{	if(it->img.TYPE == HSV)
								{	sum21=sum21+(Mask1[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
									sum22=sum22+(Mask2[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
								}
								else
								{	sum21=sum21+(Mask1[k][l]*it->jarr[i+n][j+m]);
									sum22=sum22+(Mask2[k][l]*it->jarr[i+n][j+m]);
								}
							}
							if((flags & 4) == 4)
							{	sum31=sum31+(Mask1[k][l]*it->karr[i+n][j+m]);
								sum32=sum32+(Mask2[k][l]*it->karr[i+n][j+m]);
							}
						}
						m++;
					}
					m=-it->MORGY;
					n++;
				}
				
				if((flags & 1) == 1)
				{	levels=256;
					tem = sqrt((double)(sum11*sum11)+(double)(sum12*sum12));
					t=abs(tem);
					ot->iarr[i][j]=(int)t;
					if(ot->iarr[i][j]>levels)
						ot->iarr[i][j]=levels;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	if(it->img.TYPE == HSV)
						levels=3600;
					else
						levels=255;
					tem = sqrt((double)(sum21*sum21)+(double)(sum22*sum22));
					t=abs(tem);
					ot->jarr[i][j]=(int)t;
					if(ot->jarr[i][j]>levels)
					{	if(it->img.TYPE == HSV)
							ot->jarr[i][j]=ot->jarr[i][j]-levels;
						else
							ot->jarr[i][j]=levels;
					}
					if(ot->jarr[i][j]<0)
						ot->jarr[i][j]=0;
				}
				if((flags & 4) == 4)
				{	if(it->img.TYPE == HSV)
						levels=999;
					else
						levels=255;
					tem = sqrt((double)(sum31*sum31)+(double)(sum32*sum32));
					t=abs(tem);
					ot->karr[i][j]=(int)t;
					if(ot->karr[i][j]>levels)
						ot->karr[i][j]=levels;
					if(ot->karr[i][j]<0)
						ot->karr[i][j]=0;
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				
				if((flags & 2) == 0)	
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
					
			}
		}
	}
	return(0);
}



int CIPL_Kirsch(THEADER *it,THEADER *ot,int flags)
{	
	THEADER *temp,*temp1;
	DATA *ID;
	int i,j,max,r,g,b;
		
	temp=(THEADER *)malloc(sizeof(THEADER));
	temp1=(THEADER *)malloc(sizeof(THEADER));
	
  	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->type=it->img.TYPE;
	ID->ver=it->ver;
		 	
     	HIPL_Initialise(temp,NULL,1,0,ID);
	HIPL_AllocateMem(temp);
	HIPL_Initialise(temp1,NULL,1,0,ID);
	HIPL_AllocateMem(temp1);
			  	 	
  	if(it->P.psize<it->MROWS)
	{
		HIPL_ERRNO=-17;
		HIPL_Error("Mask operation");
		return(-1);
	}
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}

		CIPL_KirschMove(it,temp,i,flags);
		i=HIPL_Putpart(temp);
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(temp->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(temp,0);
	temp->MROWS=1;
	temp->MCOLS=0;

	if(temp->img.TYPE == HSV && flags != 1)
	{	CIPL_Scale(temp,temp1,255.0/3600.0,2);
		HIPL_Refresh(temp,0);
		CIPL_Scale(temp1,temp,255.0/1000.0,4);
	}
	
	ot->img.TYPE = PGM;
	if(ot->jarr!=NULL && ot->karr != NULL){
		for(i=0;i<ot->P.psize;i++) {
			free(ot->jarr[i]);
			free(ot->karr[i]);
		}
		free(ot->jarr);
		free(ot->karr);
	}
	
	do {
		max = HIPL_Getpart(temp);
		
		if (max < 0) {
			HIPL_Error("Error in Getpart - incomplete read");
			return(max);
		}

		for (i=0; i<max; i++) {
			for (j=0; j<it->img.COLS; j++) {
				r=g=b=0;
				if((flags & 1) == 1)
					r=temp->iarr[i][j];
				if((flags & 2) == 2)
					g=temp->jarr[i][j];
				if((flags & 4) == 4)
					b=temp->karr[i][j];
				ot->iarr[i][j] = MAX(r,MAX(g,b));
			}
		}

		max = HIPL_Putpart(ot);
		if (max < 0) {
			HIPL_Error("Error in Putpart - incomplete write");
			return(max);
		}

		if (ot->P.nleft == 0)
			max = -1;
	} while (max >= 0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	i=HIPL_FreeMem(temp);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(temp1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(temp1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(temp);
	free(temp1);
  	return(0);
}

int CIPL_KirschMove(THEADER *it,THEADER *ot,int max,int flags)
{
	int i,j,k,l,m,n,**temp1,max1,levels,x;
	long int sum1[8],sum2[8],sum3[8];
	double tem,t;
	int Mask[8][3][3] = { { { 5, 5, 5},{-3,0,-3},{-3,-3,-3}},
			      { {5, 5,-3},{5,0,-3},{-3,-3,-3}},
			      { {5,-3,-3},{5,0,-3},{5,-3,-3}},
			      { {-3,-3,-3},{5, 0,-3},{5,5,-3}},
			      { {-3,-3,-3},{-3,0,-3},{5,5,5}},
			      { {-3,-3,-3},{-3,0,5},{-3,5,5}},
			      { {-3,-3,5},{-3,0,5},{-3,-3,5}},
			      { {-3,5,5},{-3,0,5},{-3,-3,-3}}};

			    
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}

	for(i=0;i<max;i++)
	{
		for(j=0;j<it->img.COLS;j++)
		{
			
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0)
				{
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			else
			{
				for(x=0;x<8;x++)
				  sum1[x]=sum2[x]=sum3[x] = 0;
						
				m=-it->MORGX;
				n=-it->MORGY;
				if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
				{	m=-it->MORGX;
					n=-it->MORGY;
					max1=-1;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(max1<it->jarr[i+n][j+m])
								max1 = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					m=-it->MORGX;
					n=-it->MORGY;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(it->jarr[i+n][j+m]<(max1 - 1800))
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
							else
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
				}
				
				m=-it->MORGX;
				n=-it->MORGY;
				for(k=0;k<it->MROWS;k++)
				{
					for(l=0;l<it->MCOLS;l++)
					{
						if(it->arrtype==0)
						{	for(x=0;x<8;x++)
							{	if((flags & 1) ==1)
								{
									sum1[x]=sum1[x]+(Mask[x][k][l]*it->iarr[i+n][j+m]);
								}
								if((flags & 2) == 2)
								{	if(it->img.TYPE == HSV)
									{	sum2[x]=sum2[x]+(Mask[x][k][l]*temp1[it->MORGY+n][it->MORGX+m]);
									}
									else
									{	sum2[x]=sum2[x]+(Mask[x][k][l]*it->jarr[i+n][j+m]);
									}
								}
								if((flags & 4) == 4)
								{	sum3[x]=sum3[x]+(Mask[x][k][l]*it->karr[i+n][j+m]);
								}
							}
						}
						m++;
					}
					m=-it->MORGY;
					n++;
				}
								
				
				if((flags & 1) == 1)
				{	levels=256;
					for(x=0;x<8;x++)
						sum1[x]=abs(sum1[x]);
					t=sum1[0];
					for(x=1;x<8;x++)
						if(sum1[x]>t) t= sum1[x];
						
					ot->iarr[i][j]=(int)t;
					if(ot->iarr[i][j]>levels)
						ot->iarr[i][j]=levels;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	if(it->img.TYPE == HSV)
						levels=3600;
					else
						levels=255;
					for(x=0;x<8;x++)
						sum2[x]=abs(sum2[x]);
					t=sum2[0];
					for(x=1;x<8;x++)
						if(sum2[x]>t) t= sum2[x];
					ot->jarr[i][j]=(int)t;
					if(ot->jarr[i][j]>levels)
					{	if(it->img.TYPE == HSV)
							ot->jarr[i][j]=ot->jarr[i][j]-levels;
						else
							ot->jarr[i][j]=levels;
					}
					if(ot->jarr[i][j]<0)
						ot->jarr[i][j]=0;
				}
				if((flags & 4) == 4)
				{	if(it->img.TYPE == HSV)
						levels=999;
					else
						levels=255;
					for(x=0;x<8;x++)
						sum3[x]=abs(sum3[x]);
					t=sum3[0];
					for(x=1;x<8;x++)
						if(sum3[x]>t) t= sum3[x];
					ot->karr[i][j]=(int)t;
					if(ot->karr[i][j]>levels)
						ot->karr[i][j]=levels;
					if(ot->karr[i][j]<0)
						ot->karr[i][j]=0;
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				
				if((flags & 2) == 0)	
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
					
			}
		}
	}
	return(0);
}
