/***********************************************************************
 *	This file contain function that enhance the image on Hue values
 *	based on the value passed by 'hueper'.
 ***********************************************************************/
#include "incl.h"

extern int HIPL_Initialise(THEADER *t,char *name,short i,short j,DATA *ID);
extern int HIPL_AllocateMem(THEADER *t);
extern int HIPL_Getpart(THEADER *t);
extern int HIPL_Putpart(THEADER *t);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_FreeMem(THEADER *t);
extern int HIPL_Refresh(THEADER *T,int flag);
extern void HIPL_Error(char *msg);
extern int HIPL_ERRNO;

int CIPL_HuePolarisation(THEADER *it,THEADER *ot,int hueper);

int CIPL_HuePolarisation(THEADER *it,THEADER *ot,int hueper)
{
	int i,j,k;
	float val1,val2;
	if(hueper<-100)
	{	HIPL_ERRNO=-20;
		return(-1);
	}
	if(hueper>100)
	{
		HIPL_ERRNO=-20;
		return(-1);
	}
	
	ot->img.TYPE = it->img.TYPE;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Histogram Stretch");
			return(i);
		}
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				val1=(float)(it->jarr[j][k]);

				if(val1<600)
					val2=val1-val1*hueper/100;
				else if(val1<1200)
					val2=val1+(1200-val1)*hueper/100;
				else if(val1<1800)
					val2=val1-(val1-1200)*hueper/100;
				else if(val1<2400)
					val2=val1+(2400-val1)*hueper/100;
				else if(val1<3000)
					val2=val1-(val1-2400)*hueper/100;
				else if(val1<3600)
					val2=val1+(3600-val1)*hueper/100;
				ot->jarr[j][k]=(int)val2;

				ot->iarr[j][k]=it->iarr[j][k];
				ot->karr[j][k]=it->karr[j][k];
				if(ot->jarr[j][k]>3600)
					ot->jarr[j][k]=3600;
				if(ot->jarr[j][k]<0)
					ot->jarr[j][k]=0;
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Saturation Variation");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}
int CIPL_HuePolarisation1(THEADER *it,THEADER *ot,int hueper,int *arr,int n)
{
	int i, j, k, temp,temp1;
	float val1,val2,diff;
	if(hueper<-100)
	{	HIPL_ERRNO=-20;
		return(-1);
	}
	if(hueper>100)
	{
		HIPL_ERRNO=-20;
		return(-1);
	}
	for(i=0;i<n;i++)
	{	for(j=i+1;j<n;j++)
		{	if(arr[i]>arr[j])
			{
				temp=arr[i];
				arr[i]=arr[j];
				arr[j]=temp;
			}
		}
	}
	
	ot->img.TYPE = it->img.TYPE;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Histogram Stretch");
			return(i);
		}
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{	
					val1=(float)(it->jarr[j][k]);
					for(temp=0; temp < n && arr[temp]<val1  ;temp++)
						;
					if(temp == n)
					{	temp1=3600+arr[0];
						if((val1-arr[temp-1])<(temp1-val1))
							val2=val1-(val1-arr[temp-1])*hueper/100;
						else
							val2=val1+(temp1-val1)*hueper/100;
					}
					else if(temp == 0)
					{	temp1=arr[n-1]-3600;
						if((val1-temp1)<(arr[temp]-val1))
							val2=val1-(val1-temp1)*hueper/100;
						else
							val2=val1+(arr[temp]-val1)*hueper/100;
					}
					else
					{		
						if((val1-arr[temp-1])<(arr[temp]-val1))
							val2=val1-(val1-arr[temp-1])*hueper/100;
						else
							val2=val1+(arr[temp]-val1)*hueper/100;
					}
					ot->jarr[j][k]=(int)val2;
				


				ot->iarr[j][k]=it->iarr[j][k];
				ot->karr[j][k]=it->karr[j][k];
				if(ot->jarr[j][k]>3600)
					ot->jarr[j][k]=ot->jarr[j][k]- 3600;
				if(ot->jarr[j][k]<0)
					ot->jarr[j][k]=3600+ot->jarr[j][k];
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Saturation Variation");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}




