#include "incl.h"

extern int  HIPL_Getpart(THEADER *T);
extern int HIPL_Putpart(THEADER *T);
extern void HIPL_Error(char *msg);
extern int HIPL_Refresh(THEADER *T,int flag);
extern int HIPL_Initialise(THEADER *,char *,short,short,DATA *);
extern int HIPL_AllocateMem(THEADER *);
extern int HIPL_Closeall(THEADER *);
extern int HIPL_FreeMem(THEADER *);

extern int HIPL_Fmaskimg(THEADER *it,THEADER *ot,double **Mask, double den);
extern int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color);

int CIPL_MoveMask(THEADER *it,THEADER *ot,int **Mask,int max,float reci,int flags);

int CIPL_Maskimg(THEADER *it,THEADER *ot,int **Mask,double factor,int flags);
int CIPL_Fmaskimg(THEADER *it,THEADER *ot,double **Mask, double den,int flags);

int CIPL_Maskimg(THEADER *it,THEADER *ot,int **Mask,double factor,int flags)
{	
	THEADER *temp;
	DATA *ID;
	float reci;
	int i;

	temp=(THEADER *)malloc(sizeof(THEADER));
  	
	ID=(DATA *)malloc(sizeof(DATA));
	
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->type=it->img.TYPE;
	ID->ver=it->ver;
	
	
	ot->img.TYPE=it->img.TYPE;
  	
     	HIPL_Initialise(temp,NULL,1,0,ID);
	
	
  	HIPL_AllocateMem(temp);

	
	if(factor==0.0)
	{
		HIPL_ERRNO=-19;
		HIPL_Error("Mask operation");
		return(-1);
	}

	reci=(float)(1/(float)factor);
	if(it->P.psize<it->MROWS)
	{
		HIPL_ERRNO=-17;
		HIPL_Error("Mask operation");
		return(-1);
	}

	do
	{	
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}
		
		CIPL_MoveMask(it,ot,Mask,i,reci,flags);
                 
		i=HIPL_Putpart(ot);
		
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);

	HIPL_Refresh(ot,0);
    	HIPL_FreeMem(temp);
  	
    	HIPL_Closeall(temp);
  	
  	free(ID);
    	free(temp);
	return(0);
 }

int CIPL_MoveMask(THEADER *it,THEADER *ot,int **Mask,int max,float reci,int flags)
{
	int i,j,k,l,m,n,levels,**temp1,max1;
	long int sum1,sum2,sum3;
	float tem,t;
	
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}
	
	for(i=0;i<max;i++)
	{	
		for(j=0;j<it->img.COLS;j++)
		{
			
			m=-it->MORGX;
			n=-it->MORGY;
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0){
					
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			
			else
			{	
				if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
				{	m=-it->MORGX;
					n=-it->MORGY;
					max1=-1;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(max1<it->jarr[i+n][j+m])
								max1 = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					m=-it->MORGX;
					n=-it->MORGY;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{	if(it->jarr[i+n][j+m]<(max1 - 1800))
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
							else
								temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
				}
				
				m=-it->MORGX;
				n=-it->MORGY;
				sum1=sum2=sum3=0;
				for(k=0;k<it->MROWS;k++)
				{
					for(l=0;l<it->MCOLS;l++)
					{
						if(it->arrtype==0)
						{	if((flags & 1) ==1)
								sum1=sum1+(Mask[k][l]*it->iarr[i+n][j+m]);
							if((flags & 2) == 2)
							{	if(it->img.TYPE == HSV)
									sum2=sum2+(Mask[k][l]*temp1[it->MORGY+n][it->MORGX+m]);
								else
									sum2=sum2+(Mask[k][l]*it->jarr[i+n][j+m]);
							}
							if((flags & 4) == 4)
								sum3=sum3+(Mask[k][l]*it->karr[i+n][j+m]);
						}
						m++;
					}
					m=-it->MORGY;
					n++;
				}
				
				if((flags & 1) == 1)
				{	tem=(float)(sum1);
					t=tem*reci;
					ot->iarr[i][j]=abs(t);
					
					levels=255;
					if(ot->iarr[i][j]>levels)
						ot->iarr[i][j]=levels;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	tem=(float)(sum2);
					t=tem*reci;
					
					ot->jarr[i][j]=abs(t);
					
					if(it->img.TYPE == HSV)
						levels=3600;
					else
						levels=255;
					if(ot->jarr[i][j]>levels)
					{	if(it->img.TYPE == HSV)
							ot->jarr[i][j]=ot->jarr[i][j]-levels;
						else
							ot->jarr[i][j]=levels;
					}
					if(ot->jarr[i][j]<0)
						ot->jarr[i][j]=0;
				}
				if((flags & 4) == 4)
				{	tem=(float)(sum3);
					t=tem*reci;
					
					ot->karr[i][j]=abs(t);
					if(it->img.TYPE == HSV)
						levels=999;
					else
						levels=255;
					if(ot->karr[i][j]>levels)
						ot->karr[i][j]=levels;
					if(ot->karr[i][j]<0)
						ot->karr[i][j]=0;
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				
				if((flags & 2) == 0)
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
			}
		}
		
	}
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	
		for(j=0;j<it->MROWS;j++)
			free(temp1[j]);	
		free(temp1);
	}
	return(0);
}



int CIPL_Fmaskimg(THEADER *it,THEADER *ot,double **Mask, double den,int flags)
{	
	int i,j;
	
	THEADER *TEMP, *TEMP1, *t1,*t2,*t3;
	DATA *ID;
	
	ot->img.TYPE = it->img.TYPE;
	
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	t1 = (THEADER *)malloc(sizeof(THEADER));
	t2 = (THEADER *)malloc(sizeof(THEADER));
	t3 = (THEADER *)malloc(sizeof(THEADER));
	
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	ID->type=it->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	i  = HIPL_Initialise(t1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(t1);
	i  = HIPL_Initialise(t2,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(t2);
	i  = HIPL_Initialise(t3,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(t3);
	
	t1->MROWS = t2->MROWS = t3->MROWS = TEMP->MROWS = TEMP1->MROWS =3;    
	t1->MCOLS = t2->MCOLS = t3->MCOLS =TEMP->MCOLS = TEMP1->MCOLS =3;
	t1->MORGX = t2->MORGX = t3->MORGX =TEMP->MORGX = TEMP1->MORGX =1;
	t1->MORGY = t2->MORGY = t3->MORGY =TEMP->MORGY = TEMP1->MORGY =1;
	
	
	CIPL_ExtractfromPPM(it,t1,0);
	if(it->img.TYPE == HSV)
	{	CIPL_Scale(it,TEMP1,256.0/3600.0,2);
		CIPL_ExtractfromPPM(TEMP1,t2,1);
		HIPL_Refresh(TEMP1,0);
	}
	else
		CIPL_ExtractfromPPM(it,t2,1);
	if(it->img.TYPE == HSV)
	{	CIPL_Scale(it,TEMP1,256.0/1000.0,4);
		CIPL_ExtractfromPPM(TEMP1,t3,2);
		HIPL_Refresh(TEMP1,0);
	}
	else
		CIPL_ExtractfromPPM(it,t3,2);
	
	
	if((flags & 1) == 1)
	{	
		HIPL_Fmaskimg(t1,TEMP,Mask,den);
		CIPL_InsertintoPPM(TEMP,ot,0);
	}
	else
	{
		CIPL_InsertintoPPM(t1,ot,0);
	}
	if((flags & 2) == 2)
	{	HIPL_Refresh(TEMP,0);
		HIPL_Fmaskimg(t2,TEMP,Mask,den);
		CIPL_InsertintoPPM(TEMP,ot,1);
	}
	else
	{	CIPL_InsertintoPPM(t2,ot,1);
	}
	
	if((flags & 4) == 4)
	{	HIPL_Refresh(TEMP,0);
		HIPL_Fmaskimg(t3,TEMP,Mask,den);
		CIPL_InsertintoPPM(TEMP,ot,2);
	}
	else
	{	CIPL_InsertintoPPM(t3,ot,2);
	}
	
	if(it->img.TYPE == HSV)
	{	CIPL_Scale(ot,TEMP1,3600.0/256.0,2);
		CIPL_Scale(TEMP1,ot,1,2);
		HIPL_Refresh(TEMP1,0);
	}
	if(it->img.TYPE == HSV)
	{	CIPL_Scale(ot,TEMP1,1000.0/256.0,4);
		CIPL_Scale(TEMP1,ot,1,4);
		HIPL_Refresh(TEMP1,0);
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object TEMP");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object TEMP");
		return -1;
	}
	i=HIPL_FreeMem(t1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t1);
	if(i<0) {
		HIPL_Error("Error in Closing Object t1");
		return -1;
	}
	i=HIPL_FreeMem(t2);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t2);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(t3);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t3);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return 0;
}
