#include "incl.h"
#include<stdio.h>
#include<math.h>
int dominant_axis, freq1[256], freq2[256], freq3[256];
typedef struct 
{
	int axis1;
	int axis2;
	int axis3;
}stpoint;
typedef struct 
{
	int axis1;
	int axis2;
	int axis3;
}edpoint;


extern int  HIPL_Getpart(THEADER *T);
extern int HIPL_Putpart(THEADER *T);
extern void HIPL_Error(char *msg);
extern int HIPL_Refresh(THEADER *T,int flag);
extern int HIPL_Initialise(THEADER *,char *,short,short,DATA *);
extern int HIPL_AllocateMem(THEADER *);
extern int HIPL_Closeall(THEADER *);
extern int HIPL_FreeMem(THEADER *);



int CIPL_Medcut(THEADER *it,THEADER *ot,int desired_no_of_boxes);

int CIPL_Medcut(THEADER *it,THEADER *ot,int desired_no_of_boxes)
{
	int count=0, median, i=0,j,tot_boxes=0,no_of_pixels,k,l,x;
	int temp1, temp2, temp3;
	int *avg1, *avg2, *avg3;
	int *count_in_box, *pixelat;
	double p,entropy=0,ptot=0;
	stpoint *start;
	edpoint *end;
	static int m;
	int split(stpoint, edpoint);
	
	ot->img.TYPE = it->img.TYPE;
	no_of_pixels = it->img.ROWS * it->img.COLS;
	
	do
	{
		x=0;
		i=HIPL_Getpart(it);
		if(i<0)
			return(i);
		
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				freq1[it->iarr[j][k]]++;
				freq2[it->jarr[j][k]]++;
				freq3[it->karr[j][k]]++;
			}
			
		}
	}while(i>0);          
	
	avg1=(int *)malloc(sizeof(int) * 2 * desired_no_of_boxes-1);
	avg2=(int *)malloc(sizeof(int) * 2 * desired_no_of_boxes-1);
	avg3=(int *)malloc(sizeof(int) * 2 * desired_no_of_boxes-1);
	count_in_box=(int *)malloc(sizeof(int) * 2 * desired_no_of_boxes-1);
	pixelat=(int *)malloc(sizeof(int) * no_of_pixels);
	
	start=(stpoint *)malloc(sizeof(stpoint) * 2 * desired_no_of_boxes-1);
	end=(edpoint *)malloc(sizeof(edpoint) * 2 * desired_no_of_boxes-1);
	
	for(j=0;j<2*desired_no_of_boxes-1;j++)
	{
		avg1[j]=0;
		avg2[j]=0;
		avg3[j]=0;
	}
	
	start[0].axis1=0;
	start[0].axis2=0;
	start[0].axis3=0;
	end[0].axis1=255;
	end[0].axis2=255;
	end[0].axis3=255;
	
	while(count<desired_no_of_boxes-1)
	{
		median=split(start[count],end[count]);
		start[count*2+1].axis1=start[count].axis1;
		
		start[count*2+1].axis2=start[count].axis2;
		start[count*2+1].axis3=start[count].axis3;
		
		switch(dominant_axis)
		{
			case 1:
			end[count*2+1].axis1=median;
			end[count*2+1].axis2=end[count].axis2;
			end[count*2+1].axis3=end[count].axis3;
			
			start[count*2+2].axis1=median;
			start[count*2+2].axis2=start[count].axis2;
			start[count*2+2].axis3=start[count].axis3;
			break;
			case 2:
			end[count*2+1].axis1=end[count].axis1;
			end[count*2+1].axis2=median;
			end[count*2+1].axis3=end[count].axis3;
			
			start[count*2+2].axis1=start[count].axis1;
			start[count*2+2].axis2=median;
			start[count*2+2].axis3=start[count].axis3;
			break;
			default:
			end[count*2+1].axis1=end[count].axis1;
			end[count*2+1].axis2=end[count].axis2;
			end[count*2+1].axis3=median;
			
			start[count*2+2].axis1=start[count].axis1;
			start[count*2+2].axis2=start[count].axis2;
			start[count*2+2].axis3=median;
		}
		end[count*2+2].axis1=end[count].axis1;
		end[count*2+2].axis2=end[count].axis2;
		end[count*2+2].axis3=end[count].axis3;
		
		count++;
	}
	HIPL_Refresh(it,0);
	do
	{
		x=0;
		i=HIPL_Getpart(it);
		if(i<0)
			return(i);
		
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				m++;
				for(l=desired_no_of_boxes-1;l<(2*desired_no_of_boxes)-1;l++)
				{
					if(it->iarr[j][k]==255)
						temp1=end[l].axis1+1;
					else
						temp1=end[l].axis1;
					
					if(it->jarr[j][k]==255)
						temp2=end[l].axis2+1;
					else
						temp2=end[l].axis2;
					
					if(it->karr[j][k]==255)
						temp3=end[l].axis3+1;
					else
						temp3=end[l].axis3;
					
					if(start[l].axis1<=it->iarr[j][k] && it->iarr[j][k]<temp1)
						if(start[l].axis2<=it->jarr[j][k] && it->jarr[j][k]<temp2)
							if(start[l].axis3<=it->karr[j][k] && it->karr[j][k]<temp3)
							{
								
								pixelat[m]=l;
								count_in_box[l]++;
								avg1[l]=it->iarr[j][k]+avg1[l];
								avg2[l]=it->jarr[j][k]+avg2[l];
								avg3[l]=it->karr[j][k]+avg3[l];
							}
				}
			}
		}
	}while(i>0);
	
	
	/* finding average of the pixels in each box */
	for(j=desired_no_of_boxes-1;j<(2*desired_no_of_boxes-1);j++)
	{
		if(count_in_box[j]!=0)
		{
			avg1[j]=avg1[j]/count_in_box[j];
			avg2[j]=avg2[j]/count_in_box[j];
			avg3[j]=avg3[j]/count_in_box[j];
		}
		else
		{
			continue;
		}
	}	
	m=0;
	HIPL_Refresh(it,0);
	do
	{
		i=0;
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Medcut Error");
			return(i);
		}
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				m++;    
				for(l=desired_no_of_boxes-1;l<(2*desired_no_of_boxes -1);l++)
				{
					if(pixelat[m]==l)
					{
						ot->iarr[j][k]=avg1[l];
						ot->jarr[j][k]=avg2[l];
						ot->karr[j][k]=avg3[l];
					}
				}
				
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Medcut Error");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	free(avg1);
	free(avg2);
	free(avg3);
	free(count_in_box);
	free(pixelat);
	free(start);
	free(end);
	m=0;
	return(0);
}


int split(stpoint start_temp, edpoint end_temp)
{
	int i;/* loop counter */
	int min_of_axis1, range_of_axis1, min_of_axis2, range_of_axis2;
	int min_of_axis3, range_of_axis3;
	int total, temp, median;
	
	/* finding range of axis1 */
	for(i=start_temp.axis1;i<end_temp.axis1;i++)
		if(freq1[i]>0)
			break;
	min_of_axis1=i;
	for(i=end_temp.axis1;i>start_temp.axis1;i++)
		if(freq1[i]>0)
			break;
	range_of_axis1=i-min_of_axis1;
	
	/* finding range of axis2 */
	for(i=start_temp.axis2;i<end_temp.axis2;i++)
		if(freq2[i]>0)
			break;
	min_of_axis2=i;
	for(i=end_temp.axis2;i>start_temp.axis2;i++)
		if(freq2[i]>0)
			break;
	range_of_axis2=i-min_of_axis2;
	
	/* finding range of axis3 */
	for(i=start_temp.axis3;i<end_temp.axis3;i++)
		if(freq3[i]>0)
			break;
	min_of_axis3=i;
	for(i=end_temp.axis3;i>start_temp.axis3;i++)
		if(freq3[i]>0)
			break;
	range_of_axis3=i-min_of_axis3;
	
	/* finding dominant axis */
	if(range_of_axis1 > range_of_axis2)
	{
		if(range_of_axis1 > range_of_axis3)
			dominant_axis=1;
		else
			dominant_axis=3;
	}
	else if(range_of_axis2>range_of_axis3)
		dominant_axis=2;
	else
		dominant_axis=3;
	
	/* finding median of dominant_axis */
	total=0;
	switch(dominant_axis)
	{
		case 1:
		for(i=start_temp.axis1;i<end_temp.axis1;i++)
		{
			total=total+freq1[i];/* total = sum of frequencies on  axis1 */
		}
		total=total/2;/* total=(sum of frequencies on axis1)/2 (helps in giving the  index of the median) */
		temp=0;
		for(i=start_temp.axis1;i<end_temp.axis1;i++)
		{
			temp=temp+freq1[i];
			if(total<temp)
				break;
		}
		median=i;
		break;
		
		case 2:
		for(i=start_temp.axis2;i<end_temp.axis2;i++)
		{
			total=total+freq2[i];/* total = sum of frequencies on  axis2 */
		}
		total=total/2;/* total=(sum of frequencies on axis2)/2 (helps in giving the  index of the median) */
		temp=0;
		for(i=start_temp.axis2;i<end_temp.axis2;i++)
		{
			temp=temp+freq2[i];
			if(total<temp)
				break;
		}
		median=i;
		break;
		
		default:
		for(i=start_temp.axis3;i<end_temp.axis3;i++)
		{
			total=total+freq3[i];/* total = sum of frequencies on  axis3 */
		}
		total=total/2;/* total=(sum of frequencies on axis3)/2 (helps in giving the  index of the median) */
		temp=0;
		for(i=start_temp.axis3;i<end_temp.axis3;i++)
		{
			temp=temp+freq3[i];
			if(total<temp)
				break;
		}
		median=i;
	}
	return(median);
}
