#include "incl.h"
#include<stdio.h>
typedef struct
{
	int r;
	int g;
	int b;
	int final_index;
	int frequency;
}palet;

extern int  HIPL_Getpart(THEADER *T);
extern int HIPL_Putpart(THEADER *T);
extern void HIPL_Error(char *msg);
extern int HIPL_Refresh(THEADER *T,int flag);
extern int HIPL_Initialise(THEADER *,char *,short,short,DATA *);
extern int HIPL_AllocateMem(THEADER *);
extern int HIPL_Closeall(THEADER *);
extern int HIPL_FreeMem(THEADER *);


int CIPL_Octree(THEADER *it,THEADER *ot,int no_of_levels,int desired_no_of_colors)
{
	int *count,i,j,k,num1,num2,num3,binaryg[8],binaryb[8],binaryr[8],int_temp;
	int *index_array,tot_unique_pixels=0,tot_count=0,m,l;
	int threshold,total_pixels_left,pal_size=0;
	int first,last,temp,n,firstat2nd,lastat2nd,location,maxcount,loopbreak,index;
	long *sumr,*sumg,*sumb;
	char index_number[8],temp_string[8];
	
	
	palet *palette;
	index=it->img.ROWS * it->img.COLS;
	count=(int *)calloc(sizeof(int) , 3*index);
	index_array=(int *)malloc(sizeof(int) * 3*index);
	sumr=(long *)calloc(sizeof(int) , 3*index);
	sumg=(long *)calloc(sizeof(int) , 3*index);
	sumb=(long *)calloc(sizeof(int) , 3*index);
	
	ot->img.TYPE = it->img.TYPE;
	
	/* finding index to each and every pixel */
	do
	{
		
		i=HIPL_Getpart(it);
		if(i<0)
			return(i);
		
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				num1=it->iarr[j][k];
				num2=it->jarr[j][k];
				num3=it->karr[j][k];
				
				/* converting r g b values from decimal to binary */
				for(l=0;l<8;l++)
				{
					
					binaryr[7-l]=num1%2;
					num1=num1/2;
					
					binaryg[7-l]=num2%2;
					num2=num2/2;
					
					binaryb[7-l]=num3%2;
					num3=num3/2;
					
				}
				for(l=0;l<no_of_levels;l++)
				{
					int_temp = binaryr[l] * 4 +  binaryg[l] * 2 +  binaryb[l];
					index_number[l]=int_temp + '1';
				}
				index_number[l]='\0';
				
				/* checking whether the index is present in existing index_array */
				for(l=0;l<tot_unique_pixels;l++)
				{
					if(index_array[l] == atoi(index_number))
					{
						count[l]++;
						sumr[l]=sumr[l]+it->iarr[j][k];
						sumg[l]=sumg[l]+it->jarr[j][k];
						sumb[l]=sumb[l]+it->karr[j][k];
						break;
					}
				}
				if(l == tot_unique_pixels)
				{
					index_array[l]=atoi(index_number);
					count[l]++;
					sumr[l]=sumr[l]+it->iarr[j][k];
					sumg[l]=sumg[l]+it->jarr[j][k];
					sumb[l]=sumb[l]+it->karr[j][k];
					tot_unique_pixels++;
				}
			}
		}
	}while(i>0); 
	count[tot_unique_pixels]=-1;
	sumr[tot_unique_pixels]=-1;
	sumg[tot_unique_pixels]=-1;
	sumb[tot_unique_pixels]=-1;
	
	for(j=0;j<tot_unique_pixels;j++)
	{
		tot_count=tot_count+count[j];
	}
	
	/* Tree pruning starts here */
	total_pixels_left = index;
	
	
	palette=(palet *)calloc(sizeof(palet) , 512);
	first=0;
	last=tot_unique_pixels;
	temp=tot_unique_pixels + 1;
	
	for(j=no_of_levels-1;j>1;j--)
	{
		threshold = total_pixels_left/(desired_no_of_colors - pal_size);
		
		for(i=first;i<last;i++)
		{
			if(count[i]>=threshold)
			{
				palette[pal_size].r=sumr[i]/count[i];
				palette[pal_size].g=sumg[i]/count[i];
				palette[pal_size].b=sumb[i]/count[i];
				palette[pal_size].final_index=index_array[i];
				total_pixels_left = total_pixels_left-count[i];
				count[i]=0;
				sumr[i]=0;
				sumg[i]=0;
				sumb[i]=0;
				pal_size++;
				if(desired_no_of_colors == pal_size)
					break;
			}
		}
		
		
		if(desired_no_of_colors == pal_size)
			break;
		/* combining pixels at nth level to move to (n-1)th level */
		
		for(i=first;i<last;i++)
		{
			if(count[i]==-2)
				continue;
			sprintf(index_number,"%d",index_array[i]);
			strncpy(temp_string,index_number,j);
			temp_string[j]='\0';
			
			
			for(n=i;n<last;n++)
			{
				if(count[n]==-2)
					continue;
				sprintf(index_number,"%d",index_array[n]);
				if((strncmp(temp_string,index_number,j) == 0))
				{
					count[temp]=count[temp] + count[n];
					sumr[temp]=sumr[temp]+sumr[n];
					sumg[temp]=sumg[temp]+sumg[n];
					sumb[temp]=sumb[temp]+sumb[n];
					count[n]=-2;
				}
			}
			index_array[temp]=atoi(temp_string);
			
			temp++;
		}
		count[temp]=-1;
		sumr[temp]=-1;
		sumg[temp]=-1;
		sumb[temp]=-1;
		first=last+1;
		last=temp;
		if(j==2)
		{
			firstat2nd=first;
			lastat2nd=last;
		}
		temp++;
	}
	
	
	for(i=firstat2nd;i<lastat2nd;i++)
	{
		if(count[i]!=0)
		{
			palette[pal_size].r=sumr[i]/count[i];
			palette[pal_size].g=sumg[i]/count[i];
			palette[pal_size].b=sumb[i]/count[i];
			palette[pal_size].final_index=index_array[i];
			count[i]=0;
			pal_size++;
		}
	}
	
	HIPL_Refresh(it,0);
	/* Assignment of pixels starts here */
	do
	{
		
		i=HIPL_Getpart(it);
		if(i<0)
			return(i);
		
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				num1=it->iarr[j][k];
				num2=it->jarr[j][k];
				num3=it->karr[j][k];
				
				/* converting r g b values from decimal to binary */
				for(l=0;l<8;l++)
				{
					
					binaryr[7-l]=num1%2;
					num1=num1/2;
					
					binaryg[7-l]=num2%2;
					num2=num2/2;
					
					binaryb[7-l]=num3%2;
					num3=num3/2;
					
				}
				for(l=0;l<no_of_levels;l++)
				{
					int_temp = binaryr[l] * 4 +  binaryg[l] * 2 +  binaryb[l];
					index_number[l]=int_temp + '1';
				}
				index_number[l]='\0';
				
				loopbreak=1;
				for(l=no_of_levels;l>=2;l--)
				{
					strncpy(temp_string,index_number,l);
					temp_string[l]='\0';
					int_temp=atoi(temp_string);
					
					for(m=0;m<pal_size;m++)
					{
						if(int_temp==palette[m].final_index)
						{	ot->iarr[j][k]=palette[m].r;
							ot->jarr[j][k]=palette[m].g;
							ot->karr[j][k]=palette[m].b;
							
							palette[m].frequency++;
							
							loopbreak=0;
							break;
						}
					}
					if(loopbreak==0)
						break;
				}
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Histogram Equalise");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	free(count);
	free(index_array);
	free(sumr);
	free(sumg);
	free(sumb);
	return(0);
}
