/***********************************************************************
 *	This file contains function that varies Saturation values
 *	depending on the value passed by 'satper'.
 ***********************************************************************/
#include "incl.h"

extern int HIPL_Initialise(THEADER *t,char *name,short i,short j,DATA *ID);
extern int HIPL_AllocateMem(THEADER *t);
extern int HIPL_Getpart(THEADER *t);
extern int HIPL_Putpart(THEADER *t);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_FreeMem(THEADER *t);
extern int HIPL_Refresh(THEADER *T,int flag);
extern void HIPL_Error(char *msg);
extern int HIPL_ERRNO;

int CIPL_SatuVariation(THEADER *it,THEADER *ot,int satper)
{
	int i,j,k;
	float val1,val2;
	if(satper<-100)
	{	HIPL_ERRNO=-20;
		return(-1);
	}
	if(satper>100)
	{
		HIPL_ERRNO=-20;
		return(-1);
	}
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Histogram Stretch");
			return(i);
		}
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{
				val1=(float)(it->karr[j][k]);

				/* Varies the S values */ 
				val2=val1+val1*satper/100;

				ot->karr[j][k]=(int)val2;
				ot->iarr[j][k]=it->iarr[j][k];
				ot->jarr[j][k]=it->jarr[j][k];

				if(ot->karr[j][k]>999)
					ot->karr[j][k]=999;
				if(ot->karr[j][k]<0)
					ot->karr[j][k]=0;
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Saturation Variation");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}
