#include "incl.h"

extern int HIPL_Initialise(THEADER *t,char *name,short i,short j,DATA *ID);
extern int HIPL_AllocateMem(THEADER *t);
extern int HIPL_Getpart(THEADER *t);
extern int HIPL_Putpart(THEADER *t);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_FreeMem(THEADER *t);
extern int HIPL_Refresh(THEADER *T,int flag);
extern void HIPL_Error(char *msg);
extern int HIPL_ERRNO;

int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color)
{
	int i,j,k;
	if(color !=1 && color !=2 && color !=4)
		return -1;
	
	ot->img.TYPE = it->img.TYPE;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Scaling Image");
			return(i);
		}
		for(j=0;j<i;j++)
		{
			for(k=0;k<it->img.COLS;k++)
			{	if(color==1){
				ot->iarr[j][k]=(int)(it->iarr[j][k]*factor);
				ot->jarr[j][k]=it->jarr[j][k];
				ot->karr[j][k]=it->karr[j][k];
				}
				else if(color==2){
				ot->jarr[j][k]=(int)(it->jarr[j][k]*factor);
				ot->iarr[j][k]=it->iarr[j][k];
				ot->karr[j][k]=it->karr[j][k];
				}
				else if(color==4){
				ot->karr[j][k]=(int)((it->karr[j][k])*factor);
				ot->jarr[j][k]=it->jarr[j][k];
				ot->iarr[j][k]=it->iarr[j][k];
				}
				
			}
		}
		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Scaling Image");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}
