#include "incl.h"

extern int CIPL_Maskimg(THEADER *it,THEADER *ot,int **Mask,double factor,int flags);
int CIPL_MoveMedian(THEADER *it,THEADER *ot,int max,int flags);
int CIPL_Sort(int *Temp,int size);

int CIPL_Smoothing(THEADER *it, THEADER *ot, int flags)
{
	int **mask,i,j;
	double sum=0;
	
	ot->img.TYPE = it->img.TYPE;
	mask=(int**)malloc(it->MROWS*sizeof(int*));

	for(i=0;i<it->MROWS;i++)
	{	mask[i]=(int*)malloc(it->MCOLS*sizeof(int));
		for(j=0;j<it->MCOLS;j++)
		{	mask[i][j]=1;
			sum+=mask[i][j];
		}
	}
	
	CIPL_Maskimg(it, ot, mask, sum, flags);
	
}

int CIPL_Highpass(THEADER *it, THEADER *ot, int flags)
{
	int **mask,i,j;
	double sum=1.0;
	
	mask=(int**)malloc(it->MROWS*sizeof(int*));

	for(i=0;i<it->MROWS;i++)
	{	mask[i]=(int*)malloc(it->MCOLS*sizeof(int));
		for(j=0;j<it->MCOLS;j++)
		{	if(i==it->MORGX && j==it->MORGY)
				mask[i][j]=(it->MROWS*it->MCOLS)-1;
			else
				mask[i][j]=-1;
		}
	}

	CIPL_Maskimg(it, ot, mask, sum, flags);
	
}
int CIPL_Highboost(THEADER *it, THEADER *ot, double amp, int flags)
{
	int i,j;
	double sum=1.0,**mask;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	ID->type=it->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	mask=(double**)malloc(it->MROWS*sizeof(double*));

	for(i=0;i<it->MROWS;i++)
	{	mask[i]=(double*)malloc(it->MCOLS*sizeof(double));
		for(j=0;j<it->MCOLS;j++)
		{	if(i==it->MORGX && j==it->MORGY)
				mask[i][j]=(it->MROWS*it->MCOLS)*amp-1.0;
			else
				mask[i][j]=-1.0;
			
		}
	}
	
	CIPL_ExtractfromPPM(it,TEMP,0);
	if((flags & 1) == 1)
	{	HIPL_Fmaskimg(TEMP,TEMP1,mask,sum);
		CIPL_InsertintoPPM(TEMP1,ot,0);
	}
	else
		CIPL_InsertintoPPM(TEMP,ot,0);
	HIPL_Refresh(TEMP,0);
	HIPL_Refresh(TEMP1,0);
	
	CIPL_ExtractfromPPM(it,TEMP,1);
	if((flags & 2) == 2)
	{	HIPL_Fmaskimg(TEMP,TEMP1,mask,sum);
		CIPL_InsertintoPPM(TEMP1,ot,1);
	}
	else
		CIPL_InsertintoPPM(TEMP,ot,1);
	HIPL_Refresh(TEMP,0);
	HIPL_Refresh(TEMP1,0);
	
	CIPL_ExtractfromPPM(it,TEMP,2);
	if((flags & 4) == 4)
	{	HIPL_Fmaskimg(TEMP,TEMP1,mask,sum);
		CIPL_InsertintoPPM(TEMP1,ot,2);
	}
	else
		CIPL_InsertintoPPM(TEMP,ot,2);
	HIPL_Refresh(TEMP,0);
	HIPL_Refresh(TEMP1,0);
		
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	
}

int CIPL_Medianmask(THEADER *it,THEADER *ot,int flags)
{
	int i;
	
	ot->img.TYPE = it->img.TYPE;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Error in Getpart");
			return(i);
		}
		CIPL_MoveMedian(it,ot,i,flags);
		i=HIPL_Putpart(ot);
		
		if(i<0)
		{
			HIPL_Error("Error in Putpart");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}



int CIPL_MoveMedian(THEADER *it,THEADER *ot,int max,int flags)
{
	int i,j,k,l,m,n,*temp,t1,t2,t3,sq,c,**temp1,max1;
	sq=it->MROWS*it->MCOLS;
	temp=(int *)malloc(sq*sizeof(int));
	
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	temp1=(int**)malloc(sizeof(int*)*it->MROWS);
		for(j=0;j<it->MROWS;j++)
			temp1[j]=(int*)malloc(sizeof(int) * it->MCOLS);	
	}

	if(temp==(int *)0)
	{
		HIPL_ERRNO=-5;
		HIPL_Error("Median Operation");
		return(-1);
	}
	for(i=0;i<max;i++)
	{
		for(j=0;j<it->img.COLS;j++)
		{
			
			if((i<it->MORGX)||((max-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
			{
				if(it->arrtype==0)
				{
					ot->iarr[i][j]=it->iarr[i][j];
					ot->jarr[i][j]=it->jarr[i][j];
					ot->karr[i][j]=it->karr[i][j];
				}
			}
			else
			{
				c=0;
				if((flags & 1)==1)
				{	m=-it->MORGY;
					n=-it->MORGX;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{
							if(it->arrtype==0)
								temp[c]=it->iarr[i+n][j+m];
							c++;
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					
					t1=CIPL_Sort(temp,sq);
					
					
				}
				
				if((flags & 2) == 2)
				{
					if(it->img.TYPE == HSV)
					{	m=-it->MORGX;
						n=-it->MORGY;
						max1=-1;
						for(k=0;k<it->MROWS;k++)
						{
							for(l=0;l<it->MCOLS;l++)
							{	if(max1<it->jarr[i+n][j+m])
									max1 = it->jarr[i+n][j+m];
								m++;
							}
							m=-it->MORGY;
							n++;
						}
						m=-it->MORGX;
						n=-it->MORGY;
						for(k=0;k<it->MROWS;k++)
						{
							for(l=0;l<it->MCOLS;l++)
							{	if(it->jarr[i+n][j+m]<(max1 - 1800))
									temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m] + 3600;
								else
									temp1[it->MORGY+n][it->MORGX+m] = it->jarr[i+n][j+m];
								m++;
							}
							m=-it->MORGY;
							n++;
						}
					}
					m=-it->MORGX;
					n=-it->MORGY;
					c=0;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{
							if(it->arrtype==0)
							{	if(it->img.TYPE == HSV)
									temp[c]=temp1[it->MORGY+n][it->MORGX+m];
								else
									temp[c]=it->jarr[i+n][j+m];
							}
							c++;
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					t2=CIPL_Sort(temp,sq);
				}
				
				if((flags & 4)==4)
				{	m=-it->MORGX;
					n=-it->MORGY;
					c=0;
					for(k=0;k<it->MROWS;k++)
					{
						for(l=0;l<it->MCOLS;l++)
						{
							if(it->arrtype==0)
								temp[c]=it->karr[i+n][j+m];
							c++;
							m++;
						}
						m=-it->MORGY;
						n++;
					}
					t3=CIPL_Sort(temp,sq);
				}
				if((flags & 1) == 1)
				{
					ot->iarr[i][j]=(int)t1;
					if(ot->iarr[i][j]>255)
						ot->iarr[i][j]=255;
					if(ot->iarr[i][j]<0)
						ot->iarr[i][j]=0;
				}
				if((flags & 2) == 2)
				{	ot->jarr[i][j]=(int)t2;
					if(it->img.TYPE == HSV)
					{
						if(ot->jarr[i][j]>3600)
							ot->jarr[i][j]=ot->jarr[i][j]-3600;
						if(ot->jarr[i][j]<0)
							ot->jarr[i][j]=0;
					}
					else
					{	if(ot->jarr[i][j]>255)
							ot->jarr[i][j]=255;
						if(ot->jarr[i][j]<0)
							ot->jarr[i][j]=0;
					}
				}
				if((flags & 4) == 4)
				{
					ot->karr[i][j]=(int)t3;
					if(it->img.TYPE == HSV)
					{
						if(ot->karr[i][j]>999)
							ot->karr[i][j]=999;
						if(ot->karr[i][j]<0)
							ot->karr[i][j]=0;
					}
					else
					{	if(ot->karr[i][j]>255)
							ot->karr[i][j]=255;
						if(ot->karr[i][j]<0)
							ot->karr[i][j]=0;
					}
				}
				if((flags & 1) == 0)
					ot->iarr[i][j]=it->iarr[i][j];
				if((flags & 2) == 0)
					ot->jarr[i][j]=it->jarr[i][j];
				if((flags & 4) == 0)
					ot->karr[i][j]=it->karr[i][j];
			}
		}
	}
	free((char *)temp);
	if((it->img.TYPE == HSV) && ((flags & 2) ==2 ))
	{	
		for(j=0;j<it->MROWS;j++)
			free(temp1[j]);
		free(temp1);
	}
	return(0);
}

/****************************************************************
*	FUNCTION : CIPL_Sort						*
*								*
*	INPUT	 :Array for which the median is to be found	*
*		    and the array size				*
*								*
*	OUTPUT	 : Median on success				*
*		   negative value on failure			*
*								*
*    DESCRIPTION : Finds the median of the neighbourhood which  *
*		     is given as a linear array			*
*								*
*   EXTERNAL CALLS : None					*
*								*
****************************************************************/

int CIPL_Sort(int *Temp,int size)
{
	int i,j,m,x,flag=0;
	
	
	for(i=0;i<size;i++)
	{
		for(j=0;j<size-1;j++)
		{
			if(Temp[j]>Temp[j+1])
			{
				flag=1;
				x=Temp[j];
				Temp[j]=Temp[j+1];
				Temp[j+1]=x;
			}
		}
		if(flag==0)
				break;
		else flag=0;
	}
	
	m=(Temp[(size/2)-1]+Temp[size/2])/2;
	if((size%2)==0) return(m);
	else		return(Temp[size/2]);
}


