#include "incl.h"
#include <math.h>
#include <stdio.h>
#define MIN(A, B)	(((A) < (B)) ? (A) : (B))


int CIPL_XYZfilter(THEADER *it, THEADER *ot,int nm, int range,int n);
int CIPL_readtable(char *name,double table[340][2]);

int CIPL_readtable(char *name,double table[340][2])
{
	FILE *fp;
	int field1=0,i;
	double field2,field3;
	
	fp=fopen(name,"r");
	if(fp == NULL)
		printf("File:%s can't read\n",name);
	
	for(i=0;i<340;i++)
	{	
		fscanf(fp,"%d, ",&field1);
		fscanf(fp,"%lf, ",&field2);
		fscanf(fp,"%lf\n",&field3);
		table[i][0]=field2;
		
		table[i][1]=field3;
	}
	fclose(fp);
}

double dist(double x,double y,int nm,double table[340][2])
{	
	
	return (sqrt((x-table[nm-360][0])*(x-table[nm-360][0])+(y-table[nm-360][1])*(y-table[nm-360][1])));
}	
int mindist(double x,double y,int min, int max,double table[340][2])
{	int temp,i;
	double dis,mind;
	for(i=min;i<max;i++)
	{	dis=dist(x,y,i,table);
		if(i==min)
			mind=dis;
		else
		{	if(mind>dis)
			{	mind=dis;
				temp=i;
			}
		}
	}
	return temp;
}
int CIPL_XYZfilter(THEADER *it, THEADER *ot,int nm, int range,int n)
{
     int i, j, max, sum, nm1;
     double x, y, X, Y, Z, H, S, I, R, G, B, t1, t2, t3, table[340][2]; 

     ot->img.TYPE = it->img.TYPE;
     
     CIPL_readtable("cie_table.txt",table);
     
     do {
	  max = HIPL_Getpart(it);
	  if (max < 0) {
	       HIPL_Error("Error in Getpart - incomplete read");
	       return(max);
	  }
	  
	  	for (i=0; i<max; i++) {
	       		for (j=0; j<it->img.COLS; j++) {
	       			
	       			R = it->iarr[i][j];
		    		G = it->jarr[i][j];
		    		B = it->karr[i][j];
		
		    		Y = 0.212671 * R + 0.715160 * G + 0.072169 * B;
		    
		    		X = 0.412453 * R + 0.357580 * G  + 0.180423 * B;
		     
		     		Z = 0.019334 * R  + 0.119193 * G + 0.950227 * B;
		     		
		     		
		     		I = (R + G + B) / 3.0;
		    
		    
		    		if ((int)(R + G + B) == 0)
			 		S = 0.0;
		   		 else
			 		S = 1.0 - (3.0 * MIN(R, MIN(G, B)) / (R + G + B));
		  
		    
		    		if (S*1000 > 0)
				 {
					 H = 0.5 * ((R - G) + (R - B)) /(sqrt((R - G) * (R - G) + (R - B) * (G - B)));
					 if ((int)(B) > (int)(G))
			      			H = (2.0 * M_PI - acos(H)) * 180.0 / M_PI;
			 		else
			      			H = acos(H) * 180.0 / M_PI;
		    		} else
					 H = 0;
	       			
	       			
				sum = X + Y+ Z;
				x = (float)X/sum;
				y = (float)Y/sum;
				
				/*t1=dist(x,y,380,table);
				t2=dist(x,y,520,table);
				t3=dist(x,y,780,table);
				
				if(t1<t2 && t1<t3)
					nm1=mindist(x,y,380,500,table);
				else if(t2<t1 && t2<t3)
					nm1=mindist(x,y,490,570,table);
				else
					nm1=mindist(x,y,560,699,table);*/
					
				nm1=mindist(x,y,380,699,table);
				
				I = 1/(1+pow((abs(nm1-nm)/(range/2)),2*n)) * I;
				
								
				I = I * 3;     /* Scale back to original */
		   		

		    		if (H == 0.0)
					 H = 360;

		   		 /* 0 < H <= 120 degrees case */
		    		if ((H > 0) && (H <= 120)) {
			 		B = (1.0 - S) / 3.0;
			 		R = (1.0 + (S * cos(H * M_PI / 180.0)) / 
			      		cos(M_PI * (60.0 - H) / 180.0)) / 3.0;
			 		G = 1.0 - (R + B);

		    		/* 120 < H <= 240 degrees case */
		    		} else if ((H > 120) && (H <= 240)) {
					 H = H - 120;
			 		 R = (1.0 - S) / 3.0;
			 		 G = (1.0 + (S * cos(H * M_PI / 180.0)) / 
			     		 cos(M_PI * (60.0 - H) / 180.0)) / 3.0;
					 B = 1.0 - (R + G);
		    		/* 240 < H <= 360 degrees case */
		    		} else {
			 		H = H - 240;
			 		G = (1.0 - S) / 3.0;
			 		B = (1.0 + (S * cos(H * M_PI / 180.0)) / 
			     		cos(M_PI * (60.0 - H) / 180.0)) / 3.0;
					 R = 1.0 - (B + G);
		   		 }

		    		 ot->iarr[i][j] = (int)(R * I);
		   		 ot->jarr[i][j] = (int)(G * I);
		   		 ot->karr[i][j] = (int)(B * I);
		   		 
				 	
	       		}
	  	}
	  
	  max = HIPL_Putpart(ot);
	  if (max < 0) {
	       HIPL_Error("Error in Putpart - incomplete write");
	       return(max);
	  }

	  if (ot->P.nleft == 0)
	       max = -1;
     } while (max >= 0);

     HIPL_Refresh(it, 0);
     HIPL_Refresh(ot, 0);

     return(0);
}
