#include "incl.h"
extern int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color);
int CIPL_Canny(THEADER *it,THEADER *ot,double sigma,int lo,int hi,int flags)
{
	THEADER *t1,*t2,*t3,*ot1,*ot2,*ot3,*TEMP;
	DATA *ID;
	int i,j,max;
	ot->img.TYPE = PGM;
	
	t1=(THEADER *)malloc(sizeof(THEADER));
	t2=(THEADER *)malloc(sizeof(THEADER));
	t3=(THEADER *)malloc(sizeof(THEADER));
	ot1=(THEADER *)malloc(sizeof(THEADER));
	ot2=(THEADER *)malloc(sizeof(THEADER));
	ot3=(THEADER *)malloc(sizeof(THEADER));
	TEMP=(THEADER *)malloc(sizeof(THEADER));
	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->ver=it->ver;
	ID->type = it->img.TYPE;
	
	HIPL_Initialise(t1,NULL,1,0,ID);
	HIPL_Initialise(t2,NULL,1,0,ID);
	HIPL_Initialise(t3,NULL,1,0,ID);
	HIPL_Initialise(ot1,NULL,1,0,ID);
	HIPL_Initialise(ot2,NULL,1,0,ID);
	HIPL_Initialise(ot3,NULL,1,0,ID);
	HIPL_Initialise(TEMP,NULL,1,0,ID);
	
	HIPL_AllocateMem(t1);
	HIPL_AllocateMem(t2);
	HIPL_AllocateMem(t3);
	HIPL_AllocateMem(ot1);
	HIPL_AllocateMem(ot2);
	HIPL_AllocateMem(ot3);
	HIPL_AllocateMem(TEMP);
	
	if((flags & 1)==1)
	{
		CIPL_ExtractfromPPM(it,t1,0);
		
	}
	if((flags & 2)==2)
	{	if(it->img.TYPE == HSV)
		{	CIPL_Scale(it,TEMP,256.0/3600.0,2);
			CIPL_ExtractfromPPM(TEMP,t2,1);
		}
		CIPL_ExtractfromPPM(it,t2,1);
	}
	HIPL_Refresh(TEMP,0);
	if((flags & 4)==4)
	{	if(it->img.TYPE == HSV)
		{	CIPL_Scale(it,TEMP,256.0/1000.0,4);
			CIPL_ExtractfromPPM(TEMP,t3,2);
		}
		CIPL_ExtractfromPPM(it,t3,2);
	}
	
	if((flags & 1) == 1)
		HIPL_Canny(t1,ot1,sigma,lo,hi);
	if((flags & 2) == 2)
		HIPL_Canny(t2,ot2,sigma,lo,hi);
	if((flags & 4) == 4)
		HIPL_Canny(t3,ot3,sigma,lo,hi);
	
	do
	{	if((flags & 1)==1)
		{
			max=HIPL_Getpart(t1);
			if(max<0)
			{
				HIPL_Error("Error in Getpart");
				return(max);
			}
		}
		if((flags & 2)==2)
		{
			max=HIPL_Getpart(t2);
			if(max<0)
			{
				HIPL_Error("Error in Getpart");
				return(max);
			}
		}
		if((flags & 4)==4)
		{
			max=HIPL_Getpart(t3);
			if(max<0)
			{
				HIPL_Error("Error in Getpart");
				return(max);
			}
		}
		for(i=0;i<max;i++)
		{	for(j=0;j<t1->img.COLS;j++)
			{	ot->iarr[i][j]=0;
				if((flags & 1)==1)
					ot->iarr[i][j]=ot1->iarr[i][j];
				if((flags & 2)==2)
				{	if(ot->iarr[i][j] < ot2->iarr[i][j])
						ot->iarr[i][j]=ot2->iarr[i][j];
				}
				if((flags & 4)==4)
				{	if(ot->iarr[i][j] < ot3->iarr[i][j])
						ot->iarr[i][j]=ot3->iarr[i][j];
				}
			}
		}

		max=HIPL_Putpart(ot);
		if(max<0)
		{
			HIPL_Error("Error in Putpart");
			return(max);
		}
		if(ot->P.nleft==0)
			max=-1;
	}while(max>=0);
	
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object TEMP");
		return -1;
	}
	i=HIPL_FreeMem(t1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t1);
	if(i<0) {
		HIPL_Error("Error in Closing Object t1");
		return -1;
	}
	i=HIPL_FreeMem(t2);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t2);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(t3);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(t3);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	
	i=HIPL_FreeMem(ot1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(ot1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(ot2);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(ot2);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(ot3);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(ot3);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return(0);
}

