/*#include"err_hipl.h"
#define ISUNIX 1 
#define  TIFF 20
#define  PGM  10
#define  RAW  30
#define  UNKNOWN 99 
#define  BINARY 0
#define  ASCII 1

typedef struct{
	int psize;
	int rowsread;
	int nleft;
	int put;
}parts;

typedef struct{
	int ROWS;
	int COLS;
	int levels;
	int TYPE;
}IMGHEADER;

typedef struct{
	int ROWS;
	int COLS;
	short ver;
	long int *hist;
	float inertia;
	float uniformity;
	float entropy;
	float roughness;
	int maxg;
	int ming;
	int mean;
	int dev;
}DATA;

typedef struct {
	FILE *fptr;
	FILE *jptr;
	FILE *kptr;
	char tempfname[25];
	char tempjname[25];
	char tempkname[25];
	int **iarr;
	int **jarr;
	int **karr;
	float **farr;
	int MORGX;
	int MORGY;
	int MROWS;
	int MCOLS;	
	parts P;
	short dfflg;
	short arrtype;
	short ver;
	short memflag;
	IMGHEADER img;
}THEADER;

typedef struct {
	char fname[100];
	THEADER *T;
	DATA *ID;
} HEADER;

typedef struct {
          int label;
          int xmin;
          int ymin;
          int xmax;
          int ymax;
} MBRSTRUCT;

extern int HIPL_ERRNO;
extern char WINERR[];*/
//int MAXMEM=350;
//int MAXMEM1=350;
int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
int HIPL_AllocateMem(THEADER *T);
int HIPL_Getpart(THEADER *T);
int HIPL_Putpart(THEADER *T);
void HIPL_Error(char *msg);
int HIPL_Closeall(THEADER *T);
int HIPL_FreeMem(THEADER *T);
int HIPL_StoreResult(char *name,THEADER *T);
int HIPL_Refresh(THEADER *T,int flg);
void HIPL_Setmemory(int Memory);
int HIPL_ReadImagePGM(FILE *,THEADER *t);
int HIPL_ReadImagePPM(FILE *fp1,THEADER *t);
int HIPL_GetImageHeaderPGM(FILE *, THEADER *t);
int HIPL_GetImageHeaderPPM(FILE *fp, THEADER *t);
int HIPL_GetImageTypePGM(THEADER *t);
int HIPL_GetImageRowsPGM(THEADER *t);
int HIPL_GetImageColsPGM(THEADER *t);
int HIPL_PutImageHeaderPGM(FILE *fp,THEADER *T);
int HIPL_WriteImagePGM(FILE *fd, THEADER *t);
int HIPL_WriteImagePPM(FILE *fp, THEADER *t);


int CIPL_ExtractfromPPM(THEADER *, THEADER *, int);
int CIPL_InsertintoPPM(THEADER *, THEADER *, int);

int CIPL_rgbtohsi(THEADER *, THEADER *);
int CIPL_hsitorgb(THEADER *, THEADER *);
int CIPL_rgbtoxyz(THEADER *, THEADER *);
int CIPL_xyztorgb(THEADER *, THEADER *);
int CIPL_rgbtoyiq(THEADER *, THEADER *);
int CIPL_yiqtorgb(THEADER *, THEADER *);

int CIPL_Negative(THEADER *it, THEADER *ot);
int CIPL_Differ(THEADER *it1,THEADER *it2,THEADER *ot);
int CIPL_SIMax(THEADER *it1,THEADER *it2,THEADER *ot);
int CIPL_SIAvg(THEADER *it1,THEADER *it2,THEADER *ot);
int CIPL_HFlip(THEADER *it,THEADER *ot);
int CIPL_Thresh(THEADER *it,THEADER *ot,int r,int g,int b,int flags);
int CIPL_Transpose(THEADER *it,THEADER *ot);
int CIPL_Bpslice(THEADER *it,THEADER *ot,int bit,int flags);
int CIPL_Double(THEADER *it,THEADER *ot);

int CIPL_Newimg(THEADER *it,int rows,int cols,int r,int g,int b);
int CIPL_Select(THEADER *T,THEADER *Sel,int xt,int yl,int xb,int yr,DATA *IDSel);
int CIPL_Dump(THEADER *it,THEADER *Sel,THEADER *ot,int xt,int yl,int xb,int yr);

int CIPL_HuePolarisation(THEADER *it,THEADER *ot,int hueper);
int CIPL_SatuVariation(THEADER *it,THEADER *ot,int satper);
int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color);
int CIPL_Str(THEADER *it,THEADER *ot,long int *hist,int gmax,int gmin,int flags);
int CIPL_Equalise(THEADER *it,THEADER *ot,long int *hist, int flags);
int CIPL_FindHistogram(THEADER *it,DATA *ID,int levels,int color);

int CIPL_Maskimg(THEADER *it,THEADER *ot,int **Mask,double factor,int flags);
int CIPL_Smoothing(THEADER *it, THEADER *ot, int flags);
int CIPL_Highboost(THEADER *it, THEADER *ot, int amp, int flags);
int CIPL_Highpass(THEADER *it, THEADER *ot, int flags);
int CIPL_Gaussavg(THEADER *it,THEADER *ot,int sigma,int flags);

int CIPL_PrewittsEdge(THEADER *it,THEADER *ot,int levels);
int CIPL_RobertsEdge(THEADER *it,THEADER *ot, int levels);
int CIPL_KirschEdge(THEADER *it,THEADER *ot,int levels);
int CIPL_SobelEdge(THEADER *it,THEADER *ot,int levels);

int CIPL_RobertsMove(THEADER *it,THEADER *ot,int max,int levels);
int CIPL_PrewittsMove(THEADER *it,THEADER *ot,int max,int levels);
int CIPL_SobelMove(THEADER *it,THEADER *ot,int max,int levels);
int CIPL_KirschMove(THEADER *it,THEADER *ot,int max,int levels);

int CIPL_MoveMask(THEADER *it,THEADER *ot,int **Mask,int max,float reci,int levels);
int CIPL_Mask(THEADER *it,THEADER *ot,int **Mask,double factor,int levels);

int CIPL_Sobel(THEADER *it,THEADER *ot,int flags);
int CIPL_Prewitts(THEADER *it,THEADER *ot,int flags);
int CIPL_Roberts(THEADER *it,THEADER *ot,int flags);
int CIPL_Kirsch(THEADER *it,THEADER *ot,int flags);
int CIPL_Canny(THEADER *it,THEADER *ot,double sigma,int lo,int hi,int flags);

int CIPL_IdealPass(THEADER *, THEADER *,int, int ,int ,int, int ,int);
int CIPL_IdealReject(THEADER *, THEADER *,int, int ,int ,int, int ,int);
int CIPL_HSIIdealPass(THEADER *, THEADER *,int ,int);
int CIPL_HSIIdealReject(THEADER *, THEADER *,int ,int);
int CIPL_Butterworth(THEADER *, THEADER *,int, int ,int ,int, int ,int ,int);
int CIPL_HSIButterworth(THEADER *, THEADER *,int, int ,int);

int CIPL_Medcut(THEADER *it,THEADER *ot,int desired_no_of_boxes);
int CIPL_Octree(THEADER *it,THEADER *ot,int no_of_levels,int desired_no_of_colors);

int CIPL_XYZfilter(THEADER *it, THEADER *ot,int nm, int range,int n);
int CIPL_readtable(char *name,double table[340][2]);
