#include "incl.h"

extern int HIPL_Getpart(THEADER *t);
extern int HIPL_Putpart(THEADER *t);
extern int HIPL_ERRNO;
extern void HIPL_Error(char *a);
int HIPL_Negative(THEADER *it,THEADER *ot);

/****************************************************************
*	FUNCTION :HIPL_Negative					*
*								*
*	INPUT	 : source and target file headers		*
*								*
*	OUTPUT	 : 0 on success					*
*		   negative value on failure			*
*								*
*    DESCRIPTION : Finds the negative of the image		*
*								*
*   EXTERNAL CALLS : 1)HIPL_Getpart				*
*		     2)HIPL_Putpart				*
*			File :HIPL_Coreio.c			*
*								*
****************************************************************/

int HIPL_Negative(THEADER *it,THEADER *ot)
{
	int i,j,k;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Getpart in copy");
			return(i);
		}
		for(j=0;j<i;j++)
			for(k=0;k<it->img.COLS;k++)
				ot->iarr[j][k]=255-it->iarr[j][k];

		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Putpart in copy");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	return(0);
}
int HIPL_Convert1(THEADER *it,THEADER *ot)
{
	int i,j,k;
	ot->ver = 0;
	do
	{
		i=HIPL_Getpart(it);
		if(i<0)
		{
			HIPL_Error("Getpart in copy");
			return(i);
		}
		for(j=0;j<i;j++)
			for(k=0;k<it->img.COLS;k++)
				ot->iarr[j][k]=it->iarr[j][k];

		i=HIPL_Putpart(ot);
		if(i<0)
		{
			HIPL_Error("Putpart in copy");
			return(i);
		}
		if(ot->P.nleft==0)
			i=-1;
	}while(i>=0);
	return(0);
}
