#include "incl.h"
extern int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
extern int HIPL_AllocateMem(THEADER *T);
extern int HIPL_Getpart(THEADER *T);
extern int HIPL_Putpart(THEADER *T);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_FreeMem(THEADER *T);
extern int HIPL_Refresh(THEADER *T,int flg);
extern void HIPL_Error(char *msg);
int HIPL_LogStretch(THEADER *it,THEADER *ot,float max,float min);

int HIPL_FftMag(THEADER *it,THEADER *ot)
{
int i,j,max;
float mag,mag1,scale,xr,xi,max1,min,val,val1;
THEADER *oi,*or,*tm;
DATA *ID;
ID = (DATA *)malloc(sizeof(DATA));
or = (THEADER *)malloc(sizeof(THEADER));
oi = (THEADER *)malloc(sizeof(THEADER));
ID->ROWS = it->img.ROWS;
ID->COLS = it->img.COLS;
ID->ver = it->ver;

i  = HIPL_Initialise(or,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(or);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_Initialise(oi,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(oi);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}

i=HIPL_FFT(it,or,oi);
if(i<0){printf("error"); return -1;}

HIPL_Refresh(or,0);
HIPL_Refresh(oi,0);

tm = (THEADER *)malloc(sizeof(THEADER));
i  = HIPL_Initialise(tm,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(tm);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
max1 = 0.0;
min =250.0;

do {
	max = HIPL_Getpart(or);
	max = HIPL_Getpart(oi);
	for(i=0;i<max;i++)
		for(j=0;j<it->img.COLS;j++)
			{
				xr=or->farr[i][j];
				xi=oi->farr[i][j];
				mag1=(float)sqrt((double)(xr*xr+xi*xi));
				mag=(float)log10((double)(1+mag1));
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
				tm->farr[i][j]=(float)mag;
			}
	max = HIPL_Putpart(tm);
	}while(or->P.nleft);

HIPL_Refresh(tm,0);
scale=255.0/(max1-min);
do {
	max = HIPL_Getpart(tm);
	for(i=0;i<max;i++)
		for(j=0;j<tm->img.COLS;j++)
			{
				val=tm->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);

HIPL_Refresh(it,0);
HIPL_FreeMem(or);
HIPL_Closeall(or);
HIPL_FreeMem(oi);
HIPL_Closeall(oi);
HIPL_FreeMem(tm);
HIPL_Closeall(tm);
free((char *)or);
free((char *)oi);
free((char *)tm);
free((char *)ID);
return 0;
}

int HIPL_FFTlh(THEADER *it,THEADER *ot,double cf,short opr)
{
int i,j,max;
float mag,scale,max1,min,val,val1;
THEADER *oi,*or,*mr,*mi,*tm;
DATA *ID;
ID = (DATA *)malloc(sizeof(DATA));
ID->ROWS = it->img.ROWS;
ID->COLS = it->img.COLS;
ID->ver = it->ver;
or = (THEADER *)malloc(sizeof(THEADER));
mr = (THEADER *)malloc(sizeof(THEADER));
mi = (THEADER *)malloc(sizeof(THEADER));
oi = (THEADER *)malloc(sizeof(THEADER));
i  = HIPL_Initialise(or,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(or);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_Initialise(oi,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(oi);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}

i=HIPL_FFT(it,or,oi);
if(i<0){printf("error"); return -1;}

HIPL_Refresh(or,0);
HIPL_Refresh(oi,0);

i  = HIPL_Initialise(mr,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(mr);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_Initialise(mi,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(mi);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}

HIPL_FFTLowhigh(or,oi,mr,mi,cf,opr);

HIPL_Refresh(mr,0);
HIPL_Refresh(mi,0);
HIPL_FreeMem(or);
HIPL_Closeall(or);
HIPL_FreeMem(oi);
HIPL_Closeall(oi);
tm = (THEADER *)malloc(sizeof(THEADER));
i  = HIPL_Initialise(tm,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(tm);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
HIPL_IFFT(mr,mi,tm);
max1 = 0.0;
min =250.0;
HIPL_Refresh(tm,0);
do {
	max = HIPL_Getpart(tm);
	for(i=0;i<max;i++)
		for(j=0;j<tm->img.COLS;j++)
			{
				mag=tm->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	}while(tm->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(tm,0);
do {
	max = HIPL_Getpart(tm);
	for(i=0;i<max;i++)
		for(j=0;j<tm->img.COLS;j++)
			{
				val=tm->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);

HIPL_Refresh(it,0);
HIPL_FreeMem(tm);
HIPL_Closeall(tm);
free((char *)or);
free((char *)oi);
free((char *)tm);
free((char *)ID);
return 0;
}


int HIPL_FFTbp(THEADER *it,THEADER *ot,double cf1,double cf2,short opr)
{
int i,j,max;
float mag,scale,max1,min,val,val1;
THEADER *oi,*or,*mr,*mi,*tm;
DATA *ID;
ID = (DATA *)malloc(sizeof(DATA));
ID->ROWS = it->img.ROWS;
ID->COLS = it->img.COLS;
ID->ver = it->ver;
or = (THEADER *)malloc(sizeof(THEADER));
mr = (THEADER *)malloc(sizeof(THEADER));
mi = (THEADER *)malloc(sizeof(THEADER));
oi = (THEADER *)malloc(sizeof(THEADER));
i  = HIPL_Initialise(or,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(or);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_Initialise(oi,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(oi);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}

i=HIPL_FFT(it,or,oi);
if(i<0){printf("error"); return -1;}

HIPL_Refresh(or,0);
HIPL_Refresh(oi,0);

i  = HIPL_Initialise(mr,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(mr);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_Initialise(mi,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(mi);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}

HIPL_FFTBand(or,oi,mr,mi,cf1,cf2,opr);

HIPL_Refresh(mr,0);
HIPL_Refresh(mi,0);
HIPL_FreeMem(or);
HIPL_Closeall(or);
HIPL_FreeMem(oi);
HIPL_Closeall(oi);
tm = (THEADER *)malloc(sizeof(THEADER));
i  = HIPL_Initialise(tm,NULL,1,1,ID);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
i  = HIPL_AllocateMem(tm);
if(i<0){
HIPL_Error("Error in initialisation"); 
return -1;
}
HIPL_IFFT(mr,mi,tm);
max1 = 0.0;
min =250.0;
HIPL_Refresh(tm,0);
do {
	max = HIPL_Getpart(tm);
	for(i=0;i<max;i++)
		for(j=0;j<tm->img.COLS;j++)
			{
				mag=tm->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	}while(tm->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(tm,0);
do {
	max = HIPL_Getpart(tm);
	for(i=0;i<max;i++)
		for(j=0;j<tm->img.COLS;j++)
			{
				val=tm->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);

HIPL_Refresh(it,0);
HIPL_Closeall(tm);
HIPL_FreeMem(tm);
free((char *)or);
free((char *)oi);
free((char *)tm);
free((char *)ID);
return 0;
}

int HIPL_FIRlh(THEADER *it,THEADER *ot,int isize,int msize,double cf,int win,int opr)
{
	THEADER *temp;
	float **mask;
	int i,max,j,rows,start,end;
	float min=256.0,max1=0.0,scale,mag,val,val1;
	DATA *ID;
	ID = (DATA *)malloc(sizeof(DATA));
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	temp=(THEADER *)malloc(sizeof(THEADER));
	i=HIPL_Initialise(temp,NULL,1,1,ID);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	i=HIPL_AllocateMem(temp);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	mask=(float **)malloc(msize*sizeof(float *));
	for(i=0;i<msize;i++)
		mask[i]=(float *)malloc(msize*sizeof(float));
	HIPL_FFTMasklh(mask,isize,msize,cf,win,opr);
	it->MROWS=temp->MROWS=msize;
	it->MORGX=temp->MORGX=msize/2;
	it->MCOLS=temp->MCOLS=msize;
	it->MORGY=temp->MORGY=msize/2;
	HIPL_Ffmaskimg(it,temp,mask);
HIPL_Refresh(temp,0);
rows = temp->img.ROWS;
start = 0;
do {
	max = HIPL_Getpart(temp);
	if(temp->P.psize == temp->img.ROWS){
		start = msize/2;
		end = max - msize/2;
		}
	else if(rows == temp->img.ROWS) { start = msize/2; end = max; }
	else if(rows <= temp->P.psize) { start = 0; end = max - msize/2; }
	for(i=start;i<end;i++)
		for(j=msize/2;j<temp->img.COLS-msize/2;j++)
			{
				mag=temp->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	rows-=max;
	}while(temp->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(temp,0);
do {
	max = HIPL_Getpart(temp);
	for(i=0;i<max;i++)
		for(j=0;j<temp->img.COLS;j++)
			{
				val=temp->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);
HIPL_Refresh(it,0);
HIPL_Refresh(ot,0);
HIPL_Closeall(temp);
HIPL_FreeMem(temp);
free((char *)ID);
free(temp);	
return 0;
}

int HIPL_IIRlh(THEADER *it,THEADER *ot,int isize,int order,double cf,int win,int opr)
{
	THEADER *temp;
	float **a,**b;
	int i,max,j,msize,rows,start,end;
	float min=256.0,max1=0.0,scale,mag,val,val1;
	DATA *ID;
	ID = (DATA *)malloc(sizeof(DATA));
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	temp=(THEADER *)malloc(sizeof(THEADER));
	i=HIPL_Initialise(temp,NULL,1,1,ID);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	i=HIPL_AllocateMem(temp);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	a=(float **)malloc((order+1)*sizeof(float *));
	for(i=0;i<=order;i++)
		a[i]=(float *)malloc((order+1)*sizeof(float));
	b=(float **)malloc((order+1)*sizeof(float *));
	for(i=0;i<=order;i++)
		b[i]=(float *)malloc((order+1)*sizeof(float));
	HIPL_IIRMasklh(a,b,isize,order,cf,win,opr);
//	for(i=0;i<order+1;i++)
//		for(j=0;j<order+1;j++)
//		printf("\n i=%d j=%d a=%f b=%f",i,j,a[i][j],b[i][j]);
	it->MROWS=temp->MROWS=order+1;
	it->MORGX=temp->MORGX=order;
	it->MCOLS=temp->MCOLS=order+1;
	it->MORGY=temp->MORGY=order;
	HIPL_IIRMaskimg(it,temp,a,b);
HIPL_Refresh(temp,0);
msize = order+1;
rows = temp->img.ROWS;
start = 0;
do {
	max = HIPL_Getpart(temp);
	if(temp->P.psize == temp->img.ROWS){
		start = msize/2;
		end = max - msize/2;
		}
	else if(rows == temp->img.ROWS) { start = msize/2; end = max; }
	else if(rows <= temp->P.psize) { start = 0; end = max - msize/2; }
	for(i=start;i<end;i++)
		for(j=msize/2;j<temp->img.COLS-msize/2;j++)
			{
				mag=temp->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	rows-=max;
	}while(temp->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(temp,0);
do {
	max = HIPL_Getpart(temp);
	for(i=0;i<max;i++)
		for(j=0;j<temp->img.COLS;j++)
			{
				val=temp->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);
HIPL_Refresh(it,0);
HIPL_Refresh(ot,0);
HIPL_Closeall(temp);
HIPL_FreeMem(temp);
free(temp);
for(i=0;i<=order;i++)
 { free(a[i]); free(b[i]); }
free(a);
free(b);	
free((char *)ID);
return 0;
}

int HIPL_IIRbp(THEADER *it,THEADER *ot,int isize,int order,double cf1,double cf2,int win,int opr)
{
	THEADER *temp;
	float **a,**b;
	int i,max,j,msize,rows,start,end;
	float min=256.0,max1=0.0,scale,mag,val,val1;
	DATA *ID;
	ID = (DATA *)malloc(sizeof(DATA));
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	temp=(THEADER *)malloc(sizeof(THEADER));
	i=HIPL_Initialise(temp,NULL,1,1,ID);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	i=HIPL_AllocateMem(temp);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	a=(float **)malloc((order+1)*sizeof(float *));
	for(i=0;i<=order;i++)
		a[i]=(float *)malloc((order+1)*sizeof(float));
	b=(float **)malloc((order+1)*sizeof(float *));
	for(i=0;i<=order;i++)
		b[i]=(float *)malloc((order+1)*sizeof(float));
	HIPL_IIRMaskbp(a,b,isize,order,cf1,cf2,win,opr);
//	for(i=0;i<order+1;i++)
//		for(j=0;j<order+1;j++)
//		printf("\n i=%d j=%d a=%f b=%f",i,j,a[i][j],b[i][j]);
	it->MROWS=temp->MROWS=order+1;
	it->MORGX=temp->MORGX=order;
	it->MCOLS=temp->MCOLS=order+1;
	it->MORGY=temp->MORGY=order;
	HIPL_IIRMaskimg(it,temp,a,b);
HIPL_Refresh(temp,0);
msize = order+1;
rows = temp->img.ROWS;
start = 0;
do {
	max = HIPL_Getpart(temp);
	if(temp->P.psize == temp->img.ROWS){
		start = msize/2;
		end = max - msize/2;
		}
	else if(rows == temp->img.ROWS) { start = msize/2; end = max; }
	else if(rows <= temp->P.psize) { start = 0; end = max - msize/2; }
	for(i=start;i<end;i++)
		for(j=msize/2;j<temp->img.COLS-msize/2;j++)
			{
				mag=temp->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	rows-=max;
	}while(temp->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(temp,0);
do {
	max = HIPL_Getpart(temp);
	for(i=0;i<max;i++)
		for(j=0;j<temp->img.COLS;j++)
			{
				val=temp->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);
HIPL_Refresh(it,0);
HIPL_Refresh(ot,0);
HIPL_FreeMem(temp);
HIPL_Closeall(temp);
free(temp);
for(i=0;i<=order;i++)
 { free( a[i] ); free( b[i] ); }
free(a);
free(b);	
free((char *)ID);
return 0;
}

int HIPL_FIRbp(THEADER *it,THEADER *ot,int isize,int msize,double cf1,double cf2,int win,int opr)
{
	THEADER *temp;
	float **mask;
	int i,max,j,rows,start,end;
	float min=256.0,max1=0.0,scale,mag,val,val1;
	DATA *ID;
	ID = (DATA *)malloc(sizeof(DATA));
	ID->ROWS = it->img.ROWS;
	ID->COLS = it->img.COLS;
	ID->ver = it->ver;
	temp=(THEADER *)malloc(sizeof(THEADER));
	i=HIPL_Initialise(temp,NULL,1,1,ID);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	i=HIPL_AllocateMem(temp);
	if(i<0){
	HIPL_Error("Error in initialisation"); 
	return -1;
	}
	mask=(float **)malloc(msize*sizeof(float *));
	for(i=0;i<msize;i++)
		mask[i]=(float *)malloc(msize*sizeof(float));
	HIPL_FFTMaskbp(mask,isize,msize,cf1,cf2,win,opr);
	it->MROWS=temp->MROWS=msize;
	it->MORGX=temp->MORGX=msize/2;
	it->MCOLS=temp->MCOLS=msize;
	it->MORGY=temp->MORGY=msize/2;
	HIPL_Ffmaskimg(it,temp,mask);
HIPL_Refresh(temp,0);
rows = temp->img.ROWS;
start = 0;
do {
	max = HIPL_Getpart(temp);
	if(temp->P.psize == temp->img.ROWS){
		start = msize/2;
		end = max - msize/2;
		}
	else if(rows == temp->img.ROWS) { start = msize/2; end = max; }
	else if(rows <= temp->P.psize) { start = 0; end = max - msize/2; }
	for(i=start;i<end;i++)
		for(j=msize/2;j<temp->img.COLS-msize/2;j++)
			{
				mag=temp->farr[i][j];
				if(mag>max1) max1=mag;
				if(mag<min) min = mag;
			}
	rows-=max;
	}while(temp->P.nleft);
scale=255.0/(max1-min);
HIPL_Refresh(temp,0);
do {
	max = HIPL_Getpart(temp);
	for(i=0;i<max;i++)
		for(j=0;j<temp->img.COLS;j++)
			{
				val=temp->farr[i][j];
				val1=(val-min)*scale;
				ot->iarr[i][j]=(int)val1;
			}
	HIPL_Putpart(ot);
}while(ot->P.nleft);
HIPL_Refresh(it,0);
HIPL_Refresh(ot,0);
HIPL_FreeMem(temp);
HIPL_Closeall(temp);
free(temp);	
free((char *)ID);
return 0;
}

int HIPL_LogStretch(THEADER *it,THEADER *ot,float max,float min)
{
	double scale,den;
	int i,j,rows;
	den = log10((double)(max-min+1));
	scale = (double)255.0/den;
	//printf("%f,%f,%f,%f",scale,max,min,den);
	fflush(stdout); 
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	do {
		rows = HIPL_Getpart(it);
		for(i=0;i<rows;i++)
			for(j=0;j<it->img.COLS;j++){
				ot->iarr[i][j] = (int)(scale*(log10(it->farr[i][j]-min+1)));
				if(ot->iarr[i][j] > 255) ot->iarr[i][j] = 255;
				if(ot->iarr[i][j] < 0) ot->iarr[i][j] = 0;
				}
		HIPL_Putpart(ot);
	}while(ot->P.nleft);
	HIPL_Refresh(it,0);
	HIPL_Refresh(ot,0);
	return 0;
}
