#include <stdio.h>
#include "incl.h"
extern void HIPL_Error(char *msg);
extern int HIPL_Closeall(THEADER *T1);
extern int HIPL_FreeMem(THEADER *T);
extern int HIPL_StoreResult(char *name,THEADER *T);
extern int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
extern int HIPL_AllocateMem(THEADER *T);
extern int CIPL_Scale(THEADER *it,THEADER *ot,float factor,int color);


int huepolarise(HEADER *h1,HEADER *h2,int per,int *arr,int n) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_HuePolarisation1(TEMP,TEMP1,per,arr,n);
	CIPL_hsitorgb(TEMP1,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int satuvariation(HEADER *h1,HEADER *h2,int per) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_SatuVariation(TEMP,TEMP1,per);
	CIPL_hsitorgb(TEMP1,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}

int satuequalise(HEADER *h1,HEADER *h2) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	CIPL_rgbtohsi(h1->T,TEMP);
	CIPL_Scale(TEMP,TEMP1,0.1,2);
	CIPL_FindHistogram(TEMP1,ID,100,2);
	HIPL_Refresh(TEMP,0);
	i=CIPL_Equalise(TEMP1,TEMP,ID->hist);
	HIPL_Refresh(TEMP1,0);
	CIPL_Scale(TEMP,TEMP1,10,2);
	CIPL_hsitorgb(TEMP1,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int satustretch(HEADER *h1,HEADER *h2,int gmax,int gmin) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	CIPL_rgbtohsi(h1->T,TEMP);
	CIPL_Scale(TEMP,TEMP1,0.1,2);
	CIPL_FindHistogram(TEMP1,ID,100,2);
	HIPL_Refresh(TEMP,0);
	i=CIPL_Str(TEMP1,TEMP,ID->hist,gmax,gmin);
	HIPL_Refresh(TEMP1,0);
	CIPL_Scale(TEMP,TEMP1,10,2);
	CIPL_hsitorgb(TEMP1,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int extractfromPPM(HEADER *h1,HEADER *h2,char *model,int flags) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	if(flags !=1 && flags != 2 && flags != 4)
	{	HIPL_ERRNO=-32;
		HIPL_Error("Error in Operation");
		return -1;
	} 
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	if(strcmp(model,"RGB")==0)
	{	i=CIPL_ExtractfromPPM(h1->T,h2->T,flags>>1);
	}
	else if(strcmp(model,"HSV")==0)
	{	CIPL_rgbtohsi(h1->T,TEMP);
		if(flags == 1)
			i=CIPL_ExtractfromPPM(TEMP,h2->T,0);
		else if (flags == 2)
		{	CIPL_Scale(TEMP,TEMP1,255.0/3600.0,2);
			i=CIPL_ExtractfromPPM(TEMP1,h2->T,1);
		}
		else if (flags == 4)
		{	CIPL_Scale(TEMP,TEMP1,255.0/1000.0,4);
			i=CIPL_ExtractfromPPM(TEMP1,h2->T,2);
		}
	}
	else if(strcmp(model,"XYZ")==0)
	{	CIPL_rgbtoxyz(h1->T,TEMP);
		i=CIPL_ExtractfromPPM(TEMP,h2->T,flags>>1);
	}
	else if(strcmp(model,"YIQ")==0)
	{	CIPL_rgbtoyiq(h1->T,TEMP);
		i=CIPL_ExtractfromPPM(TEMP,h2->T,flags>>1);
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int medcut(HEADER *h1,HEADER *h2,int boxes) {
	int i;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=CIPL_Medcut(h1->T,h2->T,boxes);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}
int octree(HEADER *h1,HEADER *h2,int levels,int colors) {
	int i;
	
	if( (colors & (colors -1))!=0)
	{	HIPL_ERRNO=-33;
		HIPL_Error("Error in Operation");
		return -1;
	}
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=CIPL_Octree(h1->T,h2->T,levels,colors);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}
int idealpass(HEADER *h1,HEADER *h2,int x,int y,int z,int bx,int by,int bz,char *model) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(strcmp(model,"RGB")==0)
	{	i=CIPL_IdealPass(h1->T,h2->T,x,y,z,bx,by,bz);
	}
	else if(strcmp(model,"HSV")==0)
	{	CIPL_rgbtohsi(h1->T,TEMP);
		i=CIPL_IdealPass(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_hsitorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"XYZ")==0)
	{	CIPL_rgbtoxyz(h1->T,TEMP);
		i=CIPL_IdealPass(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_xyztorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"YIQ")==0)
	{	CIPL_rgbtoyiq(h1->T,TEMP);
		i=CIPL_IdealPass(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_yiqtorgb(TEMP1,h2->T);
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int idealreject(HEADER *h1,HEADER *h2,int x,int y,int z,int bx,int by,int bz,char *model) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(strcmp(model,"RGB")==0)
	{	i=CIPL_IdealReject(h1->T,h2->T,x,y,z,bx,by,bz);
	}
	else if(strcmp(model,"HSV")==0)
	{	CIPL_rgbtohsi(h1->T,TEMP);
		i=CIPL_IdealReject(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_hsitorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"XYZ")==0)
	{	CIPL_rgbtoxyz(h1->T,TEMP);
		i=CIPL_IdealReject(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_xyztorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"YIQ")==0)
	{	CIPL_rgbtoyiq(h1->T,TEMP);
		i=CIPL_IdealReject(TEMP,TEMP1,x,y,z,bx,by,bz);
		CIPL_yiqtorgb(TEMP1,h2->T);
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int butterworthpass(HEADER *h1,HEADER *h2,int x,int y,int z,int bx,int by,int bz,int n,char *model) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(strcmp(model,"RGB")==0)
	{	i=CIPL_ButterworthPass(h1->T,h2->T,x,y,z,bx,by,bz,n);
	}
	else if(strcmp(model,"HSV")==0)
	{	CIPL_rgbtohsi(h1->T,TEMP);
		i=CIPL_ButterworthPass(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_hsitorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"XYZ")==0)
	{	CIPL_rgbtoxyz(h1->T,TEMP);
		i=CIPL_ButterworthPass(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_xyztorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"YIQ")==0)
	{	CIPL_rgbtoyiq(h1->T,TEMP);
		i=CIPL_ButterworthPass(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_yiqtorgb(TEMP1,h2->T);
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int butterworthreject(HEADER *h1,HEADER *h2,int x,int y,int z,int bx,int by,int bz,int n,char *model) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(strcmp(model,"RGB")==0)
	{	i=CIPL_ButterworthReject(h1->T,h2->T,x,y,z,bx,by,bz,n);
	}
	else if(strcmp(model,"HSV")==0)
	{	CIPL_rgbtohsi(h1->T,TEMP);
		i=CIPL_ButterworthReject(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_hsitorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"XYZ")==0)
	{	CIPL_rgbtoxyz(h1->T,TEMP);
		i=CIPL_ButterworthReject(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_xyztorgb(TEMP1,h2->T);
	}
	else if(strcmp(model,"YIQ")==0)
	{	CIPL_rgbtoyiq(h1->T,TEMP);
		i=CIPL_ButterworthReject(TEMP,TEMP1,x,y,z,bx,by,bz,n);
		CIPL_yiqtorgb(TEMP1,h2->T);
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int hsiidealpass(HEADER *h1,HEADER *h2,int h,int bh) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_HSIIdealPass(TEMP,TEMP1,h,bh);
	CIPL_hsitorgb(TEMP1,h2->T);
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int hsiidealreject(HEADER *h1,HEADER *h2,int h,int bh) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_HSIIdealReject(TEMP,TEMP1,h,bh);
	CIPL_hsitorgb(TEMP1,h2->T);
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int hsibutterworthpass(HEADER *h1,HEADER *h2,int h,int bh,int n) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_HSIButterworthPass(TEMP,TEMP1,h,bh,n);
	CIPL_hsitorgb(TEMP1,h2->T);
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int hsibutterworthreject(HEADER *h1,HEADER *h2,int h,int bh,int n) {
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	CIPL_rgbtohsi(h1->T,TEMP);
	i=CIPL_HSIButterworthReject(TEMP,TEMP1,h,bh,n);
	CIPL_hsitorgb(TEMP1,h2->T);
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int xyzfilter(HEADER *h1,HEADER *h2,int nm,int bw,int n) {
	int i;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
			
	i=CIPL_XYZfilter(h1->T,h2->T,nm,bw,n);
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}
