#include"err_hipl.h"
#define ISUNIX 1 
#define  TIFF 20
#define  PGM  10
#define  RAW  30
#define  UNKNOWN 99 
#define  BINARY 0
#define  ASCII 1

typedef struct{
	int psize;
	int rowsread;
	int nleft;
	int put;
}parts;

typedef struct{
	int ROWS;
	int COLS;
	int levels;
	int TYPE;
}IMGHEADER;

typedef struct{
	int ROWS;
	int COLS;
	short ver;
	long int hist[257];
	float inertia;
	float uniformity;
	float entropy;
	float roughness;
	int maxg;
	int ming;
	int mean;
	int dev;
}DATA;

typedef struct {
	FILE *fptr;
	char tempfname[25];
	int **iarr;
	float **farr;
	int MORGX;
	int MORGY;
	int MROWS;
	int MCOLS;	
	parts P;
	short dfflg;
	short arrtype;
	short ver;
	short memflag;
	IMGHEADER img;
}THEADER;

typedef struct {
	char fname[100];
	THEADER *T;
	DATA *ID;
} HEADER;

typedef struct {
          int label;
          int xmin;
          int ymin;
          int xmax;
          int ymax;
} MBRSTRUCT;

extern int HIPL_ERRNO;
extern char WINERR[];
//int MAXMEM=350;
//int MAXMEM1=350;
int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
int HIPL_AllocateMem(THEADER *T);
int HIPL_Getpart(THEADER *T);
int HIPL_Putpart(THEADER *T);
void HIPL_Error(char *msg);
int HIPL_Closeall(THEADER *T);
int HIPL_FreeMem(THEADER *T);
int HIPL_StoreResult(char *name,THEADER *T);
int HIPL_Refresh(THEADER *T,int flg);
void HIPL_Setmemory(int Memory);
int HIPL_ReadImagePGM(FILE *,THEADER *t);
int HIPL_GetImageHeaderPGM(FILE *, THEADER *t);
int HIPL_GetImageTypePGM(THEADER *t);
int HIPL_GetImageRowsPGM(THEADER *t);
int HIPL_GetImageColsPGM(THEADER *t);
int HIPL_PutImageHeaderPGM(FILE *fp,THEADER *T);
int HIPL_WriteImagePGM(FILE *fd, THEADER *t);

int HIPL_Transpose(THEADER *it,THEADER *ot);
int HIPL_Bpslice(THEADER *it,THEADER *ot,int bit);
int HIPL_Range(THEADER *it,THEADER *ot,int lo,int hi);
int HIPL_Thresh(THEADER *it,THEADER *ot,int grey);
int HIPL_Mirror(THEADER *it,THEADER *ot);
int HIPL_SIAvg(THEADER *it1,THEADER *it2,THEADER *ot);
int HIPL_SIMax(THEADER *it1,THEADER *it2,THEADER *ot);
int HIPL_Differ(THEADER *it1,THEADER *it2,THEADER *ot);

int HIPL_Dilate(THEADER *it,THEADER *ot,int **Mask);
int HIPL_Close(THEADER *it,THEADER *ot,int **Mask);
int HIPL_Open(THEADER *it,THEADER *ot,int **Mask);
int HIPL_Erode(THEADER *it,THEADER *ot,int **Mask);
int HIPL_BiClose(THEADER *it,THEADER *ot,int **Mask);
int HIPL_BiOpen(THEADER *it,THEADER *ot,int **Mask);
int HIPL_BiErode(THEADER *it,THEADER *ot,int **Mask);
int HIPL_BiDilate(THEADER *it,THEADER *ot,int **Mask);

int HIPL_Canny(THEADER *it,THEADER *ot,double sigma,int lo,int hi);
int HIPL_Connect(THEADER *it,THEADER *ot);
int HIPL_Convert1(THEADER *it,THEADER *ot);
int HIPL_Negative(THEADER *it,THEADER *ot);
int HIPL_Double(THEADER *it,THEADER *ot);
int HIPL_Thinning(THEADER *it,THEADER *ot);
int HIPL_RangeStretch(THEADER *it,THEADER *output,long int hist[257],int iter);

int HIPL_FftMag(THEADER *it,THEADER *ot);
int HIPL_FFTbp(THEADER *it,THEADER *ot,double cf1,double cf2,short opr);
int HIPL_FFTlh(THEADER *it,THEADER *ot,double cf,short opr);
int HIPL_FIRbp(THEADER *it,THEADER *ot,int isize,int msize,double cf1,double cf2,int win,int opr);
int HIPL_FIRlh(THEADER *it,THEADER *ot,int isize,int msize,double cf,int win,int opr);
int HIPL_IIRbp(THEADER *it,THEADER *ot,int isize,int order,double cf1,double cf2,int win,int opr);
int HIPL_IIRlh(THEADER *it,THEADER *ot,int isize,int order,double cf,int win,int opr);

int HIPL_Gaussavg(THEADER *it,THEADER *ot,int sigma);
int HIPL_Lstretch(THEADER *it,THEADER *ot);
int HIPL_FindHistogram(THEADER *it,long int hist[257]);
int HIPL_ImgData(THEADER *it,long int hist[257],DATA *ID);
int HIPL_Equalise( THEADER *it,THEADER *ot,long int hist[257]);
int HIPL_Str(THEADER *it,THEADER *ot,long int hist[257],int gmax,int gmin);

int HIPL_Prewitts(THEADER *it,THEADER *ot);
int HIPL_Roberts(THEADER *it,THEADER *ot);
int HIPL_Kirsch(THEADER *it,THEADER *ot);
int HIPL_IIRMaskimg(THEADER *it,THEADER *ot,float **a,float **b);
int HIPL_Sobel(THEADER *it,THEADER *ot);
int HIPL_Maskimg(THEADER *it,THEADER *ot,int **Mask,double factor);
int HIPL_Fmaskimg(THEADER *it,THEADER *ot,double **Mask,double factor);
int HIPL_Medianmask(THEADER *it,THEADER *ot);

int HIPL_Newimg(THEADER *it,int rows,int cols,int grey);
int HIPL_Select(THEADER *T,THEADER *Sel,int xt,int yl,int xb,int yr,DATA *IDSel);
int HIPL_Dump(THEADER *it,THEADER *Sel,THEADER *ot,int xt,int yl,int xb,int yr);

int HIPL_GLCM(THEADER *T,int dist,int angle,DATA *ID);
int HIPL_ReadImage(THEADER *T, char *name, short io, short arr_type, DATA *ID);
int HIPL_SpecifyOutParams(DATA *ID, int NRows, int NCols, int Type);
int HIPL_CreateOutImage(THEADER *t, short arr_type, int Type, DATA *ID,
			int NRows, int NCols);
