#include <stdio.h>
#include "incl.h"
extern void HIPL_Error(char *msg);
extern int HIPL_ImgData(THEADER *T,long int hist[257],DATA *);
extern int HIPL_FindHistogram(THEADER *it,long int hist[257]);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_FreeMem(THEADER *T);
extern int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
extern int HIPL_AllocateMem(THEADER *T);
extern int HIPL_StoreResult(char *name,THEADER *T);
extern int CIPL_Scale(THEADER *it,THEADER *ot,float scale,int flags);
int texcall(HEADER *h1,int dist,int angle) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_GLCM(h1->T,dist,angle,h1->ID);
	if(i<0) return -1;
	HIPL_FreeMem(h1->T);
	return 0;
}
int newimg(HEADER *h1,int rows,int cols,int grey,int green,int blue,int flag) {
	int i;
	if(flag == 0)
		i=HIPL_Newimg(h1->T,rows,cols,grey);
	else
		i=CIPL_Newimg(h1->T,rows,cols,grey,green,blue);
	if(i<0) return -1;
	i=HIPL_StoreResult(h1->fname,h1->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	HIPL_FreeMem(h1->T);
	HIPL_Closeall(h1->T);
	return 0;
}
int histcall(HEADER *h1,char *model,int flags) {
	int i,max;
	
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	if(flags !=1 && flags != 2 && flags != 4)
	{	HIPL_ERRNO=-32;
		HIPL_Error("Error in Operation");
		return -1;
	} 
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	if(h1->T->img.TYPE == PGM)
	{	h1->ID->hist = (long int*) malloc (257 * sizeof(long int));
		for(i=0;i<256;i++)
			h1->ID->hist[i]=0;
		i=HIPL_FindHistogram(h1->T,h1->ID->hist);
	}
	else
	{	if( flags !=1 && flags !=2 && flags !=4)
			return -1;
		if(strcmp(model,"HSV")==0)
		{	if(flags == 2)
				max = 360;
			else if(flags == 4)
				max = 150;
			else 
				max = 256;
		}
		else
			max = 256;
		
		h1->ID->hist = (long int*) malloc ((max+1) * sizeof(long int));
		for(i=0;i<max;i++)
			h1->ID->hist[i]=0;
		if(strcmp(model,"RGB")==0)
		{
			i=CIPL_FindHistogram(h1->T,h1->ID,max,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			if(flags == 2 || flags == 4)
			{	CIPL_Scale(TEMP,TEMP1,0.1,flags);
				i=CIPL_FindHistogram(TEMP1,h1->ID,max,flags);
			}
			else
			{	i=CIPL_FindHistogram(TEMP,h1->ID,max,flags);
			}
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,h1->ID,max,flags);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,h1->ID,max,flags);
		}
		
	}
	if(i<0) return -1;
	i=HIPL_ImgData(h1->T,h1->ID->hist,h1->ID);
	if(i<0) return -1;
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int histeqcall(HEADER *h1,HEADER *h2,char *model,int flags)
{
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	if(flags !=1 && flags != 2 && flags != 4)
	{	HIPL_ERRNO=-32;
		HIPL_Error("Error in Operation");
		return -1;
	} 
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	if(h1->T->img.TYPE == PGM)
	{	i=CIPL_FindHistogram(h1->T,h1->ID,255,1);
		if(i<0) return -1;
		i=HIPL_Equalise(h1->T,h2->T,h1->ID->hist);
		if(i<0) return -1;
	}
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_FindHistogram(h1->T,ID,256,flags);
			
			if(i<0) return -1;
			i=CIPL_Equalise(h1->T,h2->T,ID->hist,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	
			CIPL_rgbtohsi(h1->T,TEMP);
			if(flags == 2 || flags == 4)
			{	CIPL_Scale(TEMP,TEMP1,0.1,flags);
				HIPL_Refresh(TEMP,0);
				if(flags == 2)
					i=CIPL_FindHistogram(TEMP1,ID,360,flags);
				else
					i=CIPL_FindHistogram(TEMP1,ID,100,flags);
				if(i<0) return -1;
				i=CIPL_Equalise(TEMP1,TEMP,ID->hist,flags);
				HIPL_Refresh(TEMP1,0);
				CIPL_Scale(TEMP,TEMP1,10,flags);
			}
			else
			{	i=CIPL_FindHistogram(TEMP,ID,256,flags);
				if(i<0) return -1;
				i=CIPL_Equalise(TEMP,TEMP1,ID->hist,flags);
			}
			CIPL_hsitorgb(TEMP1,h2->T);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	
			CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,ID,256,flags);
			if(i<0) return -1;
			i=CIPL_Equalise(TEMP,TEMP1,ID->hist,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else
		{	
			CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,ID,256,flags);
			if(i<0) return -1;
			i=CIPL_Equalise(TEMP,TEMP1,ID->hist,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
	}
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	HIPL_FreeMem(h1->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h2->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return(0);
}
int histstcall(HEADER *h1,HEADER *h2,int gmax,int gmin,char *model,int flags)
{
	int i;
	
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	if(flags !=1 && flags != 2 && flags != 4)
	{	HIPL_ERRNO=-32;
		HIPL_Error("Error in Operation");
		return -1;
	} 
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);	
	
	if(h1->T->img.TYPE == PGM)
	{	i=CIPL_FindHistogram(h1->T,h1->ID,255,1);
		if(i<0) return -1;
		i=HIPL_Str(h1->T,h2->T,h1->ID->hist,gmax,gmin);
	}
	else
	{	if(strcmp(model,"RGB")==0)
		{	i=CIPL_FindHistogram(h1->T,ID,255,flags);
			if(i<0) return -1;
			i=CIPL_Str(h1->T,h2->T,ID->hist,gmax,gmin,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	
			CIPL_rgbtohsi(h1->T,TEMP);
			if(flags == 2 || flags == 4)
			{	CIPL_Scale(TEMP,TEMP1,0.1,flags);
				HIPL_Refresh(TEMP,0);
				if(flags == 2)
					i=CIPL_FindHistogram(TEMP1,ID,360,flags);
				else
					i=CIPL_FindHistogram(TEMP1,ID,100,flags);
				if(i<0) return -1;
				i=CIPL_Str(TEMP1,TEMP,ID->hist,gmax,gmin,flags);
				CIPL_Scale(TEMP,TEMP1,10,flags);
			}
			else
			{	i=CIPL_FindHistogram(TEMP,ID,255,flags);
				if(i<0) return -1;
				i=CIPL_Str(TEMP,TEMP1,ID->hist,gmax,gmin,flags);
			}
			CIPL_hsitorgb(TEMP1,h2->T);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	
			CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,ID,255,flags);
			if(i<0) return -1;
			i=CIPL_Str(TEMP,TEMP1,ID->hist,gmax,gmin,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else
		{	
			CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_FindHistogram(TEMP,ID,255,flags);
			if(i<0) return -1;
			i=CIPL_Str(TEMP,TEMP1,ID->hist,gmax,gmin,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	HIPL_FreeMem(h1->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h2->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return(0);
}

int logstretch(HEADER *h1,HEADER *h2,char *model,int flags)
{
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	
	if(flags !=1 && flags != 2 && flags != 4)
	{	HIPL_ERRNO=-32;
		HIPL_Error("Error in Operation");
		return -1;
	} 
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(h1->T->img.TYPE==PGM)
	{		i=CIPL_FindHistogram(h1->T,h1->ID,256,1);
			if(i<0) return -1;
			//HIPL_FindHistogram(h1->T,h1->ID->hist);
			i=HIPL_ImgData(h1->T,h1->ID->hist,h1->ID);
			if(i<0) return -1;
			i=HIPL_Lstretch(h1->T,h2->T);
	}
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Lstretch(h1->T,h2->T,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	
			CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Lstretch(TEMP,TEMP1,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	
			CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Lstretch(TEMP,TEMP1,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else
		{	
			CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Lstretch(TEMP,TEMP1,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	HIPL_FreeMem(h1->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h2->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return(0);
}

