#include <stdio.h>
#include "incl.h"
extern void HIPL_Error(char *msg);
extern int HIPL_Closeall(THEADER *T1);
extern int HIPL_FreeMem(THEADER *T);
extern int HIPL_Dilate(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_Erode(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_Open(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_Close(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_BiDilate(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_BiErode(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_BiOpen(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_BiClose(THEADER *T1,THEADER *T2,int **mask);
extern int HIPL_StoreResult(char *name,THEADER *T);
extern int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
extern int HIPL_AllocateMem(THEADER *T);

extern int CIPL_Fmaskimg(THEADER *it,THEADER *ot,double **Mask, double den,int flags);

int morphcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int **mask,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	h1->T->MROWS = h2->T->MROWS = rows;
	h1->T->MCOLS = h2->T->MCOLS = cols;
	h1->T->MORGX = h2->T->MORGX = orgx;
	h1->T->MORGY = h2->T->MORGY = orgy;
	switch(opr) {
		case 0:
		i=HIPL_Dilate(h1->T,h2->T,mask);
		break;
		case 1:
		i=HIPL_Erode(h1->T,h2->T,mask);
		break;
		case 2:
		i=HIPL_Open(h1->T,h2->T,mask);
		break;
		case 3:
		i=HIPL_Close(h1->T,h2->T,mask);
		break;
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	return 0;
}

int bimorphcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int **mask,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	h1->T->MROWS = h2->T->MROWS = rows;
	h1->T->MCOLS = h2->T->MCOLS = cols;
	h1->T->MORGX = h2->T->MORGX = orgx;
	h1->T->MORGY = h2->T->MORGY = orgy;
	switch(opr) {
		case 0:
		i=HIPL_BiDilate(h1->T,h2->T,mask);
		if(i<0) return -1;
		break;
		case 1:
		i=HIPL_BiErode(h1->T,h2->T,mask);
		if(i<0) return -1;
		break;
		case 2:
		i=HIPL_BiOpen(h1->T,h2->T,mask);
		if(i<0) return -1;
		break;
		case 3:
		i=HIPL_BiClose(h1->T,h2->T,mask);
		if(i<0) return -1;
		break;
	}
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	return 0;
}


int thinning(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_Thinning(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	return 0;
}
int movemaskcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int **mask,double den,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =rows;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =cols;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =orgx;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =orgy;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Maskimg(h1->T,h2->T,mask,den);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Maskimg(h1->T,h2->T,mask,den,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Maskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Maskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Maskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
			
	}
	if(i<0) return -1;
	
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int fmovemaskcall(HEADER *h1,HEADER *h2,double **mask,double den,char *model,int flags) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =3;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =3;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =1;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =1;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Fmaskimg(h1->T,h2->T,mask,den);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Fmaskimg(h1->T,h2->T,mask,den,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Fmaskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Fmaskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Fmaskimg(TEMP,TEMP1,mask,den,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
			
	}
	
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	return 0;
}

int pcannycall(HEADER *h1,HEADER *h2,double sigma,int lo,int hi,char *model,int flags)
 {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	
	if(h1->T->img.TYPE == PGM)
		i=HIPL_Canny(h1->T,h2->T,sigma,lo,hi);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Canny(h1->T,h2->T,sigma,lo,hi,flags);
			
		}
		else  if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Canny(TEMP,TEMP1,sigma,lo,hi,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else  if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Canny(TEMP,TEMP1,sigma,lo,hi,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
		else  if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Canny(TEMP,TEMP1,sigma,lo,hi,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
	}
	
	if(i<0) return -1;
	
	i=HIPL_StoreResult(h2->fname,h2->T);
	
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}

int sobel(HEADER *h1,HEADER *h2,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =3;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =3;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =1;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =1;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Sobel(h1->T,h2->T);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Sobel(h1->T,h2->T,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Sobel(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Sobel(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Sobel(TEMP,h2->T,flags);
			
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int gaussian(HEADER *h1,HEADER *h2,int s,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =3;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =3;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =1;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =1;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Gaussavg(h1->T,h2->T,s);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Gaussavg(h1->T,h2->T,s,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Gaussavg(TEMP,TEMP1,s,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Gaussavg(TEMP,TEMP1,s,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Gaussavg(TEMP,TEMP1,s,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int kirsch(HEADER *h1,HEADER *h2,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =3;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =3;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =1;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =1;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Kirsch(h1->T,h2->T);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Kirsch(h1->T,h2->T,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Kirsch(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Kirsch(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Kirsch(TEMP,h2->T,flags);
			
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int roberts(HEADER *h1,HEADER *h2,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =2;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =2;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =0;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =0;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Roberts(h1->T,h2->T);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Roberts(h1->T,h2->T,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Roberts(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Roberts(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Roberts(TEMP,h2->T,flags);
			
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}

int prewitts(HEADER *h1,HEADER *h2,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =3;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =3;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =1;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =1;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Prewitts(h1->T,h2->T);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Prewitts(h1->T,h2->T,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Prewitts(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Prewitts(TEMP,h2->T,flags);
			
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Prewitts(TEMP,h2->T,flags);
			
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
int movemedcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int flags,char *model) {
	int i;
	THEADER *TEMP, *TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	} 
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	h1->T->MROWS = h2->T->MROWS = TEMP->MROWS = TEMP1->MROWS =rows;
	h1->T->MCOLS = h2->T->MCOLS = TEMP->MCOLS = TEMP1->MCOLS =cols;
	h1->T->MORGX = h2->T->MORGX = TEMP->MORGX = TEMP1->MORGX =orgx;
	h1->T->MORGY = h2->T->MORGY = TEMP->MORGY = TEMP1->MORGY =orgy;
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Medianmask(h1->T,h2->T);
	else
	{	if(strcmp(model,"RGB")==0)
		{	
			i=CIPL_Medianmask(h1->T,h2->T,flags);
			
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Medianmask(TEMP,TEMP1,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Medianmask(TEMP,TEMP1,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Medianmask(TEMP,TEMP1,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
			
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	} 
	HIPL_FreeMem(h2->T);
	HIPL_Closeall(h2->T);
	HIPL_FreeMem(h1->T);
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}
