#include <stdio.h>
#include "incl.h"
extern void HIPL_Error(char *msg);
extern int HIPL_Closeall(THEADER *T1);
extern int HIPL_FreeMem(THEADER *T);
extern int HIPL_Negative(THEADER *T1,THEADER *T2);
extern int HIPL_StoreResult(char *name,THEADER *T);
extern int HIPL_WriteImagePGM(FILE *fptr,HEADER *H);
extern int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
extern int HIPL_AllocateMem(THEADER *T);

int convert1(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_Convert1(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}
int negitive(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE==PGM)
		i=HIPL_Negative(h1->T,h2->T);
	else
		i=CIPL_Negative(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int concomp(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_Connect(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int fft(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_FftMag(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int fftlhbw(HEADER *h1,HEADER *h2,double cf,short opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_FFTlh(h1->T,h2->T,cf,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int timemask(HEADER *h1,HEADER *h2,int isize,int msize,double cf,int win,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_FIRlh(h1->T,h2->T,isize,msize,cf,win,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int iirmask(HEADER *h1,HEADER *h2,int isize,int order,double cf,int win,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_IIRlh(h1->T,h2->T,isize,order,cf,win,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int iirbpmask(HEADER *h1,HEADER *h2,int isize,int order,double cf1,double cf2,int win,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_IIRbp(h1->T,h2->T,isize,order,cf1,cf2,win,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int timebpmask(HEADER *h1,HEADER *h2,int isize,int msize,double cf1,double cf2,int win,int opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_FIRbp(h1->T,h2->T,isize,msize,cf1,cf2,win,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int fftlhbp(HEADER *h1,HEADER *h2,double cf1,double cf2,short opr) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_FFTbp(h1->T,h2->T,cf1,cf2,opr);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int autoscall(HEADER *h1,HEADER *h2,int iter) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_RangeStretch(h1->T,h2->T,h1->ID->hist,iter);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int dbcall(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	
	if(h1->T->img.TYPE == PGM)
		i=HIPL_Double(h1->T,h2->T);
	else
		i=CIPL_Double(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int horiflip(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM )
		i=HIPL_HFlip(h1->T,h2->T);
	else
		i=CIPL_HFlip(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int threshold(HEADER *h1,HEADER *h2,int r,int g,int b,char *model,int flags)
{
	int i;
	THEADER *TEMP,*TEMP1;
	DATA *ID;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	TEMP1 = (THEADER *)malloc(sizeof(THEADER));
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	i  = HIPL_Initialise(TEMP1,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP1);
	if(h1->T->img.TYPE == PGM)
	{	i=HIPL_Thresh(h1->T,h2->T,r);
	}
	else
	{	if(strcmp(model,"RGB")==0)
		{	i=CIPL_Thresh(h1->T,h2->T,r,g,b,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Thresh(TEMP,TEMP1,r,g,b,flags);
			CIPL_hsitorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Thresh(TEMP,TEMP1,r,g,b,flags);
			CIPL_xyztorgb(TEMP1,h2->T);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Thresh(TEMP,TEMP1,r,g,b,flags);
			CIPL_yiqtorgb(TEMP1,h2->T);
		}
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP1);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	free(TEMP1);
	return 0;
}

int rangecall(HEADER *h1,HEADER *h2,int lo,int hi) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_Range(h1->T,h2->T,lo,hi);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int bpslice(HEADER *h1,HEADER *h2,int bit,char *model,int flags) {
	int i;
	THEADER *TEMP;
	DATA *ID;
	
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	
	ID = (DATA *)malloc(sizeof(DATA));
	TEMP = (THEADER *)malloc(sizeof(THEADER));
	
	ID->ROWS = h1->T->img.ROWS;
	ID->COLS = h1->T->img.COLS;
	ID->ver = h1->T->ver;
	ID->type=h1->T->img.TYPE;
	
	i  = HIPL_Initialise(TEMP,NULL,1,0,ID);
	if(i<0){
		HIPL_Error("Error in initialisation"); 
		return -1;
	}
	HIPL_AllocateMem(TEMP);
	
	if(h1->T->img.TYPE == PGM)
	{
		i=HIPL_Bpslice(h1->T,h2->T,bit);
	}
	else
	{	if(strcmp(model,"RGB")==0)
		{	i=CIPL_Bpslice(h1->T,h2->T,bit,flags);
		}
		else if(strcmp(model,"HSV")==0)
		{	CIPL_rgbtohsi(h1->T,TEMP);
			i=CIPL_Bpslice(TEMP,h2->T,bit,flags);
		}
		else if(strcmp(model,"XYZ")==0)
		{	CIPL_rgbtoxyz(h1->T,TEMP);
			i=CIPL_Bpslice(TEMP,h2->T,bit,flags);
		}
		else if(strcmp(model,"YIQ")==0)
		{	CIPL_rgbtoyiq(h1->T,TEMP);
			i=CIPL_Bpslice(TEMP,h2->T,bit,flags);
		}
	}
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(TEMP);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(TEMP);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	free(ID);
	free(TEMP);
	
	return 0;
}

int transpose(HEADER *h1,HEADER *h2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM )
		i=HIPL_Transpose(h1->T,h2->T);
	else
		i=CIPL_Transpose(h1->T,h2->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h2->fname,h2->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h2->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int difference(HEADER *h1,HEADER *h2,HEADER *h3) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM)
		i=HIPL_Differ(h1->T,h2->T,h3->T);
	else
		i=CIPL_Differ(h1->T,h2->T,h3->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h3->fname,h3->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h3->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int supermax(HEADER *h1,HEADER *h2,HEADER *h3) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM )
		i=HIPL_SIMax(h1->T,h2->T,h3->T);
	else
		i=CIPL_SIMax(h1->T,h2->T,h3->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h3->fname,h3->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h3->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int superavg(HEADER *h1,HEADER *h2,HEADER *h3) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM )
		i=HIPL_SIAvg(h1->T,h2->T,h3->T);
	else
		i=CIPL_SIAvg(h1->T,h2->T,h3->T);
	if(i<0) return -1;
	i=HIPL_StoreResult(h3->fname,h3->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h3->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(h2->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int selection(HEADER *h1,HEADER *sel,int x1,int y1,int x2, int y2) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	HIPL_Initialise(sel->T,NULL,1,0,h1->ID);
	HIPL_AllocateMem(sel->T);
	if(h1->T->img.TYPE == PGM)
		i=HIPL_Select(h1->T,sel->T,x1,y1,x2,y2,sel->ID);
	else
		i=CIPL_Select(h1->T,sel->T,x1,y1,x2,y2,sel->ID);
	if(i<0) return -1;
	i=HIPL_StoreResult(sel->fname,sel->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(sel->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(sel->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

int paste(HEADER *h1,HEADER *sel,HEADER *h3,int x1,int y1,int x2,int y2 ) {
	int i;
	i=HIPL_AllocateMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(sel->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	i=HIPL_AllocateMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in initialisation");
		return -1;
	}
	if(h1->T->img.TYPE == PGM)
		i=HIPL_Dump(h1->T,sel->T,h3->T,x1,y1,x2,y2);
	else
		i=CIPL_Dump(h1->T,sel->T,h3->T,x1,y1,x2,y2);
	if(i<0) return -1;
	i=HIPL_StoreResult(h3->fname,h3->T);
	if(i<0) {
		HIPL_Error("Error in Storing Result");
		return -1;
	}
	i=HIPL_FreeMem(h3->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_Closeall(h3->T);
	if(i<0) {
		HIPL_Error("Error in Closing Object");
		return -1;
	}
	i=HIPL_FreeMem(h1->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	i=HIPL_FreeMem(sel->T);
	if(i<0) {
		HIPL_Error("Error in Freeing Memory");
		return -1;
	}
	return 0;
}

