	#include"incl.h"
	
	extern int HIPL_ReadImagePGM(FILE *fd, THEADER *t);
	extern int HIPL_WriteImagePGM(FILE *fd, THEADER *t);
	extern int HIPL_GetImageHeaderPGM(FILE *fd,THEADER *T);
	char WINERR[200];
	int HIPL_ERRNO;
	int MAXMEM=350;
	int MAXMEM1=350;
	
	int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID);
	int HIPL_AllocateMem(THEADER *T);
	int HIPL_Getpart(THEADER *T);
	int HIPL_Putpart(THEADER *T);
	void HIPL_Error(char *msg);
	int HIPL_Closeall(THEADER *T);
	int HIPL_FreeMem(THEADER *T);
	int HIPL_StoreResult(char *name,THEADER *T);
	int Get_File_Type(char * name);
	int Create_temp_File(int b,THEADER *T);
	int HIPL_Refresh(THEADER *T,int flg);
	void HIPL_Setmemory(int Memory);
	int HIPL_ReadImage(THEADER *T, char *name, short io, short arr_type, DATA *ID);
	int HIPL_SpecifyOutParams(DATA *ID, int NRows, int NCols, int Type);
	
	/****************************************************************
	*       FUNCTION : HIPL_Initialise                              *
	*       INPUT    : THEADER,input file name,                     *
	*                   descriptor for input/output & arrar type    *
	*       OUTPUT   :      0 on success                            *
	*                      -1 on failure                            *
	*                                                               *
	*       DESCRIPTION : 1) fills in the header structure          *
	*                     2) creates the temporary data files       *
	*                     3) allocates memory to the arrays         *
	*                                                               *
	*    EXTERNAL CALLS : 1)ReadImagePGM                            *
	*                       File :pgmread.c                         *
	*                     2)ReadImageTIFF                           *
	*                       File :tiffread.c                        *
	*                                                               *
	****************************************************************/ 
	
	int HIPL_Initialise(THEADER *T,char *name,short io,short arr_type,DATA *ID)
	{
	     FILE *fd;
	     int type,i;
	     static int count=1;
	     DB_printf(("Entered Initialize Function\n"));
	
	     count++;
	     if(count>=10000)
		  count=0;
	     i=Create_temp_File(count,T);
	     DB_printf(("Created Temp Files (%s, %s and %s)\n", T->tempfname,
			T->tempjname, T->tempkname));
	
	     if(i<0)
		  return(-1);
	     T->fptr = T->jptr = T->kptr = NULL;
	
	     if(io==0)
	     {
		  if(ISUNIX) {
		       T->fptr=fopen(T->tempfname,"w");
		       DB_printf(("Opened Temp File %s\n", T->tempfname));
		  } else
		  {
		       if(T->ver==0)
			    T->fptr=fopen(T->tempfname,"wb");
		       else
			    T->fptr=fopen(T->tempfname,"w");
		  }
		  if(T->fptr==NULL)
		  {
		       HIPL_ERRNO=-8;
		       return(-1);
		  }
	     }
		
	     if(io==0)
	     {
		  DB_printf(("Trying to open %s for reading\n", name));
		  fd=fopen(name,"r");
	
		  if(fd==NULL)
		  {
		       DB_printf(("Opened %s for reading\n", name));
		       HIPL_ERRNO=-1;
		       return(-1);
		  }
		  type=Get_File_Type(name);
		  DB_printf(("File Type: %d\n", type));
		  if(type==PGM) {
		       i=HIPL_GetImageHeaderPGM(fd,T);
		       if(i<0) return -1;
		       fclose(fd);
		       T->img.TYPE=PGM;
		  } else if (type == PPM) {
		       i = HIPL_GetImageHeaderPPM(fd, T);
		       if (i < 0)
			    return(-1);
		       fclose(fd);
		       T->img.TYPE=PPM;
		  }
		 
		  if(ISUNIX)
		       fd=fopen(name,"r");
		  else {
		       if(T->ver==0)
			    fd=fopen(name,"rb");
		       else
			    fd=fopen(name,"r");
		  }
		  if(fd==NULL)
		  {
		       HIPL_ERRNO=-1;
		       return(-1);
		  }
		  if((type==PGM)&&(io==0))
		  {
		       i=HIPL_ReadImagePGM(fd,T);
		       if(i<0)
		       {
			    fclose(T->fptr);
			    return(-1);
		       }
		       fclose(T->fptr);
		  }
		  if ((type==PPM) && (io==0)) {
		       T->jptr=fopen(T->tempjname,"w");
		       T->kptr=fopen(T->tempkname,"w");
		       DB_printf(("Opened Temp Files (%s and %s) for writing\n",
				  T->tempjname, T->tempkname));
		       i = HIPL_ReadImagePPM(fd, T);
	
		       DB_printf(("Return from ReadImagePPM (%d): %d\n", T->img.TYPE, i));
		       fclose(T->fptr);
		       fclose(T->jptr);
		       fclose(T->kptr);
		       if (i < 0)
			    return(-1);
		  }
		  if(type==TIFF)
		  {
		       fclose(T->fptr);
		       return( -1);
		  }
		  if(type==UNKNOWN)
		  {
		       fclose(T->fptr);
		       return(-1);
		  }
		  fclose(fd);
	     }
	     if(io==1)
	     {
		  T->img.COLS=ID->COLS;
		  T->img.ROWS=ID->ROWS;
		  T->ver=ID->ver;
		  T->img.TYPE=ID->type;
		  T->fptr=fopen(T->tempfname,"w");
		  if(T->fptr==NULL)
		  {
		       HIPL_ERRNO=-8;
		       return(-1);
		  }
		  fclose(T->fptr);
		  if (ID->type == PPM || ID->type == HSV || ID->type == YIQ || ID->type == XYZ) {
		       T->jptr = fopen(T->tempjname, "w");
		       T->kptr = fopen(T->tempkname, "w");
		       if ((T->jptr == NULL) || (T->kptr == NULL)) {
			    HIPL_ERRNO = -8;
			    return(-1);
		       }
		       fclose(T->jptr);
		       fclose(T->kptr);
		  }
	     }
	     if(io==0)
	     {
		  ID->COLS=T->img.COLS;
		  ID->ROWS=T->img.ROWS;
		  ID->ver=T->ver;
		  ID->type=type;
		  DB_printf(("Setting Image Dimensions (%d %d %d)\n",
			     T->img.ROWS, T->img.COLS, T->img.levels));
	     }
	     T->arrtype=arr_type;
	     return 0;
	}
	
	int HIPL_AllocateMem(THEADER *T)
	{
	     int part_size=0,num_cols,i;
	     num_cols=T->img.COLS;
	     DB_printf(("Allocate Memory Num Cols: %d\n", T->img.COLS));
	     if(T->dfflg!=1)
		  T->P.psize=(int)((MAXMEM*1024)/(T->img.COLS));
	     if(T->dfflg==1)
		  T->P.psize=(int)((MAXMEM1*1024)/(T->img.COLS));
	     if(T->P.psize > T->img.ROWS)
		  T->P.psize=T->img.ROWS;
	     part_size=T->P.psize;
	     if(T->arrtype==0)
	     {
		  T->iarr=(int **)malloc(part_size*sizeof(int *));
		  if (T->jptr != NULL) { /* Image is PPM */
		       T->jarr=(int **)malloc(part_size*sizeof(int *));
		       T->karr=(int **)malloc(part_size*sizeof(int *));
		       if(T->jarr==(int **) 0) {
			    HIPL_ERRNO=-5;
			    return(-1);
		       }
		       if(T->karr==(int **) 0) {
			    HIPL_ERRNO=-5;
			    return(-1);
		       }
		  }
		  if(T->iarr==(int **) 0)
		  {
		       HIPL_ERRNO=-5;
		       return(-1);
		  }
		  for(i=0;i<part_size;i++)
		  {
		       T->iarr[i]=(int *)malloc(num_cols*sizeof(int));
		       if(T->iarr[i]==(int *) 0)
		       {
			    HIPL_ERRNO=-5;
			    return(-1);
		       }
		       if (T->jptr != NULL) {
			    T->jarr[i] = (int *)malloc(num_cols*sizeof(int));
			    if(T->jarr[i]==(int *) 0) {
				 HIPL_ERRNO=-5;
				 return(-1);
			    }
			    T->karr[i] = (int *)malloc(num_cols*sizeof(int));
			    if(T->karr[i]==(int *) 0) {
				 HIPL_ERRNO=-5;
				 return(-1);
			    }
		       }
		  }
	     }
	     if(T->arrtype==1)
	     {
		  T->farr=(float **)malloc(part_size*sizeof(float *));
		  if(T->farr==(float **)0)
		  {
		       HIPL_ERRNO=-9;
		       return(-1);
		  }
		  for(i=0;i<part_size;i++)
		  {
		       T->farr[i]=(float *)malloc(num_cols*sizeof(float));
		       if(T->farr[i]==(float *)0)
		       {
			    HIPL_ERRNO=-9;
			    return(-6);
		       }
		  }
	     }
	     T->P.rowsread=0;
	     T->MROWS=1;
	     T->MCOLS=0;
	     T->MORGX=0;
	     T->MORGY=0;
	     T->memflag=0;
	     T->P.put=0;
	     T->P.nleft=T->img.ROWS;
	     return 0;
	}
	
	/****************************************************************
	*       FUNCTION  : Get_File_Type                               *
	*                                                               *
	*       INPUT     : Name of the file                            *
	*                                                               *
	*       OUTPUT    : Number indicating the type of the file      *
	*                                                               *
	*    DESCRIPTION  :  Finds out the type of the image file       *
	*                       Recognises only PGM, PPM & TIFF formats *
	*                                                               *
	*   EXTERNAL CALLS : None                                       *
	*                                                               *
	****************************************************************/
	
	int Get_File_Type(char *name)
	{
	     int tmp1,tmp2;
	     FILE *fp;
	     DB_printf(("Entered GetFileType Function\n"));
	     fp=fopen(name,"r");
	
	     if(fp==NULL)
		  return(-3);
	
	     if(((tmp1=fgetc(fp))!=0)&&((tmp2=fgetc(fp))!=0))
	     {
		  if(tmp1=='P')
		  {
		       if((tmp2=='5')||(tmp2=='2'))
		       {
			    fclose(fp);
			    return(PGM);
		       }
		       if((tmp2=='3')||(tmp2=='6')) {
			    fclose(fp);
			    return(PPM);
		       }
		       if (tmp2==0)
		       {
			    fclose(fp);
			    return(-20);
		       }
		       else
		       {
			    fclose(fp);
			    return(UNKNOWN);
		       }
		  }
	
		  if(((tmp1=='I')&&(tmp2=='I'))||((tmp1=='M')&&(tmp2=='M')))
		  {
		       fclose(fp);
		       return(TIFF);
		  }
	     }
	     return(RAW);
	
	}
	
	/****************************************************************
	*       FUNCTION : Create_temp_File                             *
	*                                                               *
	*       INPUT    : Count indicating the number of the           *
	*                       temp. file name                         *
	*                  and the header in which the name is stored   *
	*                                                               *
	*       OUTPUT   :  0 on success                                *
	*                   negative number on failure                  *
	*   DESCRIPTION : Creates a temporary file name                 *
	*                                                               *
	*   EXTERNAL CALLS : None                                       *
	*                                                               *
	****************************************************************/
	
	int Create_temp_File(int c,THEADER *T)
	{
	     char buf[35], jbuf[35], kbuf[35];
	     int i;
	     for(i=0;i<35;i++)
		  buf[i]=jbuf[i]=kbuf[i]='\0';
	     sprintf(buf,"hipl%d.idt",c);
	     sprintf(jbuf,"hipl%d-j.idt", c);
	     sprintf(kbuf,"hipl%d-k.idt", c);
		
	     for(i=0;i<35;i++) {
		  T->tempfname[i]=buf[i];
		  T->tempjname[i]=jbuf[i];
		  T->tempkname[i]=kbuf[i];
	     }
	     return(0);
	}
	
	int HIPL_Maskinit(THEADER *it,int rows, int cols,int orgx,int orgy)
	{
	     it->MROWS=rows;
	     it->MCOLS=cols;
	     it->MORGX=orgx;
	     it->MORGY=orgy;
	     return(0);
	}	
	
	/****************************************************************
	*       FUNCTION : HIPL_Getpart                                 *
	*                                                               *
	*       INPUT    : Header containing the pointer to array       *
	*                       into which data is to be read.          *
	*                                                               *
	*       OUTPUT   : Number of rows read on success               *
	*                   negative number (depending on the type      *
	*                       of failure) on failure.                 *
	*                                                               *
	*     EXTERNAL CALLS :None.                                     *
	*                                                               *
	*   DESCRIPTION  : Fills in the array pointed to in the         *
	*                     header with the data from the temp file.  *
	*                                                               *
	*****************************************************************/
	
	int HIPL_Getpart(THEADER *T)
	{
	     int i,j,left,back,pparts,k,start,temp,index,cc;
	     unsigned char *buff;
	     
	     buff=(unsigned char*)malloc(T->img.COLS*sizeof(unsigned char));
	

	     k=(T->MROWS - T->MORGX - 1);
	     if(k<0) k= 0;
	     if(T->MROWS <= 0) {
		  back = 0;
		  T->MORGX=0;
	     }
	     else
		  back = T->MROWS - 1; 
	     if(T->P.nleft==0)
		  return(0);
	
	     if(T->memflag==1)
	     {
		  T->P.nleft=0;
		  T->P.rowsread=T->img.ROWS;
		  T->P.put=T->img.ROWS;
		  return(T->img.ROWS);
	     }
	
	
	     if(T->P.rowsread==0)
	     {
		  if(ISUNIX) {
		       T->fptr=fopen(T->tempfname,"r");
		       if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    T->jptr = fopen(T->tempjname, "r");
			    T->kptr = fopen(T->tempkname, "r");
		       }
		  } else {
		       if(T->ver==0){
			    T->fptr=fopen(T->tempfname,"rb");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr = fopen(T->tempjname, "rb");
			    	T->kptr = fopen(T->tempkname, "rb");
		       	     }
			}
		       else{
			    T->fptr=fopen(T->tempfname,"r");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr = fopen(T->tempjname, "r");
			    	T->kptr = fopen(T->tempkname, "r");
		            }
			}
		  }
		  
		  if(T->fptr==NULL)
		  {
		       HIPL_ERRNO=-7;
		       return(-1);
		  }
		  if((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)){
			if(T->jptr==NULL || T->kptr==NULL){
				HIPL_ERRNO=-7;
				return(-1);
			}
		  } 
	     }
	
	     if(T->P.rowsread==0)
		  start=0;
	     else
		  start=back;
	
	     if(T->P.psize==T->img.ROWS)
	     {
		  start=0;
		  T->memflag=1;
	     }
	
	     for(i=0;i<start;i++)
	     {
		  for(j=0;j<T->img.COLS;j++)
		  {
		       temp=T->P.psize-back+i;
		       if(T->arrtype==0) {
			    T->iarr[i][j]=T->iarr[temp][j];
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
				 T->jarr[i][j] = T->jarr[temp][j];
				 T->karr[i][j] = T->karr[temp][j];
			    }
		       }
		       if(T->arrtype==1)
			    T->farr[i][j]=T->farr[temp][j];
	
	
		  }
	     }
	
	     if((T->P.nleft)<=T->P.psize)
	     {
		  left=T->P.nleft;
	          
		  for(i=start;i<left;i++)
		  {
		       
		       
			    if(T->arrtype==0)
			    {
				 if(T->ver==0)
				 {
				      if(fread(buff,1,T->img.COLS,T->fptr)!=T->img.COLS)
						      printf("Error in reading file: iptr\n");
				       for(index=0;index<T->img.COLS;index++)
						T->iarr[i][index]=(int)buff[index];
				      if(T->img.TYPE == HSV){
					      if(fread(T->jarr[i],4,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in reading file: jptr\n");
					      if(fread(T->karr[i],4,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in reading file: kptr\n");
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					      if(fread(buff,1,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in reading file\n");
					      for(index=0;index<T->img.COLS;index++)
						T->jarr[i][index]=(int)buff[index];
					      if(fread(buff,1,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in reading file9\n");
				       	      for(index=0;index<T->img.COLS;index++)
						T->karr[i][index]=(int)buff[index];
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				 }
	
				 if(T->ver==1)
				 { for(j=0;j<T->img.COLS;j++){
				      fscanf(T->fptr,"%d ",&T->iarr[i][j]);
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					   fscanf(T->jptr,"%d ",&T->jarr[i][j]);
					   fscanf(T->kptr,"%d ",&T->karr[i][j]);
				      }
					   
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				    }
				 }		    
			    }
			    if(T->arrtype==1)
			    {  for(j=0;j<T->img.COLS;j++){
				 fscanf(T->fptr," %f",&T->farr[i][j]);
				 if(ferror(T->fptr)==1)
				 {
				      HIPL_ERRNO=-22;
				      clearerr(T->fptr);
				      return(-1);
				 }
			       }
			    }
		       
		  }
		  
		  T->P.rowsread=T->img.ROWS;
		  T->P.nleft=0;
		  T->P.put=T->img.ROWS;
		  fclose(T->fptr);
		  if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
		       fclose(T->jptr);
		       fclose(T->kptr);
		  }
		  return(left);
		  
	     }
	
	
	     if((T->P.nleft) > T->P.psize)
	     {
		  for(i=start;i<T->P.psize;i++)
		  {
		       
			    if(T->arrtype==0)
			    {
				 if(T->ver==0)
				 {
				      if(fread(buff,1,T->img.COLS,T->fptr)!=T->img.COLS)
						      printf("Error in reading file1\n");
				       for(index=0;index<T->img.COLS;index++)
						T->iarr[i][index]=(int)buff[index];
				      if(T->img.TYPE == HSV){
					      if(fread(T->jarr[i],4,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in reading file2\n");
					      if(fread(T->karr[i],4,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in reading file3\n");
				      }
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					      if(fread(buff,1,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in reading file4\n");
					      for(index=0;index<T->img.COLS;index++)
						T->jarr[i][index]=(int)buff[index];
					      if(fread(buff,1,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in reading file5 \n");
				       	      for(index=0;index<T->img.COLS;index++)
						T->karr[i][index]=(int)buff[index];
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				 }
				 if(T->ver==1)
				 {  for(j=0;j<T->img.COLS;j++){
				      fscanf(T->fptr,"%d ",&T->iarr[i][j]);
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					   fscanf(T->jptr,"%d ",&T->jarr[i][j]);
					   fscanf(T->kptr,"%d ",&T->karr[i][j]);
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				    }
				 }
			    }
			    if(T->arrtype==1)
			    {  for(j=0;j<T->img.COLS;j++){
				 fscanf(T->fptr," %f",&T->farr[i][j]);
				 if(ferror(T->fptr)==1)
				 {
				      HIPL_ERRNO=-22;
				      clearerr(T->fptr);
				      return(-1);
				 }
			       }
			    }
		       
		  }
	     }
	     
	     if(T->P.rowsread==0)
	     {
		  T->P.put=T->P.psize-k;
		  T->P.rowsread=T->P.rowsread + T->P.psize - k;
		  pparts=T->P.psize;
		  T->P.nleft= T->P.nleft -T->P.psize +back;
	     }
	     else
	     {
		  T->P.put=T->P.psize-back;
		  T->P.rowsread=T->P.rowsread + T->P.psize - back;
		  pparts=T->P.psize;
		  T->P.nleft= T->P.nleft -T->P.psize +back;
	     }
	     return(pparts);
	}
	/****************************************************************
	 *                                                               *
	 *       FUNCTION  : HIPL_Putpart                                *
	*                                                               *
	*       INPUT     : Pointer to the structure of the output      *
	*                       header containing the processed array   *
	*                       and the pointer to the temp output file *
	*                                                               *
	*       OUTPUT    : 0 on success                                *
	*                   Negative number(depending on the type       *
	*                       of failure) on failure                  *
	*                                                               *
	*     EXTERNAL CALLS : None                                     *
	*                                                               *
	*     DESCRIPTION : Writes the processed array into the         *
	*                       temporary file                          *
	****************************************************************/
	
	int HIPL_Putpart(THEADER *T)
	{
	     int i,j,k,back,status,left,index;
	     unsigned char *buff;
	     	 
	     buff=(unsigned char*)malloc(T->img.COLS*sizeof(unsigned char));
	     
	     if(T->P.nleft==0) 
		  return(0);
	     if(T->memflag==1)
	     {
		  T->P.nleft=0;
		  T->P.put=T->img.ROWS;
		  T->P.rowsread=T->img.ROWS;
		  return(0);
	     }
	     if(T->P.psize==T->img.ROWS)
	     {
		  T->P.nleft=0;
		  T->P.put=T->img.ROWS;
		  T->P.rowsread=T->img.ROWS;
		  T->memflag=1;
		  if(ISUNIX) {
			
		       T->fptr=fopen(T->tempfname,"w");
		       if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    T->jptr = fopen(T->tempjname, "w");
			    T->kptr = fopen(T->tempkname, "w");
		       }
		  }
		  else
		  {
		       if(T->ver==0){
			    T->fptr=fopen(T->tempfname,"wb");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr=fopen(T->tempjname,"wb");
			    	T->kptr=fopen(T->tempkname,"wb");
			     }
			}
		       else{
			    T->fptr=fopen(T->tempfname,"w");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr=fopen(T->tempjname,"w");
			    	T->kptr=fopen(T->tempkname,"w");
			     }
			}
		  }
		  if(T->fptr==NULL)
		  {
		       HIPL_ERRNO=-8;
		       return(-1);
		  }
		  if((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)){
			if(T->jptr==NULL || T->kptr==NULL){
				HIPL_ERRNO=-7;
				return(-1);
			}
		  } 
		  fclose(T->fptr);
		  return(0);
	     }
	     k=(T->MROWS - T->MORGX - 1);
	     if(T->MROWS <= 0) {
		  back = 0;
		  T->MORGX=0;
	     }
	     else
		  back = T->MROWS - 1; 
	     if(T->P.psize==T->img.ROWS)
	     {
		  k=0;
		  back=0;
	     }
	     if(T->P.put==0)
	     {
		  if(ISUNIX) {
		       T->fptr=fopen(T->tempfname,"w");
		       if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    T->jptr = fopen(T->tempjname, "w");
			    T->kptr = fopen(T->tempkname, "w");
		       }
		  }
		  else
		  {
		       if(T->ver==0){
			    T->fptr=fopen(T->tempfname,"wb");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr=fopen(T->tempjname,"wb");
			    	T->kptr=fopen(T->tempkname,"wb");
			     }
			}
		       else{
			    T->fptr=fopen(T->tempfname,"w");
			    if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    	T->jptr=fopen(T->tempjname,"w");
			    	T->kptr=fopen(T->tempkname,"w");
			     }
			}
		  }
		  if(T->fptr==NULL)
		  {
		       HIPL_ERRNO=-8;
		       return(-1);
		  }
		   if((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)){
			if(T->jptr==NULL || T->kptr==NULL){
				HIPL_ERRNO=-7;
				return(-1);
			}
		  } 
	     }
	     if(T->P.put == 0)
	     {
		  for(i=0;i<(T->P.psize-k);i++)
		  {
		       
			    switch(T->arrtype)
			    {
			    case(0):
				 if(T->ver==0)
				 {	
				      for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->iarr[i][index];
					
				      if(fwrite(buff,1,T->img.COLS,T->fptr)!=T->img.COLS)
						      printf("Error in writing file\n");
					
				      if(T->img.TYPE == HSV){
					      
					      if(fwrite(T->jarr[i],4,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");				
					      if(fwrite(T->karr[i],4,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					 for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->jarr[i][index];
						
					     if(fwrite(buff,1,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");	
			     			
					  for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->karr[i][index];
					      if(fwrite(buff,1,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				 }
				 if(T->ver==1)
				 {  for(j=0;j<T->img.COLS;j++){
				      fprintf(T->fptr,"%3d ",T->iarr[i][j]);
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					   fprintf(T->jptr, "%3d ", T->jarr[i][j]);
					   fprintf(T->kptr, "%3d ", T->karr[i][j]);
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				    }
				 }
				 break;
			    case(1):
				for(j=0;j<T->img.COLS;j++){
				   fprintf(T->fptr," %f",T->farr[i][j]);
				   if(ferror(T->fptr)==1)
				   {
				      HIPL_ERRNO=-22;
				      clearerr(T->fptr);
				      return(-1);
				    }
				}
				break;
			    }
		       
		  }
		  T->P.nleft=T->P.nleft + back - T->P.psize;
		  T->P.put=T->P.psize-k;
		  if(T->P.nleft==0) {
		       fclose(T->fptr);
		       if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
			    fclose(T->jptr);
			    fclose(T->kptr);
		       }
		   }
		  return(0);
	     }
	     if((T->P.nleft)<=T->P.psize)
	     {       
		  left=T->P.nleft;
		  
		  for(i=T->MORGX;i<left;i++)
		  {
		       
			    switch(T->arrtype)
			    {
			    case(0):
				 if(T->ver==0)
				 {
				      for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->iarr[i][index];
				      if(fwrite(buff,1,T->img.COLS,T->fptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      if(T->img.TYPE == HSV){
					      if(fwrite(T->jarr[i],4,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");
					      if(fwrite(T->karr[i],4,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					 for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->jarr[i][index];
					     if(fwrite(buff,1,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");					
					  for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->karr[i][index];
					      if(fwrite(buff,1,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				 }
				 if(T->ver==1)
				 {  for(j=0;j<T->img.COLS;j++){
				      fprintf(T->fptr,"%3d ",T->iarr[i][j]);
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					   fprintf(T->jptr, "%3d ", T->jarr[i][j]);
					   fprintf(T->kptr, "%3d ", T->karr[i][j]);
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				     }
				 }
				 break;
			    case(1):
				for(j=0;j<T->img.COLS;j++){
				  fprintf(T->fptr," %f",T->farr[i][j]);
				  if(ferror(T->fptr)==1)
				  {
				      HIPL_ERRNO=-22;
				      clearerr(T->fptr);
				      return(-1);
				  }
				}
				break;
			    }
		       
		  }
		  T->P.put=T->P.nleft;
		  T->P.nleft=0;
		  fclose(T->fptr);
		  if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
		       fclose(T->jptr);
		       fclose(T->kptr);
		  }
	     }
	     else
	     {
		  for(i=T->MORGX;i<(T->P.psize-k);i++)
		  {
		       
			    switch(T->arrtype)
			    {
			    case(0):
				 if(T->ver==0)
				 {
				      for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->iarr[i][index];
				      if(fwrite(buff,1,T->img.COLS,T->fptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      if(T->img.TYPE == HSV){
					      if(fwrite(T->jarr[i],4,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");
					      if(fwrite(T->karr[i],4,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					 for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->jarr[i][index];
					     if(fwrite(buff,1,T->img.COLS,T->jptr)!=T->img.COLS)
						      printf("Error in writing file\n");					
					  for(index=0;index<T->img.COLS;index++)
						buff[index]=(unsigned char)T->karr[i][index];
					      if(fwrite(buff,1,T->img.COLS,T->kptr)!=T->img.COLS)
						      printf("Error in writing file\n");
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				 }
				 if(T->ver==1)
				 { for(j=0;j<T->img.COLS;j++){
				      fprintf(T->fptr,"%3d ",T->iarr[i][j]);
				      if ((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)) {
					   fprintf(T->jptr, "%3d ", T->jarr[i][j]);
					   fprintf(T->kptr, "%3d ", T->karr[i][j]);
				      }
				      if(ferror(T->fptr)==1)
				      {
					   HIPL_ERRNO=-22;
					   clearerr(T->fptr);
					   clearerr(T->jptr);
					   clearerr(T->kptr);
					   return(-1);
				      }
				      if (T->img.TYPE == PPM || T->img.TYPE == YIQ || T->img.TYPE == XYZ ) {
					  if(ferror(T->jptr)==1 || ferror(T->kptr)==1)
				      	  {
					     HIPL_ERRNO=-22;
					     clearerr(T->fptr);
					     clearerr(T->jptr);
					     clearerr(T->kptr);
					     return(-1);
				           }
				       }
				    }
				 }
				 break;
			    case(1):
				for(j=0;j<T->img.COLS;j++){
				   fprintf(T->fptr," %f",T->farr[i][j]);
				   if(ferror(T->fptr)==1)
				   {
				      HIPL_ERRNO=-22;
				      clearerr(T->fptr);
				      return(-1);
				   }
				}
				break;
			    }
		      
		  }
		  T->P.nleft=T->P.nleft-T->P.psize+back;
		  T->P.put=T->P.psize-back;
	     }
	     return(0);
	}
	
	/****************************************************************
	*       FUNCTION  : HIPL_Storeresult                            *
	*                                                               *
	*       INPUT     : Name of the file and the output header      *
	*                                                               *
	*       OUTPUT    : 0  on success                               *
	*                   -1 on failure                               *
	*                                                               *
	*  DESCRIPTION    : Creates the PGM file from the data file     *
	*                                                               *
	*   EXTERNAL CALLS :None                                        *
	*                                                               *
	****************************************************************/
	
	int HIPL_StoreResult(char *name,THEADER *T)
	{
	
	     FILE *fp;
	     int i;
	     
	     if(ISUNIX)
		  fp=fopen(name,"w");
	     else
	     {
		  //if(T->ver==0)
		  //fp=fopen(name,"wb");
		  //else
		  fp=fopen(name,"w");
	     }
	
	
	     if(fp==NULL)
	     {
		  HIPL_ERRNO=-18;
		  return(-1);
	     }
	      
	     if (T->img.TYPE == PPM)
		  i=HIPL_WriteImagePPM(fp,T);
	     else 
		  i = HIPL_WriteImagePGM(fp, T);
	     if(i==1)
		  return(-1);
	     fclose(fp);
	     return(0);
	}
	
	
	/****************************************************************
	*       FUNCTION  : HIPL_Closeall                               *
	*                                                               *
	*       INPUT     : Input header and the Output header          *
	*                                                               *
	*       OUTPUT    : 0  on success                               *
	*                   -1 on failure                               *
	*                                                               *
	*    DESCRIPTION :  Closes and removes the temporary files      *
	*                                                               *
	*  EXTERNAL CALLS :None                                         *
	*                                                               *
	****************************************************************/
	
	int HIPL_Closeall(THEADER *T)
	{
	     int i, j=0, k=0;
	     i=remove(T->tempfname);
	     if((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) ||(T->img.TYPE == XYZ)){
			j=remove(T->tempjname);
			k=remove(T->tempkname);
	     }
	     
	     if(i!=0 || j!=0 || k!=0)
	     {
		  HIPL_ERRNO=-21;
		  return(-1);
	     }
	     return 0;
	}
	
	int HIPL_FreeMem(THEADER *T)
	{
	     int i;
	     if(T->arrtype==0)
	     {
		  for(i=0;i<T->P.psize;i++)
		       free(T->iarr[i]);
		  free(T->iarr);
		  if((T->img.TYPE == PPM) || (T->img.TYPE == HSV) || (T->img.TYPE == YIQ) || (T->img.TYPE == XYZ)){
			for(i=0;i<T->P.psize;i++){
		       		free(T->jarr[i]);
		       		free(T->karr[i]);
			}
			free(T->jarr);
		  	free(T->karr);
		  }
	     }
	     if(T->arrtype==1)
	     {
		  for(i=0;i<T->P.psize;i++)
		       free(T->farr[i]);
		  free(T->farr);
	     }
	     return(0);
	}
	
	/****************************************************************
	*	FUNCTION  : HIPL_Refresh				*
	*								*
	*	INPUT     : Input header and FLAG			*
	*								*
	*	OUTPUT    : 0  on success				*
	*		    -1 on failure				*
	*								*
	*    DESCRIPTION :Retains Header info and according to FLAG 	*
	*   		     realloctes memory				*
	*   								*
	*  EXTERNAL CALLS :None						*
	*								*
	****************************************************************/
	
	int HIPL_Refresh(THEADER *T,int Flag)
	{
	     int i,part_size,num_rows,num_cols,arr_type;
	     if(Flag==1)
	     {
		  if(T->arrtype==0)
		  {
		       for(i=0;i<T->P.psize;i++)
			    free(T->iarr[i]);
		       free(T->iarr);
	
		       if(T->img.TYPE == PPM || T->img.TYPE == HSV || T->img.TYPE == YIQ || T->img.TYPE == XYZ) {
			    for(i=0;i<T->P.psize;i++) {
				 free(T->jarr[i]);
				 free(T->karr[i]);
			    }
			    free(T->jarr);
			    free(T->karr);
		       }
		  }
	
		  if(T->arrtype==1)
		  {
		       for(i=0;i<T->P.psize;i++)
			    free(T->farr[i]);
		       free(T->farr);
		  }
	     }
	     num_rows=T->img.ROWS;
	     num_cols=T->img.COLS;
	     arr_type=T->arrtype;
	
	     if(Flag==1)
	     {
		  T->P.psize=(int)(MAXMEM1*1024)/(T->img.COLS);
		  part_size=T->P.psize;
		  if(arr_type==0)
		  {
				
		       T->iarr=(int **)malloc(part_size*sizeof(int *));
		       if(T->iarr==(int **) 0)
		       {
			    HIPL_ERRNO=-5;
			    return(-1);
		       }
		       for(i=0;i<part_size;i++)
		       {
			    T->iarr[i]=(int *)malloc(num_cols*sizeof(int));
			    if(T->iarr[i]==(int *) 0)
			    {
				 HIPL_ERRNO=-5;
				 return(-1);
			    }
		       }
		       if(T->img.TYPE == PPM || T->img.TYPE == HSV || T->img.TYPE == YIQ || T->img.TYPE == XYZ) {
				T->jarr=(int **)malloc(part_size*sizeof(int *));
				T->karr=(int **)malloc(part_size*sizeof(int *));
				if((T->jarr==(int **) 0) ||(T->karr==(int **) 0) )
		       		{
			    		HIPL_ERRNO=-5;
			    		return(-1);
		       		}
				for(i=0;i<part_size;i++)
		       		{
			    		T->jarr[i]=(int *)malloc(num_cols*sizeof(int));
					T->karr[i]=(int *)malloc(num_cols*sizeof(int));
			    		if((T->jarr[i]==(int *) 0)||(T->karr[i]==(int *) 0))
			    		{
						 HIPL_ERRNO=-5;
				 		return(-1);
			    		}
		       		}
			}
		  }
		  if(arr_type==1)
		  {
		       T->farr=(float **)malloc(part_size*sizeof(float *));
		       if(T->farr==NULL)
		       {
			    HIPL_ERRNO=-9;
			    return(-1);
		       }
		       for(i=0;i<part_size;i++)
		       {
			    T->farr[i]=(float *)malloc(num_cols*sizeof(float));
			    if(T->farr[i]==NULL)
			    {
				 HIPL_ERRNO=-9;
				 return(-6);
			    }
		       }
		  }
	     }
	     T->P.nleft=T->img.ROWS;
	     T->P.put=0;
	     T->P.rowsread=0;
	     return(0);
	}
	
	/****************************************************************
	*       FUNCTION  : HIPL_Error                                  *
	*                                                               *
	*       INPUT     :  Message to be printed                      *
	*                                                               *
	*       OUTPUT    :  None                                       *
	*                                                               *
	*    DESCRIPTION :  Prints the message given in the input       *
	*                    and the corrosponding error message by     *
	*                       using to the file HIPL_Error.h          *
	*                                                               *
	*   EXTERNAL CALLS : None                                       *
	*                                                               *
	****************************************************************/
	
	void HIPL_Error(char *msg)
	{
	     if(HIPL_ERRNO==-1)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG1);
	
	     if(HIPL_ERRNO==-2)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG2);
	
	     if(HIPL_ERRNO==-3)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG3);
	
	     if(HIPL_ERRNO==-4)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG4);
	
	     if(HIPL_ERRNO==-5)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG5);
	
	     if(HIPL_ERRNO==-6)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG6);
	
	     if(HIPL_ERRNO==-7)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG7);
	
	     if(HIPL_ERRNO==-8)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG8);
	
	     if(HIPL_ERRNO==-9)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG9);
	
	     if(HIPL_ERRNO==-10)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG10);
	
	     if(HIPL_ERRNO==-11)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG11);
	
	     if(HIPL_ERRNO==-12)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG12);
	
	     if(HIPL_ERRNO==-13)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG13);
	
	     if(HIPL_ERRNO==-14)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG14);
	
	     if(HIPL_ERRNO==-15)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG15);
	
	     if(HIPL_ERRNO==-16)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG16);
	
	     if(HIPL_ERRNO==-17)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG17);
	
	     if(HIPL_ERRNO==-18)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG18);
	
	     if(HIPL_ERRNO==-19)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG19);
		
	     if(HIPL_ERRNO==-20)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG20);
	
	
	     if(HIPL_ERRNO==-21)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG21);
		
	     if(HIPL_ERRNO==-22)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG22);
	
	     if(HIPL_ERRNO==-23)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG23);
	
	     if(HIPL_ERRNO==-24)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG24);
	
	     if(HIPL_ERRNO==-25)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG25);
	
	     if(HIPL_ERRNO==-26)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG26);
	
	     if(HIPL_ERRNO==-27)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG27);
	
	     if(HIPL_ERRNO==-28)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG28);
	
	     if(HIPL_ERRNO==-29)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG29);
		
	     if(HIPL_ERRNO==-30)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG30);
	
	     if(HIPL_ERRNO==-31)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG31);
	  
	      if(HIPL_ERRNO==-32)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG32);
	  	
	      if(HIPL_ERRNO==-33)
		  sprintf(WINERR,"%s  : %s",msg,HIPL_ERRMSG33);
	     fprintf(stderr, "---> %s\n", WINERR);
	}
	
	
	/****************************************************************
	*       FUNCTION  : HIPL_Setmemory                              *
	*                                                               *
	*       INPUT     :  Memory to be set                           *
	*                                                               *
	*       OUTPUT    :  None                                       *
	*                                                               *
	*    DESCRIPTION :  Sets the memory capability of the tool      *
	*                       to the user given value		            *
	*                                                               *
	*   EXTERNAL CALLS : None                                       *
	*                                                               *
	****************************************************************/
	
	void HIPL_Setmemory(int Memory)
	{
	     MAXMEM=MAXMEM1=Memory;
	     return;
	}
	
	/****************************************************************
	*                                                               *
	*       FUNCTION  : HIPL_ReadImage                              *
	*                                                               *
	*       INPUT     : THEADER *t, char *name, short io,           *
	*                   short arr_type, DATA *ID                    *
	*                                                               *
	*       OUTPUT    : 0 on success                                *
	*                   Negative number(depending on the type       *
	*                       of failure) on failure                  *
	*                                                               *
	*     EXTERNAL CALLS : None                                     *
	*                                                               *
	*     DESCRIPTION : Creates the image structure and reads       *
	*                   the input image into it. Function added     *
	*                   by Chak Bhagvati on 31/03/2001              *
	****************************************************************/
	int HIPL_ReadImage(THEADER *T, char *name, short io, short arr_type, DATA *ID)
	{
	     int rv;
	     extern int HIPL_ERRNO;
	
	     if ((HIPL_ERRNO= HIPL_Initialise(T, name, io, arr_type, ID)) != 0)
		  return(-1);
	
	     if ((HIPL_ERRNO = HIPL_AllocateMem(T)) != 0)
		  return(-1);
	
	     return(0);
	}
	
	/****************************************************************
	*                                                               *
	*       FUNCTION  : HIPL_SpecifyOutParams                       *
	*                                                               *
	*       INPUT     : DATA *ID, int NRows, int NCols, int Type    *
	*                                                               *
	*       OUTPUT    : 0 on success                                *
	*                   Negative number(depending on the type       *
	*                       of failure) on failure                  *
	*                                                               *
	*     EXTERNAL CALLS : None                                     *
	*                                                               *
	*     DESCRIPTION : Fills the DATA data structure for           *
	*                   initialising output images. Type is         *
	*                   either BINARY or ASCII images. Function     *
	*                   added by Chak Bhagvati on 31/03/2001        *
	****************************************************************/
	int HIPL_SpecifyOutParams(DATA *ID, int NRows, int NCols, int Type)
	{
	     extern int HIPL_ERRNO;
	
	     if (ID == NULL) {
		  HIPL_ERRNO = -11;
		  return(-1);
	     }
	     ID->COLS = NCols;
	     ID->ROWS = NRows;
	     if ((Type != BINARY) && (Type != ASCII)) {
		  HIPL_ERRNO = -10;
		  return(-1);
	     }
	     ID->ver = Type;
	
	     return(0);
	}
	
	int HIPL_CreateOutImage(THEADER *t, short arr_type, int Type, DATA *ID,
				int NRows, int NCols)
	{
	
	     if (ID == NULL) {
		  ID = (DATA *)malloc(sizeof(DATA));
		  if (ID == NULL) {
		       HIPL_ERRNO = -11;
		       return(-1);
		  }
		  ID->COLS = NCols;
		  ID->ROWS = NRows;
		  if ((Type != BINARY) && (Type != ASCII)) {
		       HIPL_ERRNO = -10;
		       return(-1);
		  }
		  ID->ver = Type;
	     }
	     if (HIPL_Initialise(t, NULL, 1, arr_type, ID) != 0)
		  return(-1);
	     if (HIPL_AllocateMem(t) != 0)
		  return(-1);
	
	     return(0);
	}
	
	void HIPL_PreprocessImage(THEADER *t1, THEADER *t2, int *imgtype)
	{
	     int i, j;
	
	     DB_printf(("Entered Preprocess Image\n"));
	     *imgtype = t1->img.TYPE;
	     if (*imgtype == PPM) {
		  i=HIPL_Getpart(t1);
		  for (i=0; i<t1->img.ROWS; i++) {
		       for (j=0; j<t1->img.COLS; j++) {
			    t2->jarr[i][j] = t1->jarr[i][j];
			    t2->karr[i][j] = t1->karr[i][j];
		       }
		  }
	     }
	     t1->img.TYPE = PGM;
	     HIPL_Refresh(t1, 0);
	     DB_printf(("Leaving Preprocess Image\n"));
	}
	
	void HIPL_PostprocessImage(THEADER *t1, THEADER *t2, int imgtype)
	{
	     DB_printf(("Entered Postprocess Image\n"));
	     t2->img.TYPE = imgtype;
	     
	     DB_printf(("Leaving Postprocess Image\n"));
	} 
	
