#include "incl.h"
#include <tcl.h>
extern char WINERR[];
extern int HIPL_ERRNO;
int mag=5,ang=0,flags=1;
char model[4]="HSV";
extern int pimg_init(HEADER *T, char *fname,short d,DATA *ID);
extern int negitive(HEADER *h1,HEADER *h2);
extern int morphcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int **mask,int opr);
extern int bimorphcall(HEADER *h1,HEADER *h2,int rows,int cols,int orgx,int orgy,int **mask,int opr);
int ObjectCmd(ClientData clientData, Tcl_Interp *interp, int argc,
char *argv[]) { 
	HEADER *T = (HEADER *) clientData;
	HEADER *T1;
	Tcl_CmdInfo infoptr;
	if(argc<2) {
		interp->result = "Wrong # arguments";
		return TCL_ERROR;
	}
	
	if(strcmp(argv[1],"cget")==0) {
		if(argc<3) {
			interp->result = "Wrong # arguments";
			return TCL_ERROR;
		}
		if(strcmp(argv[2],"-maxg")==0){
			sprintf(interp->result,"%d",T->ID->maxg);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-ming")==0){
			sprintf(interp->result,"%d",T->ID->ming);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-mean")==0){
			sprintf(interp->result,"%d",T->ID->mean);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-dev")==0){
			sprintf(interp->result,"%d",T->ID->dev);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-drows") == 0) {
			sprintf(interp->result,"%d",T->ID->ROWS);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-dcols") == 0) {
			sprintf(interp->result,"%d",T->ID->COLS);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-inertia") == 0) {
			sprintf(interp->result,"%f",T->ID->inertia);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-uniformity") == 0) {
			sprintf(interp->result,"%f",T->ID->uniformity);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-entropy") == 0) {
			sprintf(interp->result,"%f",T->ID->entropy);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-roughness") == 0) {
			sprintf(interp->result,"%f",T->ID->roughness);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-histvalue")==0){
			int val,max=255;
			if(argc < 4) {
				interp->result = "Wrong # args";
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp, argv[3],&val)==TCL_ERROR){
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp, argv[4],&max)==TCL_ERROR){
				return TCL_ERROR;
			}
			
			if(val>max)
				sprintf(interp->result,"%d",0);
			else
				sprintf(interp->result,"%ld",T->ID->hist[val]);
			return TCL_OK;
		}
		if(strcmp(argv[2],"-histile")==0){
			int i,val,pr,max=255;
			float pr1;
			unsigned long sum=0,sumval=0;
			if(argc < 4) {
				interp->result = "Wrong # args";
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp, argv[3],&val)==TCL_ERROR){
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp, argv[4],&max)==TCL_ERROR){
				return TCL_ERROR;
			}
			if(val>max)
				sprintf(interp->result,"%d",0);
				else	{	
					for(i=0;i<max+1;i++){
						sum+=T->ID->hist[i];
					}
					for(i=0;i<=val;i++){
						sumval+=T->ID->hist[i];
					}
					pr1=((float)sumval/(float) sum)*100;
					pr = (int) pr1;
					sprintf(interp->result,"%.3f",pr1);
				}
				return TCL_OK;
		}
	}
	if(strcmp(argv[1], "difference")==0) {
		static int unique=1;
		int i;
		HEADER *H;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		i = Tcl_GetCommandInfo(interp,argv[2],&infoptr);
		if(i==0) {
			interp->result="Image Object does not exist";
			return TCL_ERROR;
		}
		T1 = (HEADER *) infoptr.clientData;
		if ((T->T->img.ROWS!=T1->T->img.ROWS) || (T->T->img.COLS!=T1->T->img.COLS)) {
			strcpy(interp->result,"ERROR:Dimensions of two images must be same");
			return(TCL_ERROR);
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Dif%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Dif%d.ppm",unique);	
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=difference(T,T1,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1], "supermax")==0) {
		static int unique=1;
		int i;
		HEADER *H;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		i = Tcl_GetCommandInfo(interp,argv[2],&infoptr);
		if(i==0) {
			interp->result="Image Object does not exist";
			return TCL_ERROR;
		}
		T1 = (HEADER *) infoptr.clientData;
		if((T->T->img.ROWS!=T1->T->img.ROWS)||(T->T->img.COLS!=T1->T->img.COLS)){
			strcpy(interp->result,"ERROR:Dimensions of two images must be same");
			return(TCL_ERROR);
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Smax%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Smax%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=supermax(T,T1,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1], "superavg")==0) {
		static int unique=1;
		int i;
		HEADER *H;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		i = Tcl_GetCommandInfo(interp,argv[2],&infoptr);
		if(i==0) {
			interp->result="Image Object does not exist";
			return TCL_ERROR;
		}
		T1 = (HEADER *) infoptr.clientData;
		if((T->T->img.ROWS!=T1->T->img.ROWS)||(T->T->img.COLS!=T1->T->img.COLS)){
			strcpy(interp->result,"ERROR:Dimensions of two images must be same");
			return(TCL_ERROR);
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Savg%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Savg%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=superavg(T,T1,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1], "select")==0) {
		static int unique=1;
		int i,t1,t2,b1,b2;
		double tx,ty,bx,by;
		HEADER *sel;
		sel=(HEADER *)malloc(sizeof(HEADER));
		if(sel == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		sel->T=(THEADER *)malloc(sizeof(THEADER));
		if(sel->T == (THEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		sel->ID=(DATA *)malloc(sizeof(DATA));
		if(sel->ID == (DATA *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		if(argc<(6)) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[2],&tx)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[3],&ty)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[4],&bx)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[5],&by)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if((tx<0)||(ty<0)||(bx<0)||(by<0)) {
			interp->result="Incorrect Selection Parameters";
			return TCL_ERROR;
		}
		if((tx>bx)||(ty>by)) {
			interp->result="Incorrect Selection Parameters";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(sel->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(sel->fname,"HIPL_Sel%d.pgm",unique);
			else
				sprintf(sel->fname,"CIPL_Sel%d.ppm",unique);
			unique++;
		}
		t1=(int)tx;
		t2=(int)ty;
		b1=(int)bx;
		b2=(int)by;
		
		i=selection(T,sel,t1,t2,b1,b2);
		if(i<0) {
			free((char *)sel->T);
			free((char *)sel->ID);
			free ((char *) sel);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,sel->fname);
		free((char *)sel->T);
		free((char *)sel->ID);
		free ((char *)sel );
	}
	if(strcmp(argv[1], "paste")==0) {
		static int unique=1;
		int i,t1,t2,b1,b2;
		double px,py;
		HEADER *sel,*H;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		i = Tcl_GetCommandInfo(interp,argv[2],&infoptr);
		if(i==0) {
			interp->result="Image Object does not exist";
			return TCL_ERROR;
		}
		sel = (HEADER *) infoptr.clientData;
		if(argc<5) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[3],&px)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp,argv[4],&py)==TCL_ERROR){	
			return TCL_ERROR;
		}
		if((px<0)||(py<0)) {
			interp->result="Incorrect Paste Parameters";
			return TCL_ERROR;
		}
		if((px>T->T->img.COLS)||(py>T->T->img.ROWS)) {
			interp->result="Incorrect Paste Parameters";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Pa%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Pa%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		t1=(int)px;
		t2=(int)py;
		b1=t1+sel->T->img.ROWS-1;
		b2=t2+sel->T->img.COLS-1;
		if(b1 >(T->T->img.ROWS-1)) b1 = T->T->img.ROWS-1;
		if(b2 >(T->T->img.COLS-1)) b2 = T->T->img.COLS-1;
		i=paste(T,sel,H,t1,t2,b1,b2);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1], "ver") == 0) {
		sprintf(interp->result,"%d",T->T->ver);
	}
	if(strcmp(argv[1], "raw") == 0) {
		strcpy(interp->result,T->T->tempfname);
	}
	if(strcmp(argv[1],"rows") == 0) {
		sprintf(interp->result,"%d",T->T->img.ROWS);
	}
	if(strcmp(argv[1],"cols") == 0) {
		sprintf(interp->result,"%d",T->T->img.COLS);
	}
	if(strcmp(argv[1],"fname") == 0) {
		strcpy(interp->result,T->fname);
	}
	if(strcmp(argv[1],"getgray") == 0) {
		double d1,d2;
		int r,c,grey;
		unsigned long int l;
		if(argc < 4) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp, argv[2],&d1)==TCL_ERROR){
			return TCL_ERROR;
		};
		if(Tcl_GetDouble(interp, argv[3],&d2)==TCL_ERROR){
			return TCL_ERROR;
		};
		r=(int)d1;
		c=(int)d2;
		if((r<0)||(c<0)){
			interp->result="***";
			return TCL_OK;
		}
		if((r>=T->T->img.ROWS)||(c>=T->T->img.COLS)){
			interp->result="***";
			return TCL_OK;
		}
		l=(long)(r)*(long)(T->T->img.COLS)+(long)(c);
		if(T->T->ver == 1) l = 4*l;
		T->T->fptr=fopen(T->T->tempfname,"r");
		fseek(T->T->fptr,l,SEEK_SET);
		if(T->T->ver==0)
			grey = (int)fgetc(T->T->fptr);
		else
			fscanf(T->T->fptr,"%d",&grey);
		sprintf(interp->result,"%d",grey);
		fclose(T->T->fptr);
	}
	if(strcmp(argv[1],"neg")==0){
		HEADER *H;
		int i;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Neg%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Neg%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=negitive(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"convert")==0){
		HEADER *H;
		int i;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"IPL_Cnv%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=convert1(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"connect")==0){
		HEADER *H;
		int i;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Con%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=concomp(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"pthreshold")==0)
	{
		HEADER *H;
		double val,pr1,diff1,diff2,prev,valg,valb;
		int i,val1,grey,j,r=0,g=0,b=0,max;
		unsigned long int sum=0,sumval=0;
		static int unique=1;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetDouble(interp, argv[2],&val)==TCL_ERROR){
			return TCL_ERROR;
		}
		
		if((val>100)||(val<0)) {
			interp->result="Incorrect Percentile";
			return TCL_ERROR;
		}
		if(T->T->img.TYPE == PPM)
		{
			if(Tcl_GetDouble(interp, argv[3],&valg)==TCL_ERROR)
				return TCL_ERROR;
			if((valg>255)||(valg<0)) {
				interp->result="Incorrect Gray Level";
				return TCL_ERROR;
			}
			
			if(Tcl_GetDouble(interp, argv[4],&valb)==TCL_ERROR)
				return TCL_ERROR;
			if((valb>255)||(valb<0)) {
				interp->result="Incorrect Gray Level";
				return TCL_ERROR;
			}
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Pt%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Pt%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		if((flags &1)==1)
		{
			i=histcall(T,model,1);
			if(i!=0) return TCL_ERROR;
			for(i=0;i<256;i++){
				sum+=T->ID->hist[i];
			}
			prev=0;
			val1=0;
			do {
				sumval=0;	
				for(i=0;i<=val1;i++){
					sumval+=T->ID->hist[i];
				}
				pr1=((float)sumval/(float) sum)*100;
				if(val<pr1){
					if(prev==0){
						grey=0;
						break;
					}
					else {
						diff1=fabs(prev - val);
						diff2=fabs(pr1 - val);
						grey =(diff1>diff2)?val1:(val1-1);
						break;
					}
				}
				prev = pr1;
				val1++;
			}while(1);
			grey++;
			r=grey;
		}
		if((flags & 2)==2)
		{
			i=histcall(T,model,2);
			if(i!=0) return TCL_ERROR;
			if(strcmp(model,"HSV")==0)
				max=360;
			else
				max=256;
			for(i=0;i<max;i++){
				sum+=T->ID->hist[i];
			}
			prev=0;
			val1=0;
			do {
				sumval=0;	
				for(i=0;i<=val1;i++){
					sumval+=T->ID->hist[i];
				}
				pr1=((float)sumval/(float) sum)*100;
				if(valg<pr1){
					if(prev==0){
						grey=0;
						break;
					}
					else {
						diff1=fabs(prev - valg);
						diff2=fabs(pr1 - valg);
						grey =(diff1>diff2)?val1:(val1-1);
						break;
					}
				}
				prev = pr1;
				val1++;
			}while(1);
			grey++;
			g=grey;
		}
		if((flags & 4) == 4)
		{
			i=histcall(T,model,4);
			if(i!=0) return TCL_ERROR;
			if(strcmp(model,"HSV")==0)
				max=100;
			else
				max=256;
			for(i=0;i<max;i++){
				sum+=T->ID->hist[i];
			}
			prev=0;
			val1=0;
			do {
				sumval=0;	
				for(i=0;i<=val1;i++){
					sumval+=T->ID->hist[i];
				}
				pr1=((float)sumval/(float) sum)*100;
				if(valb<pr1){
					if(prev==0){
						grey=0;
						break;
					}
					else {
						diff1=fabs(prev - valb);
						diff2=fabs(pr1 - valb);
						grey =(diff1>diff2)?val1:(val1-1);
						break;
					}
				}
				prev = pr1;
				val1++;
			}while(1);
			grey++;
			b=grey;
		}
		i=threshold(T,H,r,g,b,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"gthreshold")==0){
		HEADER *H;
		int i,val,valg=0,valb=0,j;
		static int unique=1;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&val)==TCL_ERROR)
			return TCL_ERROR;
		if((val>255)||(val<0)) {
			interp->result="Incorrect Gray Level";
			return TCL_ERROR;
		}
		if(T->T->img.TYPE == PPM)
		{
			if(Tcl_GetInt(interp, argv[3],&valg)==TCL_ERROR)
				return TCL_ERROR;
			if((valg>255)||(valg<0)) {
				interp->result="Incorrect Gray Level";
				return TCL_ERROR;
			}
			
			if(Tcl_GetInt(interp, argv[4],&valb)==TCL_ERROR)
				return TCL_ERROR;
			if((valb>255)||(valb<0)) {
				interp->result="Incorrect Gray Level";
				return TCL_ERROR;
			}
		}
			H=(HEADER *)malloc(sizeof(HEADER));
			if(H == (HEADER *)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(i=0;i<argc;i++) {
				if(strcmp(argv[i],"-file")==0)
				{
					if(argc<(i+2)) {
						interp->result = "No file name Specified";
						return TCL_ERROR;
					}
					strcpy(H->fname,argv[i+1]);
					break;
				}
				if(strcmp(argv[i],"-flags")==0)
				{	if(argc<(i+2)) {
						interp->result = "No file name Specified";
						return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				}
				if(strcmp(argv[i],"-model")==0)
				{	if(argc<(i+2)) {
						interp->result = "No file name Specified";
						return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
				}
			}
			if(i==argc)
			{	if(T->T->img.TYPE == PGM)
					sprintf(H->fname,"HIPL_Gt%d.pgm",unique);
				else
					sprintf(H->fname,"CIPL_Gt%d.ppm",unique);
				unique++;
			}
			i=pimg_init(H,NULL,1,T->ID);
			if(i<0) {
				interp->result = "Error in initialise";
				return TCL_ERROR;
			}
			i=threshold(T,H,val,valg,valb,model,flags);
			if(i<0) {
				free((char *)H->T);
				free((char *)H->ID);
				free ((char *) H);
				Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
				return TCL_ERROR;
			}
			strcpy(interp->result,H->fname);
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
	}
	if(strcmp(argv[1],"bpslice")==0){
		HEADER *H;
		int i,val,j;
		static int unique=1;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&val)==TCL_ERROR){
			return TCL_ERROR;
		};
		if((val>7)||(val<0)) {
			interp->result="Incorrect Bit Number";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	
			sprintf(H->fname,"HIPL_Bp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=bpslice(T,H,val,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"istretch")==0){
		HEADER *H;
		int i,iter;
		static int unique=1;
		if(argc<3) {
			interp->result = "Wrong # arguments";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Ist%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&iter)==TCL_ERROR){
			return TCL_ERROR;
		};
		if(iter<0) {
			interp->result="Incorrect Increments";
			return TCL_ERROR;
		}
		i=autoscall(T,H,iter);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"double")==0){
		HEADER *H;
		int i;
		static int unique=1;
		DATA ID;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Db%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Db%d.ppm",unique);
			unique++;
		}
		ID.ROWS = 2*T->ID->ROWS;
		ID.COLS = 2*T->ID->COLS;
		ID.ver = T->ID->ver;
		ID.type = T->ID->type;
		i=pimg_init(H,NULL,1,&ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=dbcall(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"hflip")==0){
		HEADER *H;
		int i;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Hf%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Hf%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=horiflip(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"transpose")==0){
		HEADER *H;
		int i;
		static int unique=1;
		if(T->T->img.COLS != T->T->img.ROWS) {
			interp->result="Not a Square Image";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Tr%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Tr%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=transpose(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"equalise")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Eq%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Eq%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=histeqcall(T,H,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}		
	if(strcmp(argv[1],"stretch")==0){
		HEADER *H;
		int i,gmin,gmax,j;
		static int unique=1;
		if(argc<4) {
			interp->result = "Wrong # arguments";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&gmin)==TCL_ERROR){
			return TCL_ERROR;
		};
		if(Tcl_GetInt(interp, argv[3],&gmax)==TCL_ERROR){
			return TCL_ERROR;
		};
		if((gmin<0)||(gmax<0)||(gmin>=gmax)||(gmin>255)||(gmax>255)) {
			interp->result="Incorrect Range";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_St%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_St%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=histstcall(T,H,gmax,gmin,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}		
	if(strcmp(argv[1],"lstretch")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Lst%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Lst%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=logstretch(T,H,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}		
	if(strcmp(argv[1],"dilate")==0){
		HEADER *H;
		int i, **mask,j,k,l,rows,cols,orgx,orgy,count;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=128;
			mask[0][1]=128;
			mask[0][2]=128;
			mask[1][0]=128;
			mask[1][1]=128;
			mask[1][2]=128;
			mask[2][0]=128;
			mask[2][1]=128;
			mask[2][2]=128;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Dl%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=morphcall(T,H,rows,cols,orgx,orgy,mask,0);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"erode")==0){
		HEADER *H;
		int i,count,j,k,l,orgx,orgy,rows,cols,**mask;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=128;
			mask[0][1]=128;
			mask[0][2]=128;
			mask[1][0]=128;
			mask[1][1]=128;
			mask[1][2]=128;
			mask[2][0]=128;
			mask[2][1]=128;
			mask[2][2]=128;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Er%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=morphcall(T,H,rows,cols,orgx,orgy,mask,1);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++)
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"open")==0){
		HEADER *H;
		int i,j,k,l,count,orgx,orgy,rows,cols,**mask;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=128;
			mask[0][1]=128;
			mask[0][2]=128;
			mask[1][0]=128;
			mask[1][1]=128;
			mask[1][2]=128;
			mask[2][0]=128;
			mask[2][1]=128;
			mask[2][2]=128;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Op%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=morphcall(T,H,rows,cols,orgx,orgy,mask,2);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"close")==0){
		HEADER *H;
		int i,count,j,k,l,rows,cols,orgx,orgy,**mask;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=128;
			mask[0][1]=128;
			mask[0][2]=128;
			mask[1][0]=128;
			mask[1][1]=128;
			mask[1][2]=128;
			mask[2][0]=128;
			mask[2][1]=128;
			mask[2][2]=128;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Cl%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=morphcall(T,H,rows,cols,orgx,orgy,mask,3);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	
	if(strcmp(argv[1],"bidilate")==0){
		HEADER *H;
		int i,rows,cols,orgx,orgy,count,j,k,l,**mask;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
					if((mask[k][l]!=0)&&(mask[k][l]!=255)) {
						interp->result="Mask values must be 0 or 255";
						return(TCL_ERROR);
					}
					
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(cols*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=255;
			mask[0][1]=255;
			mask[0][2]=255;
			mask[1][0]=255;
			mask[1][1]=255;
			mask[1][2]=255;
			mask[2][0]=255;
			mask[2][1]=255;
			mask[2][2]=255;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Bdl%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=bimorphcall(T,H,rows,cols,orgx,orgy,mask,0);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"bierode")==0){
		HEADER *H;
		int i,**mask,j,k,l,count,rows,cols,orgx,orgy;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
					if((mask[k][l]!=0)&&(mask[k][l]!=255)) {
						interp->result="Mask values must be 0 or 255";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=255;
			mask[0][1]=255;
			mask[0][2]=255;
			mask[1][0]=255;
			mask[1][1]=255;
			mask[1][2]=255;
			mask[2][0]=255;
			mask[2][1]=255;
			mask[2][2]=255;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Ber%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=bimorphcall(T,H,rows,cols,orgx,orgy,mask,1);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"biopen")==0){
		HEADER *H;
		int i,j,k,l,orgx,orgy,rows,cols,count,**mask;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
					if((mask[k][l]!=0)&&(mask[k][l]!=255)) {
						interp->result="Mask values must be 0 or 255";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=255;
			mask[0][1]=255;
			mask[0][2]=255;
			mask[1][0]=255;
			mask[1][1]=255;
			mask[1][2]=255;
			mask[2][0]=255;
			mask[2][1]=255;
			mask[2][2]=255;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Bop%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=bimorphcall(T,H,rows,cols,orgx,orgy,mask,2);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"biclose")==0){
		HEADER *H;
		int i,**mask,orgx,rows,cols,orgy,count,j,k,l;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
					if((mask[k][l]!=0)&&(mask[k][l]!=255)) {
						interp->result="Mask values must be 0 or 255";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=255;
			mask[0][1]=255;
			mask[0][2]=255;
			mask[1][0]=255;
			mask[1][1]=255;
			mask[1][2]=255;
			mask[2][0]=255;
			mask[2][1]=255;
			mask[2][2]=255;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Bcl%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=bimorphcall(T,H,rows,cols,orgx,orgy,mask,3);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"applymask")==0){
		HEADER *H;
		double den=1.0;
		int i,**mask,count,j,k,l,orgx,orgy,rows,cols;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+rows*cols+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				count=i+3;
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					j=sscanf(argv[count++],"%d",&mask[k][l]);
					if(j!=1) {
						interp->result="Error in mask specification";
						return(TCL_ERROR);
					}
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=1;
			mask[0][1]=1;
			mask[0][2]=1;
			mask[1][0]=1;
			mask[1][1]=1;
			mask[1][2]=1;
			mask[2][0]=1;
			mask[2][1]=1;
			mask[2][2]=1;
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Mma%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Mma%d.ppm",unique);	
			unique++;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-factor")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Wrong # arguments";
					return TCL_ERROR;
				}
				if(Tcl_GetDouble(interp,argv[i+1],&den)==TCL_ERROR)
					return TCL_ERROR;
					if(den <= 0) {
						interp->result = "Wrong factor value";
						return TCL_ERROR;
					}
					break;
			}
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=movemaskcall(T,H,rows,cols,orgx,orgy,mask,den,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"mlowpass")==0){
		HEADER *H;
		double den=0.0;
		int i,**mask,j,k,l,orgx,orgy,rows,cols;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					mask[k][l] = 1;
					den+=(double)mask[k][l];
				}
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=1;
			mask[0][1]=1;
			mask[0][2]=1;
			mask[1][0]=1;
			mask[1][1]=1;
			mask[1][2]=1;
			mask[2][0]=1;
			mask[2][1]=1;
			mask[2][2]=1;
			orgx=orgy=1;
			rows=cols=3;
			den=9.0;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
				
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Lp%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Lp%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=movemaskcall(T,H,rows,cols,orgx,orgy,mask,den,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"mhighpass")==0){
		HEADER *H;
		double den=0.0;
		int i,**mask,j,k,l,orgx,orgy,rows,cols;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				mask=(int **)malloc(rows*sizeof(int *));
				if(mask == (int **)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
				for(k=0;k<rows;k++) { 
					mask[k]=(int *)malloc(cols*sizeof(int));
					if(mask[k]== (int *)0) {
						interp->result="UNABLE to Allocate Memory";
						return TCL_ERROR;
					}
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				for(k=0;k<rows;k++) 
				for(l=0;l<cols;l++) {
					if((k == orgx)&&(l == orgy))
						mask[k][l] = rows*cols - 1;
					else
						mask[k][l] = -1;
				}
				den =(double)rows*cols;
				break;
			}
		}
		if(i==argc)
		{
			mask=(int **)malloc(3*sizeof(int *));
			if(mask == (int **)0) {
				interp->result="UNABLE to Allocate Memory";
				return TCL_ERROR;
			}
			for(k=0;k<3;k++) { 
				mask[k]=(int *)malloc(3*sizeof(int));
				if(mask[k]== (int *)0) {
					interp->result="UNABLE to Allocate Memory";
					return TCL_ERROR;
				}
			}
			mask[0][0]=-1;
			mask[0][1]=-1;
			mask[0][2]=-1;
			mask[1][0]=-1;
			mask[1][1]=8;
			mask[1][2]=-1;
			mask[2][0]=-1;
			mask[2][1]=-1;
			mask[2][2]=-1;
			orgx=orgy=1;
			rows=cols=3;
			den=9.0;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Hp%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Hp%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=movemaskcall(T,H,rows,cols,orgx,orgy,mask,den,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<rows;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"highboost")==0){
		HEADER *H;
		int i,j;
		double a=1.15,**mask,den=9.0;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-amplification")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetDouble(interp,argv[i+1],&a)==TCL_ERROR)
					return TCL_ERROR;
					if( a < 1) {
						interp->result = "wrong amplification factor";
						return TCL_ERROR;
					}
			}
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Hb%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Hb%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		mask=(double **)malloc(3*sizeof(double *));
		for(i=0;i<3;i++) 
			mask[i]=(double *)malloc(3*sizeof(double));
		mask[0][0]=-1.0;
		mask[0][1]=-1.0;
		mask[0][2]=-1.0;
		mask[1][0]=-1.0;
		mask[1][1]=9*a-1;
		mask[1][2]=-1.0;
		mask[2][0]=-1.0;
		mask[2][1]=-1.0;
		mask[2][2]=-1.0;
		i=fmovemaskcall(T,H,mask,den,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		for(i=0;i<3;i++) 
			free(mask[i]);
		free(mask);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"thin")==0){
		HEADER *H;
		int i;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Thin%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=thinning(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"canny")==0){
		HEADER *H;
		double sigma=1.0;
		int i,lo=-1,hi=-1,j;
		static int unique=1;
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-stddev")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetDouble(interp, argv[i+1],&sigma)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(sigma <= 0) {
					interp->result = "Sigma must be > 0";
					return TCL_ERROR;
				}
				break;
			}
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-thresholds")==0)
			{
				if (argc<(i+3)) {
					interp->result="wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&lo)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&hi)==TCL_ERROR){
					return TCL_ERROR;
				}
				break;
			}
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Can%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Can%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=pcannycall(T,H,sigma,lo,hi,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fft")==0){
		HEADER *H;
		int i,row,l,m;
		double m1;
		static int unique=1;
		if(T->T->img.COLS != T->T->img.ROWS) {
			interp->result="Not a Square Image";
			return TCL_ERROR;
		}
		row = T->T->img.ROWS;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(i = 0;i<m;i++) l<<=1;
		if(l != row) {
			interp->result = "Image size is not a Power of 2";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fft%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=fft(T,H);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"flowpass")==0){
		HEADER *H;
		int i,ii,m,l,row,msize=5,isize=32,win1=1,type=1,order=3;
		static int unique=1;
		double cf=2.0,m1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+2)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf>(double)M_PI)||(cf<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Flp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbw(T,H,cf,0);
			break;
			case 1:
			i=timemask(T,H,isize,msize,cf,win1,0);
			break;
			case 2:
			i=iirmask(T,H,isize,order,cf,win1,0);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fhighpass")==0){
		HEADER *H;
		int i,ii,msize=5,isize=32,win1=1,type=1,order=3;
		int row,l,m;
		double m1;
		static int unique=1;
		double cf=2.0;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+2)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf>(double)M_PI)||(cf<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fhp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbw(T,H,cf,1);
			break;
			case 1:
			i=timemask(T,H,isize,msize,cf,win1,1);
			break;
			case 2:
			i=iirmask(T,H,isize,order,cf,win1,1);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fbwlowpass")==0){
		HEADER *H;
		int i,ii,msize=5,isize=32,win1=1,type=1,order=3;
		int row,l,m;
		double m1;
		static int unique=1;
		double cf=2.0;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+2)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf>(double)M_PI)||(cf<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fbwlp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbw(T,H,cf,2);
			break;
			case 1:
			i=timemask(T,H,isize,msize,cf,win1,2);
			break;
			case 2:
			i=iirmask(T,H,isize,order,cf,win1,2);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fbwhighpass")==0){
		HEADER *H;
		int i,msize=5,isize=32,win1=1,type=1,order=3;
		int row,l,m,ii;
		double m1;
		static int unique=1;
		double cf=2.0;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+2)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+4)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+4],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf>(double)M_PI)||(cf<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fbwhp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbw(T,H,cf,3);
			break;
			case 1:
			i=timemask(T,H,isize,msize,cf,win1,3);
			break;
			case 2:
			i=iirmask(T,H,isize,order,cf,win1,3);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fbandpass")==0){
		HEADER *H;
		int i,msize=5,isize=32,win1=1,type=1,order=3;
		int row,l,m,ii;
		double m1;
		static int unique=1;
		double cf1=1.0,cf2 = 3.0;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+3)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+2],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+4],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+5],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+4],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+5],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf1>(double)M_PI)||(cf1<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if((cf2>(double)M_PI)||(cf2<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(cf1>=cf2) {
			interp->result = "Cutoff low must be < Cutoff high";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fbp%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbp(T,H,cf1,cf2,0);
			break;
			case 1:
			i=timebpmask(T,H,isize,msize,cf1,cf2,win1,0);
			break;
			case 2:
			i=iirbpmask(T,H,isize,order,cf1,cf2,win1,0);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"fbandreject")==0){
		HEADER *H;
		int i,msize=5,isize=32,win1=1,type=1,order=3;
		int row,l,m,ii;
		double m1;
		static int unique=1;
		double cf1=1.0,cf2 = 3.0;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-type")==0){
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(strcmp(argv[i+1],"fft")==0) type = 0;
				if(strcmp(argv[i+1],"fir")==0) type = 1;
				if(strcmp(argv[i+1],"iir")==0) type = 2;
				break;
			}
		}
		for(i=0;i<argc;i++){
			if(strcmp(argv[i],"-values")==0){
				switch(type){
					case 0:
					if(T->T->img.COLS != T->T->img.ROWS) {
						interp->result="Not a Square Image";
						return TCL_ERROR;
					}
					row = T->T->img.ROWS;
					l = 1;
					m1 = log10((double)row)/log10((double)2.0);
					m = (int)m1;
					for(ii = 0;ii<m;ii++) l<<=1;
					if(l != row) {
						interp->result = "Image size is not a Power of 2";
						return TCL_ERROR;
					}
					if(argc<(i+3)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+1],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+2],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					break;
					case 1:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&msize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+4],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+5],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
					case 2:
					if(argc<(i+5)) {
						interp->result = "wrong # args";
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+1],&isize)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+2],&order)==TCL_ERROR){	
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+3],&cf1)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetDouble(interp, argv[i+4],&cf2)==TCL_ERROR){
						return TCL_ERROR;
					}
					if(Tcl_GetInt(interp,argv[i+5],&win1)==TCL_ERROR){	
						return TCL_ERROR;
					}
					break;
				}
				break;
			}
		}
		row = isize;
		l = 1;
		m1 = log10((double)row)/log10((double)2.0);
		m = (int)m1;
		for(ii = 0;ii<m;ii++) l<<=1;
		if(l != row) {
			interp->result = "Impulse size is not a Power of 2";
			return TCL_ERROR;
		}
		if((cf1>(double)M_PI)||(cf1<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if((cf2>(double)M_PI)||(cf2<0)) {
			interp->result = "Cutoff must be between 0 and PI";
			return TCL_ERROR;
		}
		if(cf1>=cf2) {
			interp->result = "Cutoff low must be < Cutoff high";
			return TCL_ERROR;
		}
		if(((msize%2)==0)||(msize<=0)||(msize>isize)) {
			interp->result = "Mask size must be odd and < impulse size";
			return TCL_ERROR;
		}
		if((order>=(isize/2))||(order<=0)) {
			interp->result = "Order must be < impulse size / 2";
			return TCL_ERROR;
		}
		if((win1<1)||(win1>4)) {
			interp->result = "Window must be between 1 and 4";
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Fbr%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		switch(type){
			case 0:
			i=fftlhbp(T,H,cf1,cf2,1);
			break;
			case 1:
			i=timebpmask(T,H,isize,msize,cf1,cf2,win1,1);
			break;
			case 2:
			i=iirbpmask(T,H,isize,order,cf1,cf2,win1,1);
			break;
		}
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"sobel")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	sprintf(H->fname,"HIPL_So%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=sobel(T,H,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"gaussian")==0){
		HEADER *H;
		int i,sig=1,j;
		static int unique=1;
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-sigma")==0)
			{
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&sig)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(sig<1) {
					interp->result = "Sigma must be > 1";
					return TCL_ERROR;
				}
				break;
			}
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Gau%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Gau%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=gaussian(T,H,sig,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"prewitts")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Pre%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=prewitts(T,H,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"roberts")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Ro%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=roberts(T,H,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"kirsch")==0){
		HEADER *H;
		int i,j;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Kir%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=kirsch(T,H,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"applymedian")==0){
		HEADER *H;
		int i,j,orgx,orgy,rows,cols;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-mask")==0)
			{
				if(argc<(i+2)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%dx%d",&rows,&cols);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((rows<=0)||(cols<=0)) {
					interp->result = "Incorrect mask specification";
					return TCL_ERROR;
				}
				if(argc<(i+3)) {
					interp->result = "wrong # args";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+2],"%dx%d",&orgx,&orgy);
				if(j!=2) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
				if((orgx>=rows)||(orgy>=cols)) {
					interp->result="Mask origin exceeds Mask dimensions";
					return(TCL_ERROR);
				}
				break;
			}
		}
		if(i==argc)
		{
			orgx=orgy=1;
			rows=cols=3;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{	if(T->T->img.TYPE == PGM)
				sprintf(H->fname,"HIPL_Mme%d.pgm",unique);
			else
				sprintf(H->fname,"CIPL_Mme%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=movemedcall(T,H,rows,cols,orgx,orgy,flags,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"texinit")==0){
		int i;
		i=texcall(T,mag,ang);
		if(i<0) return TCL_ERROR;
	}
	if(strcmp(argv[1],"histinit")==0){
		int i,j;
		for(i=0;i<argc;i++)
		{
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
				
		}
		i=histcall(T,model,flags);
		if(i<0) return TCL_ERROR;
	}
	if(strcmp(argv[1],"histval")==0){
		int i,val,max=256;
		unsigned long sum=0,pr;
		float pr1;			
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&val)==TCL_ERROR){
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[3],&max)==TCL_ERROR){
			return TCL_ERROR;
		}
		if(val>max)
		{	pr=0;
			sprintf(interp->result,"%ld",pr);
		}
		else
		{
			for(i=0;i<max;i++){
				if(sum<T->ID->hist[i])
					sum=T->ID->hist[i];
			}
			pr1=((float)T->ID->hist[val]/(float)sum)*150.0;
			pr=(int)pr1;
			sprintf(interp->result,"%ld",pr);
		}
	}
	if(strcmp(argv[1],"increment255")==0){
		int val,max;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&val)==TCL_ERROR){
			return TCL_ERROR;
		}
		if(T->T->img.TYPE == PGM)
			max = 255;
		else
			max=360;
		if(val==max)
			val=0;
		else val++;	
		sprintf(interp->result,"%d",val);
	}
	if(strcmp(argv[1],"decrement255")==0){
		int val;
		if(argc < 3) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&val)==TCL_ERROR){
			return TCL_ERROR;
		};
		if(val==0)
		{	if(T->T->img.TYPE == PGM)
				val = 255;
			else
				val=360;
		}
		else val--;	
		sprintf(interp->result,"%d",val);
	}
	if(strcmp(argv[1],"range")==0){
		HEADER *H;
		int i,lo,hi;
		static int unique=1;
		if(argc < 4) {
			interp->result = "Wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&lo)==TCL_ERROR){
			return TCL_ERROR;
		};
		if(Tcl_GetInt(interp, argv[3],&hi)==TCL_ERROR){
			return TCL_ERROR;
		};
		if((lo<-1)||(hi<-1)||(lo>=hi)||(lo>256)||(hi>256)) {
			interp->result="Incorrect Range";
			return TCL_ERROR;
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Ran%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=rangecall(T,H,lo,hi);
		if(i!=0) return TCL_ERROR;
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	
	/*color specific operations */
	
	if(strcmp(argv[1],"huepolarise")==0){
		HEADER *H;
		int i,j,per=0,n=0,*arr;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-per")==0)
			{
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&per)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(per<0) {
					interp->result = "Percentage must be > 0";
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-n")==0)
			{
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(n<0) {
					interp->result = "n must be > 0";
					return TCL_ERROR;
				}
				arr=(int*)malloc(n*sizeof(int));
			}
			if(strcmp(argv[i],"-values")==0)
			{
				if(argc < (i+n+1)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				for(j=0;j<n;j++,i++)
				{
					if(Tcl_GetInt(interp, argv[i+1],&arr[j])==TCL_ERROR){
						return TCL_ERROR;
					}
					if(arr[j]<0) {
						interp->result = "values must be > 0";
						return TCL_ERROR;
					}
				}
				
			}
			
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Huepola%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=huepolarise(T,H,per,arr,n);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
		free(arr);
	}
	if(strcmp(argv[1],"satuvariation")==0){
		HEADER *H;
		int i,j,per=0;
		static int unique=1;
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-per")==0)
			{
				if(argc < (i+2)) {
					interp->result = "Wrong # args";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&per)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(per<0) {
					interp->result = "Percentage must be > 0";
					return TCL_ERROR;
				}
				break;
			}
		}
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Satuvari%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=satuvariation(T,H,per);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}	
	
	
	if(strcmp(argv[1],"extract")==0){
		HEADER *H;
		int i,j,flags;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
			if(strcmp(argv[i],"-flags")==0)
			{	if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				j=sscanf(argv[i+1],"%d",&flags);
				if(j!=1) {
					interp->result="Error in mask specification";
					return(TCL_ERROR);
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"HIPL_Extract%d.pgm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=extractfromPPM(T,H,model,flags);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"medcut")==0){
		HEADER *H;
		int i,j,boxes=0;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&boxes)==TCL_ERROR){
			return TCL_ERROR;
		}
		
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Medcut%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=medcut(T,H,boxes);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"octree")==0){
		HEADER *H;
		int i,j,levels=0,colors=0;
		static int unique=1;
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[2],&levels)==TCL_ERROR){
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp, argv[3],&colors)==TCL_ERROR){
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Octree%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=octree(T,H,levels,colors);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"idealpass")==0){
		HEADER *H;
		int i,j,x,y,z,bx,by,bz;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-point")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&x)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&y)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&z)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bx)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&by)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&bz)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No model name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Idealpass%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=idealpass(T,H,x,y,z,bx,by,bz,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"idealreject")==0){
		HEADER *H;
		int i,j,x,y,z,bx,by,bz;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-point")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&x)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&y)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&z)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bx)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&by)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&bz)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No model name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Idealreject%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=idealreject(T,H,x,y,z,bx,by,bz,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"butterworthpass")==0){
		HEADER *H;
		int i,j,x=0,y=0,z=0,bx=0,by=0,bz=0,n=1;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-order")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Order not Specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-point")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&x)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&y)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&z)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bx)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&by)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&bz)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No model name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Butterpass%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=butterworthpass(T,H,x,y,z,bx,by,bz,n,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"butterworthreject")==0){
		HEADER *H;
		int i,j,x=0,y=0,z=0,bx=0,by=0,bz=0,n=1;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-order")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Order not Specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-point")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&x)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&y)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&z)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+4)) {
					interp->result = "Must have 3 values";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bx)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+2],&by)==TCL_ERROR){
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+3],&bz)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-model")==0)
			{	if(argc<(i+2)) {
					interp->result = "No model name Specified";
					return TCL_ERROR;
				}
				strcpy(model,argv[i+1]);
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Butterreject%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=butterworthreject(T,H,x,y,z,bx,by,bz,n,model);
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"hsiidealpass")==0){
		HEADER *H;
		int i,j,h,bh;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-hue")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Hue value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&h)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Bandwidth value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bh)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_HSIIdealpass%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=hsiidealpass(T,H,h,bh);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"hsiidealreject")==0){
		HEADER *H;
		int i,j,h,bh;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-hue")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Hue value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&h)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Bandwidth value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bh)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_HSIIdealreject%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=hsiidealreject(T,H,h,bh);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"hsibutterworthpass")==0){
		HEADER *H;
		int i,j,h=0,bh=0,n=1;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-hue")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Hue value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&h)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Bandwidth value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bh)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-order")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Order not Specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_HSIButterworthpass%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=hsibutterworthpass(T,H,h,bh,n);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"hsibutterworthreject")==0){
		HEADER *H;
		int i,j,h=0,bh=0,n=1;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-hue")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Hue value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&h)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Bandwidth value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bh)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-order")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Order not Specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_HSIButterworthreject%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		i=hsibutterworthreject(T,H,h,bh,n);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	if(strcmp(argv[1],"xyzfilter")==0){
		HEADER *H;
		int i,j,nm=0,bw=0,n=1;
		static int unique=1;
		
		H=(HEADER *)malloc(sizeof(HEADER));
		if(H == (HEADER *)0) {
			interp->result="UNABLE to Allocate Memory";
			return TCL_ERROR;
		}
		for(i=0;i<argc;i++) {
			if(strcmp(argv[i],"-file")==0)
			{
				if(argc<(i+2)) {
					interp->result = "No file name Specified";
					return TCL_ERROR;
				}
				strcpy(H->fname,argv[i+1]);
				break;
			}
			if(strcmp(argv[i],"-nm")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Hue value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&nm)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-bw")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Bandwidth value not specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&bw)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
			if(strcmp(argv[i],"-order")==0)
			{
				if(argc<(i+2)) {
					interp->result = "Order not Specified";
					return TCL_ERROR;
				}
				if(Tcl_GetInt(interp, argv[i+1],&n)==TCL_ERROR){
					return TCL_ERROR;
				}
			}
		}
		if(i==argc)
		{
			sprintf(H->fname,"CIPL_Xyzfilter%d.ppm",unique);
			unique++;
		}
		i=pimg_init(H,NULL,1,T->ID);
		if(i<0) {
			interp->result = "Error in initialise";
			return TCL_ERROR;
		}
		
		i=xyzfilter(T,H,nm,bw,n);
		
		if(i<0) {
			free((char *)H->T);
			free((char *)H->ID);
			free ((char *) H);
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		strcpy(interp->result,H->fname);
		free((char *)H->T);
		free((char *)H->ID);
		free ((char *) H);
	}
	return TCL_OK;
}

void DeletePimg( ClientData clientData) {
	HEADER *T = (HEADER *) clientData;
	remove(T->T->tempfname);
	free((char *)T->T);
	free((char *)T->ID);
	free ((char *) T);
}


int PimageCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]){
	int i,j;
	static int id=1;
	HEADER *T;
	T=(HEADER *)malloc(sizeof(HEADER));
	if(T == (HEADER *)0) {
		interp->result="UNABLE to Allocate Memory";
		return TCL_ERROR;
	}
	if((argc!=2)&&(argc!=4)){
		interp->result="wrong # args";
		return TCL_ERROR;
	}
	for(i=0;i<argc;i++) {
		if(strcmp(argv[i],"-objname")==0)
		{
			j = pimg_init(T,argv[1],0,T->ID);
			if(j<0) {
				Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
				return TCL_ERROR;
			}
			sprintf(interp->result,"%s", argv[i+1]);
			break;
		}
	}
	if(i==argc)
	{
		j =pimg_init(T,argv[1],0,T->ID);
		if(j<0) {
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		sprintf(interp->result, "pimg%d", id);
	}
	/*	if(argc == 2) {
		i =pimg_init(T,argv[1],0,T->ID);
		if(i<0) {
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		sprintf(interp->result, "pimg%d", id);
	}
	if(argc == 3) {
		i = pimg_init(T,argv[1],0,T->ID);
		if(i<0) {
			Tcl_SetResult(interp,WINERR,TCL_VOLATILE);
			return TCL_ERROR;
		}
		sprintf(interp->result,"%s", argv[2]);
	}
	*/	
	strcpy(T->fname,argv[1]);
	Tcl_CreateCommand(interp, interp->result, ObjectCmd,(ClientData) T ,DeletePimg);
	id++;
	return TCL_OK;
}

int SetmemCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]){
	int i;
	if(argc!=2){
		interp->result="wrong # args";
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[1],&i)==TCL_ERROR)
		return TCL_ERROR;
	HIPL_Setmemory(i);
	return TCL_OK;
}
int SettexCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]){
	int mag1,ang1;
	if(argc!=3){
		interp->result="wrong # args";
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[1],&mag1)==TCL_ERROR)
		return TCL_ERROR;
	if(Tcl_GetInt(interp, argv[2],&ang1)==TCL_ERROR)
		return TCL_ERROR;
	mag = mag1;
	ang = ang1;
	return TCL_OK;
}

int CounterCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]){
	static int counter = 1;
	if(argc!=2){
		interp->result="wrong # args";
		return TCL_ERROR;
	}
	if(strcmp(argv[1],"get")==0){
		sprintf(interp->result,"%d",(counter-1));
		return TCL_OK;
	} else if(strcmp(argv[1],"next")==0){
		sprintf(interp->result,"%d",counter++);
	} else {
		interp->result="wrong command";
		return TCL_ERROR;
	}
	return TCL_OK;
}

int NewimgCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]){
	int i,grey=0,width=128,height=128,red,green,blue,flag=0;
	HEADER *H;
	static int unique = 1;
	char fname[100];
	for(i=0;i<argc;i++) 
	if(strcmp(argv[i],"-gray")==0){
		if(argc<(i+2)) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp,argv[i+1],&grey)==TCL_ERROR){	
			return TCL_ERROR;
		}
		break;
	}
	for(i=0;i<argc;i++) 
	if(strcmp(argv[i],"-width")==0){
		if(argc<(i+2)) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp,argv[i+1],&width)==TCL_ERROR){	
			return TCL_ERROR;
		}
		break;
	}
	for(i=0;i<argc;i++)
	if(strcmp(argv[i],"-height")==0){
		if(argc<(i+2)) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		if(Tcl_GetInt(interp,argv[i+1],&height)==TCL_ERROR){	
			return TCL_ERROR;
		}
		break;
	}
	
	for(i=0;i<argc;i++)
	{
		if(strcmp(argv[i],"-red")==0){
			if(argc<(i+2)) {
				interp->result = "wrong # args";
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp,argv[i+1],&grey)==TCL_ERROR){	
				return TCL_ERROR;
			}
			flag=1;
		}
		if(strcmp(argv[i],"-green")==0){
			if(argc<(i+2)) {
				interp->result = "wrong # args";
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp,argv[i+1],&green)==TCL_ERROR){	
				return TCL_ERROR;
			}
			
		}
		if(strcmp(argv[i],"-blue")==0){
			if(argc<(i+2)) {
				interp->result = "wrong # args";
				return TCL_ERROR;
			}
			if(Tcl_GetInt(interp,argv[i+1],&blue)==TCL_ERROR){	
				return TCL_ERROR;
			}
			
		}
	}
	
	for(i=0;i<argc;i++)
	if(strcmp(argv[i],"-file")==0){
		if(argc<(i+2)) {
			interp->result = "wrong # args";
			return TCL_ERROR;
		}
		strcpy(fname,argv[i+1]);
		break;
	}
	if(i==argc) {
		sprintf(fname,"HIPL_New%d.pgm",unique++);
	}	
	H=(HEADER *)malloc(sizeof(HEADER));
	if(H == (HEADER *)0) {
		interp->result="UNABLE to Allocate Memory";
		return TCL_ERROR;
	}
	H->T=(THEADER *)malloc(sizeof(THEADER));
	if(H->T == (THEADER *)0) {
		interp->result="UNABLE to Allocate Memory";
		return TCL_ERROR;
	}
	H->ID=(DATA *)malloc(sizeof(DATA));
	if(H->ID == (DATA *)0) {
		interp->result="UNABLE to Allocate Memory";
		return TCL_ERROR;
	}
	strcpy(H->fname,fname);
	i = newimg(H,height,width,grey,green,blue,flag);
	if(i < 0) return TCL_ERROR;
	strcpy(interp->result,fname);
	free(H->T);
	free(H->ID);
	free(H);
	return TCL_OK;
}
