#include "incl.h"

extern int HIPL_Initialise(THEADER *t,char *name,short i,short j,DATA *ID);
extern int HIPL_Getpart(THEADER *t);
extern int HIPL_Putpart(THEADER *t);
extern int HIPL_StoreResult(char *name,THEADER *T);
extern int HIPL_Closeall(THEADER *T);
extern int HIPL_AllocateMem(THEADER *T);
extern int HIPL_FreeMem(THEADER *T);
extern void HIPL_Error(char *msg);
extern int HIPL_ERRNO;
extern int HIPL_Refresh(THEADER *T,int i);

int HIPL_GLCM(THEADER *T,int dist,int angle,DATA *ID);

/****************************************************************
*	FUNCTION : HIPL_GLCM					*
*								*
*	INPUT	 : source 					*
*								*
*	OUTPUT	 : 0 on success					*
*		   negative value on failure			*
*								*
*    DESCRIPTION : Finds the cooccurance matrix			*
*		     form which the user specifies distance	*
*			and angle				*
*								*
*   EXTERNAL CALLS : 1)HIPL_Initialise				*
*		     2)HIPL_Getpart				*
*		     3)HIPL_Putpart				*
*		     4)HIPL_StoreResult				*
*		     5)HIPL_Error				*
*		     6)HIPL_Closeall				*
*		  File :HIPL_Coreio.c				*
*		    						*
*								*
****************************************************************/

int HIPL_GLCM(THEADER *it,int dist,int angle,DATA *IDO)
{

	long int i,j,max1,cflag;
        unsigned long int  GLCM[256][256];
	unsigned long int sum=0;
	double tflag=0;
	DATA ID;
	double theta,t1,tt,x,y;
	int signx,signy,xinc,yinc;
	ID.ROWS=it->img.ROWS;
	ID.COLS=it->img.COLS;
	ID.ver=it->ver;
	HIPL_Refresh(it,0);
	for(i=0;i<256;i++)
		for(j=0;j<256;j++)
			GLCM[i][j]=0;
	theta=(float)M_PI*(double)angle/180;
	x=dist*cos(theta);
	y=dist*sin(theta);
	it->MROWS=(int)(fabs(y))+1;
	it->MCOLS=(int)(fabs(x))+1;
	if((x>=0)&&(y>=0))
	{
	it->MORGX=it->MROWS-1;
	it->MORGY=0;
	signx=-1;
	signy=+1;
	}	
	if((x<0)&&(y>=0))
	{
	it->MORGX=it->MROWS-1;
	it->MORGY=it->MCOLS-1;
	signx=-1;
	signy=-1;
	}	
	if((x>=0)&&(y<0))
	{
	it->MORGX=0;
	it->MORGY=0;
	signx=+1;
	signy=+1;
	}	
	if((x<0)&&(y<0))
	{
	it->MORGX=0;
	it->MORGY=it->MCOLS-1;
	signx=+1;
	signy=-1;
	}
	xinc=(int)(signx*fabs(y));	
	yinc=(int)(signy*fabs(x));
	do{
	max1=HIPL_Getpart(it);
	for(i=0;i<max1;i++)
	for(j=0;j<it->img.COLS;j++)
	{
	if((i<it->MORGX)||((max1-i)<(it->MROWS-it->MORGX))||(j<it->MORGY)||((it->img.COLS-j)<(it->MCOLS-it->MORGY)))
	continue;
	else
	{
	GLCM[it->iarr[i+xinc][j+yinc]][it->iarr[i][j]]++;
	sum++;
	}
	}
	}while(it->P.nleft);
	HIPL_Refresh(it,0);
	it->MROWS=0;
	tflag=0;
	theta=0;
	tt=0;
	for(i=0;i<=255;i++)
	{
		for(j=0;j<=255;j++)
		{
			cflag=(i-j);
			t1=(double)GLCM[i][j]/(double)sum;
			tt=tt+((double)cflag*(double)cflag*t1);
			tflag=tflag+t1*t1;
			if(GLCM[i][j]!=0)
			{
				theta=theta-t1*log(t1);
			}
		}
	}
	if(tt!=0)
	{
		t1=tt;
		t1=1/t1;
	}
	else
		t1=0;
	t1=1-t1;
	IDO->inertia=(float)tt;
	IDO->inertia=1.0-(1.0/(1.0+IDO->inertia));
	IDO->uniformity=(float)tflag;
	IDO->entropy=(float)theta;
	IDO->entropy=1.0-(1.0/(1.0+IDO->entropy));
	i=HIPL_FindHistogram(it,IDO->hist);
	i=HIPL_ImgData(it,IDO->hist,IDO);
	IDO->roughness=(1.0-1.0/(1.0+(IDO->dev)*(IDO->dev)));
//	IDO->roughness=(float) t1;
	return(0);
}
